VERSION 5.00
Begin VB.UserControl DoubleLine 
   Alignable       =   -1  'True
   ClientHeight    =   345
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2025
   ScaleHeight     =   23
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   135
   ToolboxBitmap   =   "DoubleLine.ctx":0000
   Begin VB.Line Line1 
      BorderColor     =   &H00A0A0A0&
      X1              =   0
      X2              =   129
      Y1              =   0
      Y2              =   6
   End
   Begin VB.Line Line2 
      BorderColor     =   &H00D0D0D0&
      X1              =   3
      X2              =   129
      Y1              =   6
      Y2              =   18
   End
End
Attribute VB_Name = "DoubleLine"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

    Public Enum EnumLineStyle
    Horizontal = 0
    Vertical = 1
    End Enum

'Default Property Values:
Const m_def_LineStyle = 0
'Property Variables:
Dim m_LineStyle As EnumLineStyle
'Event Declarations:
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseDown
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseMove
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseUp
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."
Event Resize() 'MappingInfo=UserControl,UserControl,-1,Resize
Attribute Resize.VB_Description = "Occurs when a form is first displayed or the size of an object changes."

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BorderStyle
Public Property Get BorderStyle() As Integer
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
    BorderStyle = UserControl.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As Integer)
    UserControl.BorderStyle() = New_BorderStyle
    PropertyChanged "BorderStyle"
End Property

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,MouseIcon
Public Property Get MouseIcon() As Picture
Attribute MouseIcon.VB_Description = "Sets a custom mouse icon."
    Set MouseIcon = UserControl.MouseIcon
End Property

Public Property Set MouseIcon(ByVal New_MouseIcon As Picture)
    Set UserControl.MouseIcon = New_MouseIcon
    PropertyChanged "MouseIcon"
End Property

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,MousePointer
Public Property Get MousePointer() As Integer
Attribute MousePointer.VB_Description = "Returns/sets the type of mouse pointer displayed when over part of an object."
    MousePointer = UserControl.MousePointer
End Property

Public Property Let MousePointer(ByVal New_MousePointer As Integer)
    UserControl.MousePointer() = New_MousePointer
    PropertyChanged "MousePointer"
End Property

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

Private Sub UserControl_Resize()

    With UserControl
    .Line1.X1 = 0
    .Line1.Y1 = 0
    
        If m_LineStyle = Horizontal Then
        .Line1.Y2 = 0
        .Line1.X2 = .ScaleWidth
        .Line2.X1 = 0
        .Line2.X2 = .ScaleWidth
        .Line2.Y1 = 1
        .Line2.Y2 = 1
        .Height = 30

        Else
        .Line1.Y2 = .ScaleHeight
        .Line1.X2 = 0
        .Line2.X1 = 1
        .Line2.X2 = 1
        .Line2.Y1 = 0
        .Line2.Y2 = .ScaleHeight
        .Width = 30

        End If

    End With

    RaiseEvent Resize
    
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=Line1,Line1,-1,BorderColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the color of an object's border."
    BackColor = Line1.BorderColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    Line1.BorderColor() = New_BackColor
    PropertyChanged "BackColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=Line2,Line2,-1,BorderColor
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the color of an object's border."
    ForeColor = Line2.BorderColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    Line2.BorderColor() = New_ForeColor
    PropertyChanged "ForeColor"
End Property

Public Property Get LineStyle() As EnumLineStyle
    LineStyle = m_LineStyle
End Property

Public Property Let LineStyle(ByVal New_LineStyle As EnumLineStyle)
    m_LineStyle = New_LineStyle
    UserControl_Resize
    PropertyChanged "LineStyle"
End Property

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_LineStyle = m_def_LineStyle
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    UserControl.BorderStyle = PropBag.ReadProperty("BorderStyle", 0)
    Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
    UserControl.MousePointer = PropBag.ReadProperty("MousePointer", 0)
    Line1.BorderColor = PropBag.ReadProperty("BackColor", 10526880)
    Line2.BorderColor = PropBag.ReadProperty("ForeColor", 13684944)
    m_LineStyle = PropBag.ReadProperty("LineStyle", m_def_LineStyle)
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("BorderStyle", UserControl.BorderStyle, 0)
    Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
    Call PropBag.WriteProperty("MousePointer", UserControl.MousePointer, 0)
    Call PropBag.WriteProperty("BackColor", Line1.BorderColor, 10526880)
    Call PropBag.WriteProperty("ForeColor", Line2.BorderColor, 13684944)
    Call PropBag.WriteProperty("LineStyle", m_LineStyle, m_def_LineStyle)
End Sub

