Attribute VB_Name = "LibAppInstances"
Option Explicit
Function GetExceptionText(ByVal ExceptionCode As Long) As String
Dim strExceptionString As String

 Select Case ExceptionCode
 Case EXCEPTION_ACCESS_VIOLATION: strExceptionString = "Access Violation"
 Case EXCEPTION_DATATYPE_MISALIGNMENT: strExceptionString = "Data Type Misalignment"
 Case EXCEPTION_BREAKPOINT: strExceptionString = "Breakpoint"
 Case EXCEPTION_SINGLE_STEP: strExceptionString = "Single Step"
 Case EXCEPTION_ARRAY_BOUNDS_EXCEEDED: strExceptionString = "Array Bounds Exceeded"
 Case EXCEPTION_FLT_DENORMAL_OPERAND: strExceptionString = "Float Denormal Operand"
 Case EXCEPTION_FLT_DIVIDE_BY_ZERO: strExceptionString = "Divide By Zero"
 Case EXCEPTION_FLT_INEXACT_RESULT: strExceptionString = "Floating Point Inexact Result"
 Case EXCEPTION_FLT_INVALID_OPERATION: strExceptionString = "Invalid Operation"
 Case EXCEPTION_FLT_OVERFLOW: strExceptionString = "Float Overflow"
 Case EXCEPTION_FLT_STACK_CHECK: strExceptionString = "Float Stack Check"
 Case EXCEPTION_FLT_UNDERFLOW: strExceptionString = "Float Underflow"
 Case EXCEPTION_INT_DIVIDE_BY_ZERO: strExceptionString = "Integer Divide By Zero"
 Case EXCEPTION_INT_OVERFLOW: strExceptionString = "Integer Overflow"
 Case EXCEPTION_PRIVILEGED_INSTRUCTION: strExceptionString = "Privileged Instruction"
 Case EXCEPTION_IN_PAGE_ERROR: strExceptionString = "In Page Error"
 Case EXCEPTION_ILLEGAL_INSTRUCTION: strExceptionString = "Illegal Instruction"
 Case EXCEPTION_NONCONTINUABLE_EXCEPTION: strExceptionString = "Non Continuable Exception"
 Case EXCEPTION_STACK_OVERFLOW: strExceptionString = "Stack Overflow"
 Case EXCEPTION_INVALID_DISPOSITION: strExceptionString = "Invalid Disposition"
 Case EXCEPTION_GUARD_PAGE_VIOLATION: strExceptionString = "Guard Page Violation"
 Case EXCEPTION_INVALID_HANDLE: strExceptionString = "Invalid Handle"
 Case EXCEPTION_CONTROL_C_EXIT: strExceptionString = "Control-C Exit"
 Case Else: strExceptionString = "Unknown (&H" & Right("00000000" & Hex(ExceptionCode), 8) & ")"
 End Select

GetExceptionText = strExceptionString

End Function
Function ExceptionCatcher(ByRef ExceptionPtrs As EXCEPTION_POINTERS) As Long
' This function will be called when an unhandled exception occurs. It raises an error so that it can be trapped with an ON ERROR statement in the procedure that caused the exception.

Dim Rec As EXCEPTION_RECORD
Dim strException As String

Rec = ExceptionPtrs.pExceptionRecord: 'Get the current exception record.

    Do Until Rec.pExceptionRecord = 0: 'If Rec.pExceptionRecord is not zero, then it is a nested exception and Rec.pExceptionRecord points to another EXCEPTION_RECORD structure. Follow the pointers back to the original exception.
    CopyExceptionRecord Rec, Rec.pExceptionRecord, Len(Rec): 'A friendly declaration of CopyMemory.
    Loop

strException = GetExceptionText(Rec.ExceptionCode) 'Translate the exception code into a user-friendly string.
Err.Raise 10000, "ExceptionCatcher", strException 'Raise an error to return control to the calling procedure.

End Function

Function AppID() As String
AppID = App.ProductName & " verso " & App.Major & "." & Format$(App.Minor, "00") & IIf(App.Revision <> 0, "." & Format$(App.Revision, "0000"), "")
End Function


Sub SetAppPriority(dwPriorityClass As usrProccessPriorities)
On Error GoTo SetAppPriority_Err

Dim hProcess&
Dim ret&, pid&
pid = GetCurrentProcessId() ' get my proccess id
' get a handle to the process
hProcess = OpenProcess(PROCESS_DUP_HANDLE, True, pid)

    If hProcess = 0 Then
    Err.Raise 2, "SetAppPriority", "Unable to open the source process"
    Exit Sub
    End If

' change the priority
ret = SetPriorityClass(hProcess, dwPriorityClass)
' Close the source process handle
Call CloseHandle(hProcess)

    If ret = 0 Then
    Err.Raise 4, "SetAppPriority", "Unable to close source handle"
    Exit Sub
    End If

Exit Sub
SetAppPriority_Err:
ErrH , "Sub SetAppPriority"
Exit Sub

End Sub
Function AppRegistered(ByVal N As String) As Boolean
On Error GoTo AppRegistered_Err

AppRegistered = GetSetting("VBApps", "Registered Apps", N, "No") <> "No"

Exit Function
AppRegistered_Err:
ErrH App.ProductName & " code library", "Function AppRegistered"
Exit Function

End Function
Function CloneInstance() As Boolean
On Error GoTo CloneInstance_Err

    If App.PrevInstance Then CloneInstance = True

Exit Function
CloneInstance_Err:
ErrH App.ProductName & " code library", "Function CloneInstance"
Exit Function

End Function
Sub ExecApp(cmdline$)
On Error GoTo ExecApp_Err

Dim proc As Process_Information
Dim start As StartupInfo
Dim ret&

' Initialize the STARTUPINFO structure:
start.cb = Len(start)

' Start the shelled application:
ret& = CreateProcessA(0&, cmdline$, 0&, 0&, 1&, NORMAL_PRIORITY_CLASS, 0&, 0&, start, proc)

' Wait for the shelled application to finish:
ret& = WaitForSingleObject(proc.hProcess, INFINITE)
ret& = CloseHandle(proc.hProcess)

Exit Sub
ExecApp_Err:
ErrH App.ProductName & " code library", "Sub ExecApp"
Exit Sub

End Sub
Sub RegisterApp(ByVal N As String)
On Error GoTo RegisterApp_Err

SaveSetting "VBApps", "Registered Apps", N, "Fully Installed"

Exit Sub
RegisterApp_Err:
ErrH App.ProductName & " code library", "Sub RegisterApp"
Exit Sub

End Sub
