Attribute VB_Name = "LibCriptography"
Option Explicit
Function Crypt(ByVal Word As String, Optional uSeed As Long) As String
On Error GoTo Crypt_Err

Dim NewWord As String, Counter As Integer, RFactor As Integer

NewWord = ""

    If uSeed = 0 Then uSeed = -1

    For Counter = 1 To Len(Word)
    RFactor = Int(Rnd(uSeed * Counter) * 10 - 5)
    NewWord = NewWord + Chr$(RFactor + Asc(Mid$(Word, Counter, 1)))
    Next Counter

Crypt$ = NewWord

Exit Function
Crypt_Err:
ErrH , "Function Crypt"
Exit Function

End Function
Function DeCrypt(ByVal Word As String, Optional uSeed As Long) As String
On Error GoTo DeCrypt_Err1

Dim NewWord  As String, Counter As Integer, RFactor As Integer

NewWord = ""
    
    If uSeed = 0 Then uSeed = -1
    
    For Counter = 1 To Len(Word)
    RFactor = Int(Rnd(uSeed * Counter) * 10 - 5)
    NewWord = NewWord + Chr$(Asc(Mid$(Word, Counter, 1)) - RFactor)
    Next Counter

DeCrypt = NewWord

Exit Function
DeCrypt_Err1:
ErrH App.ProductName & " code library", "Function DeCrypt$"
Exit Function

End Function
Function EncryptText(ByVal Source As String) As String
On Error GoTo EncryptText_Err

' Performs simple encryption of text values, and reverses the order of the
' encrypted characters in the string.
'
Dim Dest As String, i As Integer, L As Integer

Dest = Source
L = Len(Source) + 1

    For i = 1 To Len(Dest)
    Mid$(Dest, i, 1) = Chr$((270 + i - Asc(Mid$(Source, L - i, 1))) And 255)
    Next i
    
EncryptText = Dest

Exit Function
EncryptText_Err:
ErrH App.ProductName & " code library", "Function EncryptText"
Exit Function

End Function
Function DecryptText(ByVal Source As String) As String
On Error GoTo DecryptText_Err

'
' Undoes EncryptText encryption using the Decrypt function
'
Dim Dest As String, i As Integer, L As Integer
  Dest = Source
  L = Len(Source) + 1
  For i = 1 To Len(Dest)
    Mid$(Dest, L - i, 1) = Chr$((270 + i - Asc(Mid$(Source, i, 1))) And 255)
  Next i
  DecryptText = Dest

Exit Function
DecryptText_Err:
ErrH App.ProductName & " code library", "Function DecryptText"
Exit Function

End Function
Function EAN_13_CheckDigit(ByVal number As String) As String
On Error GoTo EAN_13_CheckDigit_Err

'
' Calculates check digit for 12-digit EAN-13 codes.
' Codes of any other length get back an 'x'.
'
Dim Digit1 As Integer, Digit2 As Integer, i As Integer
    If Len(number) <> 12 Then
    EAN_13_CheckDigit = "x"    ' Dummy value - they're misusing the function
    
    Else
    Digit1 = 0
    Digit2 = 0
    For i = 1 To 11 Step 2
    Digit1 = Digit1 + Val(Mid$(number, i, 1))
    Next i
    
        For i = 2 To 12 Step 2
        Digit2 = Digit2 + Val(Mid$(number, i, 1))
        Next i
        
    EAN_13_CheckDigit = Chr$(((220 - (Digit2 * 3 + Digit1)) Mod 10) + 48)
    
    End If
    

Exit Function
EAN_13_CheckDigit_Err:
ErrH App.ProductName & " code library", "Function EAN_13_CheckDigit"
Exit Function

End Function
Function Encrypt(Source As Variant) As Variant
On Error GoTo Encrypt_Err

'
' Encrypts different DATAtypes using the EncryptText function,
' and converting the various number DATAtypes to and from binary strings.
'
' Note: Empty, Null, and Date types remain unchanged
'       Empty and Null because they are non-DATA
'
'       Dates are handled separately because the DATA type can't handle
'       the encrypted values returned by EncryptText
'
Dim T As TypesAsType, S As TypesAsString

    Select Case VarType(Source)
    
    Case 0, 1     ' can't encrypt Empty or Null
    Encrypt = Source
    
    Case 2        ' Integer
    T.i = Source
    LSet S = T
    S.i = EncryptText(S.i)
    LSet T = S
    Encrypt = T.i
    
    Case 3        ' Long
    T.L = Source
    LSet S = T
    S.L = EncryptText(S.L)
    LSet T = S
    Encrypt = T.L
    
    Case 4        ' Single
    T.S = Source
    LSet S = T
    S.S = EncryptText(S.S)
    LSet T = S
    Encrypt = T.S
    
    Case 5        ' Double
    T.D = Source
    LSet S = T
    S.D = EncryptText(S.D)
    LSet T = S
    Encrypt = T.D
    
    Case 6        ' Currency
    T.c = Source
    LSet S = T
    S.c = EncryptText(S.c)
    LSet T = S
    Encrypt = T.c
    Case 7
    T.Dat = Source
    LSet S = T
    S.D1 = EncryptText(S.D1)
    LSet T = S
    Encrypt = CVDate(T.Dat)
    
    Case 8        ' Text
    Encrypt = EncryptText(Source)
    End Select

Exit Function
Encrypt_Err:
ErrH App.ProductName & " code library", "Function Encrypt"
Exit Function

End Function
Function StringCode(ByVal N As String) As String
On Error GoTo StringCode_Err

Dim Counter As Integer, M As Currency

M = 0

    For Counter = 0 To Len(N) - 1
    M = M + (Asc(Mid$(N, Counter + 1, 1)) * (Counter + 1))
    Next Counter

StringCode = Hex$(Trim(str$(M)))

Exit Function
StringCode_Err:
ErrH , "Function StringCode"
Exit Function

End Function
Function UPC_A_CheckDigit(ByVal number As String) As String
On Error GoTo UPC_A_CheckDigit_Err

'
' Calculates check digit for 11-digit UPC-A codes.
' Codes of any other length get back an 'x'.
'
Dim Digit1 As Integer, Digit2 As Integer, i As Integer
    If Len(number) <> 11 Then
    UPC_A_CheckDigit = "x"     ' Dummy value - they're misusing the function
    
    Else
    Digit1 = 0
    Digit2 = 0
    
        For i = 2 To 10 Step 2
        Digit1 = Digit1 + Val(Mid$(number, i, 1))
        Next i
        
        For i = 1 To 11 Step 2
        Digit2 = Digit2 + Val(Mid$(number, i, 1))
        Next i
    
    UPC_A_CheckDigit = Chr$(((210 - (Digit2 * 3 + Digit1)) Mod 10) + 48)
    End If

Exit Function
UPC_A_CheckDigit_Err:
ErrH App.ProductName & " code library", "Function UPC_A_CheckDigit"
Exit Function

End Function
