Attribute VB_Name = "LibGraph"
Option Explicit

Enum uFlipMode
flipVertical = 0
FlipHorizontal = 1
End Enum
Sub Paint(ObjhDC As Long, X As Long, Y As Long, CorLimite As Long, Pintura As Byte)
On Error GoTo Paint_Err

Call ExtFloodFill(ObjhDC, X, Y, CorLimite, Pintura)

Exit Sub
Paint_Err:
ErrH , "Sub Paint"
Exit Sub
End Sub
Private Sub CaptureArea(uForm As Form, Controle As Control, X As Integer, Y As Integer, largura As Integer, altura As Integer, ZoomX As Integer, ZoomY As Integer)
On Error GoTo CaptureArea_Err

Dim Tela As Long

    If Not TypeOf Controle Is PictureBox Then 'Verifica se o controle  um picturebox
    MsgBox "O Controle tem que ser PictureBox"
    Exit Sub
    End If
    
Tela = CreateDCA("DISPLAY", 0, 0, 0) 'Adquire o HDC da Tela (Screen)

Controle.AutoRedraw = True 'Muito importante par a imagem no se perder
uForm.ScaleMode = 3 'Ajusta a escala para PIXEL
Controle.Width = Int(largura * (ZoomX / 100)) 'Ajusta o objeto para caber a figura capturada
Controle.Height = Int(altura * (ZoomY / 100))
Call StretchBlt(Controle.hdc, 0, 0, Controle.Width, Controle.Height, Tela, X, Y, largura, altura, SRCCOPY) 'Chama a API
Controle.Picture = Controle.Image 'Fora a gravao definitiva da imagem no Picture

Exit Sub
CaptureArea_Err:
ErrH , "Private Sub CaptureArea"
Exit Sub
End Sub
Function FlipImage(POrigin As PictureBox, PDestiny As PictureBox, ByVal uType As uFlipMode) As Boolean
On Error GoTo FlipImage_Err

Dim px As Integer, py As Integer, retval As Integer

PDestiny.Cls

    Select Case uType
    Case FlipHorizontal
    px% = POrigin.ScaleWidth
    py% = POrigin.ScaleHeight
    retval% = StretchBlt(PDestiny.hdc, px%, 0, -px%, py%, POrigin.hdc, 0, 0, px%, py%, SRCCOPY)
    
    Case flipVertical
    px% = POrigin.ScaleWidth
    py% = POrigin.ScaleHeight
    retval% = StretchBlt(PDestiny.hdc, 0, py%, px%, -py%, POrigin.hdc, 0, 0, px%, py%, SRCCOPY)
    
    End Select

FlipImage = True

Exit Function
FlipImage_Err:
ErrH "", "Function FlipImage"
Exit Function
End Function
Function OpenEllipticForm(ByRef uForm As Form, XOrigin As Integer, YOrigin As Integer, XCenter As Integer, YCenter As Integer) As Boolean
On Error GoTo OpenEllipticForm_Err

Dim lReigon As Long, lResult As Long
lReigon = CreateEllipticRgn(XOrigin, YOrigin, XCenter, YCenter)
lResult = SetWindowRgn(uForm.hWnd, lReigon, True)
uForm.Show
OpenEllipticForm = lResult

Exit Function
OpenEllipticForm_Err:
ErrH , "Function OpenEllipticForm"
Exit Function
End Function
Function OpenPolyForm(ByRef uForm As Form, uPoints() As POINTAPI) As Boolean
Dim lReigon As Long, lResult As Long
lReigon = CreatePolygonRgn(uPoints(0), UBound(uPoints) + 1, WINDING)
lResult = SetWindowRgn(uForm.hWnd, lReigon, True)
uForm.Show
OpenPolyForm = lResult
End Function
Function OpenRoundedForm(ByRef uForm As Form, XAlias As Integer, YAlias As Integer) As Boolean
Dim lReigon As Long, lResult As Long
lReigon = CreateRoundRectRgn(0, 0, uForm.Width / Screen.TwipsPerPixelX, uForm.Height / Screen.TwipsPerPixelY, YAlias, YAlias)
lResult = SetWindowRgn(uForm.hWnd, lReigon, True)
uForm.Show
OpenRoundedForm = lResult
End Function
Public Function GetPrinterMinMargin(ByVal T As Integer) As Long
On Error GoTo GetPrinterMinMargin_Err

Select Case T
    Case MARGIN_TOP:
       GetPrinterMinMargin = GetDeviceCaps(Printer.hdc, PHYSICALOFFSETY) _
           * Printer.TwipsPerPixelY
    Case MARGIN_BOTTOM:
       GetPrinterMinMargin = _
          Printer.Height - Printer.ScaleHeight - _
          (GetDeviceCaps(Printer.hdc, PHYSICALOFFSETY) * Printer.TwipsPerPixelY)
    Case MARGIN_LEFT:
       GetPrinterMinMargin = GetDeviceCaps(Printer.hdc, PHYSICALOFFSETX) _
           * Printer.TwipsPerPixelX
       
    Case MARGIN_RIGHT:
       GetPrinterMinMargin = _
          Printer.Width - Printer.ScaleWidth - _
          GetDeviceCaps(Printer.hdc, PHYSICALOFFSETX) * Printer.TwipsPerPixelX
   
    Case Else
       ' There's an error
       GetPrinterMinMargin = -1
    End Select

Exit Function
GetPrinterMinMargin_Err:
ErrH App.ProductName & " code library", "Public Function GetPrinterMinMargin"
Exit Function
End Function
Function RotatePicture(POrigin As PictureBox, PDestiny As PictureBox, uAngle As Integer) As Boolean
On Error GoTo RotatePicture_Err

PDestiny.Cls
 Call BMPRotate(POrigin, PDestiny, (Atn(1)) / 45 * uAngle)
RotatePicture = True

Exit Function
RotatePicture_Err:
ErrH "", "Function RotatePicture"
Exit Function
End Function
Sub BMPRotate(pic1 As PictureBox, pic2 As PictureBox, ByVal theta!)
On Error GoTo BMPRotate_Err

Dim c1x As Integer, c1y As Integer
Dim c2x As Integer, c2y As Integer
Dim A As Single
Dim p1x As Integer, p1y As Integer
Dim p2x As Integer, p2y As Integer
Dim N As Integer, R As Integer
Dim pic1hDC As Integer
Dim pic2hDC As Integer
Dim c0&, c1&, c2&, c3&, xret&, T%

c1x = pic1.ScaleWidth \ 2
c1y = pic1.ScaleHeight \ 2
c2x = pic2.ScaleWidth \ 2
c2y = pic2.ScaleHeight \ 2

    If c2x < c2y Then N = c2y Else N = c2x
    
N = N - 1
pic1hDC% = pic1.hdc
pic2hDC% = pic2.hdc
For p2x = 0 To N
    
    For p2y = 0 To N
    
        If p2x = 0 Then A = (4 * Atn(1)) / 2 Else A = Atn(p2y / p2x)
        
    R = Sqr(1& * p2x * p2x + 1& * p2y * p2y)
    p1x = R * Cos(A + theta!)
    p1y = R * Sin(A + theta!)
    c0& = GetPixel(pic1hDC%, c1x + p1x, c1y + p1y)
    c1& = GetPixel(pic1hDC%, c1x - p1x, c1y - p1y)
    c2& = GetPixel(pic1hDC%, c1x + p1y, c1y - p1x)
    c3& = GetPixel(pic1hDC%, c1x - p1y, c1y + p1x)
    
        If c0& <> -1 Then xret& = SetPixel(pic2hDC%, c2x + p2x, c2y + p2y, c0&)
        If c1& <> -1 Then xret& = SetPixel(pic2hDC%, c2x - p2x, c2y - p2y, c1&)
        If c2& <> -1 Then xret& = SetPixel(pic2hDC%, c2x + p2y, c2y - p2x, c2&)
        If c3& <> -1 Then xret& = SetPixel(pic2hDC%, c2x - p2y, c2y + p2x, c3&)
        
    Next

T% = DoEvents()
Next

Exit Sub
BMPRotate_Err:
ErrH "", "Sub BMPRotate"
Exit Sub
End Sub
Public Sub ShadeForm(f As Form, Optional StartColor As Variant, Optional Fstep As Variant, Optional Cstep As Variant)
On Error GoTo ShadeForm_Err

Dim FillStep As Single  ' Not an integer because sometimes
                           ' rounding leaves a large bottom region
   Dim c As Long
   Dim FillArea As RECT
   Dim i As Integer
   Dim oldm As Integer
   Dim hBrush As Long
   Dim c2(1 To 3) As Long
   Dim cs2(1 To 3) As Long
   Dim fs As Long
   Dim cs As Integer
      
   ' Set defaults
   fs = IIf(IsMissing(Fstep), 64, CLng(Fstep))
   cs = IIf(IsMissing(Cstep), 4, CInt(Cstep))
   c = IIf(IsMissing(StartColor), vbBlue, CLng(StartColor))
   
   
   oldm = f.ScaleMode
   f.ScaleMode = vbPixels
   FillStep = f.ScaleHeight / fs
   FillArea.Left = 0
   FillArea.Right = f.ScaleWidth
   FillArea.Top = 0

   ' Break down the color and set individual
   ' color steps
   c2(1) = c And 255#
   cs2(1) = IIf(c2(1) > 0, cs, 0)
   c2(2) = (c \ 256#) And 255#
   cs2(2) = IIf(c2(2) > 0, cs, 0)
   c2(3) = (c \ 65536#) And 255#
   cs2(3) = IIf(c2(3) > 0, cs, 0)
   
   
   For i = 1 To fs
      FillArea.Bottom = FillStep * i

      hBrush = CreateSolidBrush(RGB(c2(1), c2(2), c2(3)))
      FillRect f.hdc, FillArea, hBrush
      DeleteObject hBrush
      
      ' Could do this in a loop, but it's simple
      ' and may be faster.
      c2(1) = (c2(1) - cs2(1)) And 255#
      c2(2) = (c2(2) - cs2(2)) And 255#
      c2(3) = (c2(3) - cs2(3)) And 255#
      
      FillArea.Top = FillArea.Bottom
   Next i
   
   f.ScaleMode = oldm

Exit Sub
ShadeForm_Err:
ErrH App.ProductName & " code library", "Public Sub ShadeForm"
Exit Sub
End Sub
Public Function SmallFonts() As Boolean
On Error GoTo SmallFonts_Err

Dim hdc As Long
   Dim hWnd As Long
   Dim PrevMapMode As Long
   Dim tm As TEXTMETRIC

   ' Set the default return value to small fonts
   SmallFonts = True
   
   ' Get the handle of the desktop window
   hWnd = GetDesktopWindow()

   ' Get the device context for the desktop
   hdc = GetWindowDC(hWnd)
   If hdc Then
      ' Set the mapping mode to pixels
      PrevMapMode = SetMapMode(hdc, MM_TEXT)
      
      ' Get the size of the system font
      GetTextMetrics hdc, tm

      ' Set the mapping mode back to what it was
      PrevMapMode = SetMapMode(hdc, PrevMapMode)

      ' Release the device context
      ReleaseDC hWnd, hdc
     
      ' If the system font is more than 16 pixels high,
      ' then large fonts are being used
      If tm.tmHeight > 16 Then SmallFonts = False
   End If

Exit Function
SmallFonts_Err:
ErrH App.ProductName & " code library", "Public Function SmallFonts"
Exit Function
End Function
Public Function GetNColors() As Long
On Error GoTo GetNColors_Err

Dim hSrcDC As Integer

  hSrcDC = GetDC(GetDesktopWindow())
  GetNColors = GetDeviceCaps(hSrcDC, PLANES) * 2 ^ GetDeviceCaps(hSrcDC, BITSPIXEL)
  Call ReleaseDC(GetDesktopWindow(), hSrcDC)

Exit Function
GetNColors_Err:
ErrH App.ProductName & " code library", "Public Function GetNColors"
Exit Function
End Function
Public Function RotateText(ob As Object, ByVal angle As Single) As Variant
On Error GoTo RotateText_Err

Dim T As LogFont
   Dim i As Long
   Dim v(1 To 2) As Variant
   
   If ob Is Printer Then
      T.lfHeight = ob.FontSize * -20 / Printer.TwipsPerPixelY
   Else
      T.lfHeight = ob.FontSize * -20 / Screen.TwipsPerPixelY
   End If
   
   T.lfWidth = 0
   T.lfEscapement = CLng(angle * 10#)
   T.lfOrientation = T.lfEscapement
   T.lfWeight = ob.Font.Weight
   T.lfItalic = IIf(ob.FontItalic, 255, 0)
   T.lfUnderline = IIf(ob.FontUnderline, 255, 0)
   T.lfStrikeOut = IIf(ob.FontStrikethru, 255, 0)
   T.lfCharSet = 0
   T.lfOutPrecision = 0
   T.lfClipPrecision = 0
   T.lfQuality = 0
   T.lfPitchAndFamily = 0
   T.lfFaceName = ob.FontName & Chr$(0)

   i = CreateFontIndirect(T)
      
   v(1) = SelectObject(ob.hdc, i)
   v(2) = i
   
   RotateText = v

Exit Function
RotateText_Err:
ErrH App.ProductName & " code library", "Public Function RotateText"
Exit Function
End Function
Public Sub SetTransparent(ob As Object, ByVal T As Boolean)
On Error GoTo SetTransparent_Err

Call SetBkMode(ob.hdc, IIf(T, TRANSPARENT, OPAQUE))

Exit Sub
SetTransparent_Err:
ErrH App.ProductName & " code library", "Public Sub SetTransparent"
Exit Sub
End Sub
Public Sub RestoreText(ob As Object, handles As Variant)
On Error GoTo RestoreText_Err

SelectObject ob.hdc, CLng(handles(1))
   DeleteObject CLng(handles(2))

Exit Sub
RestoreText_Err:
ErrH App.ProductName & " code library", "Public Sub RestoreText"
Exit Sub
End Sub
Sub FillFormBackGround(ByRef frmForm As Form, ByVal picPicture As PictureBox, FillStyle As EnumFillStyle)
On Error GoTo FillFormBackGround_Err

Dim iPicWidth As Long, _
iPicHeight As Long, _
lPicHwnd As Long, _
lFrmHwnd As Long, _
iCol As Integer, _
iRow As Integer, _
lRet As Long, _
lMaxHeight As Integer, _
lMaxWidth As Integer
  
    With picPicture
    .AutoSize = True ' Autosize the box to the BMP
    iPicWidth = .ScaleWidth ' Width of picture box
    iPicHeight = .ScaleHeight ' Height of picture box
    .Visible = True ' Start off invisible
    End With
   
lPicHwnd = picPicture.hdc
lFrmHwnd = frmForm.hdc
  
lMaxHeight = frmForm.ScaleHeight
lMaxWidth = frmForm.ScaleWidth
   
iPicHeight = picPicture.Height
iPicWidth = picPicture.Width
   
   Select Case FillStyle
   
    Case EnumFillStyle.Complete
    
        For iRow = 0 To lMaxHeight Step iPicHeight
        
            For iCol = 0 To lMaxWidth Step iPicWidth
            lRet = BitBlt(lFrmHwnd, iCol, iRow, iPicWidth, iPicHeight, lPicHwnd, 0, 0, SRCCOPY)
            Next
            
        Next
    
    Case EnumFillStyle.LeftSide
    
        For iRow = 0 To lMaxHeight Step iPicHeight
        lRet = BitBlt(lFrmHwnd, iCol, iRow, iPicWidth, iPicHeight, lPicHwnd, 0, 0, SRCCOPY)
        Next
    
    Case EnumFillStyle.AcrossTop
    
        For iCol = 0 To lMaxWidth Step iPicWidth
        lRet = BitBlt(lFrmHwnd, iCol, iRow, iPicWidth, iPicHeight, lPicHwnd, 0, 0, SRCCOPY)
        Next
    
    End Select
    
frmForm.Refresh

Exit Sub
FillFormBackGround_Err:
ErrH App.ProductName & " code library", "Sub FillFormBackGround"
Exit Sub
End Sub
Function LoadAnimatedCursor(Frm As Form, FName As String) As Long
On Error GoTo LoadAnimatedCursor_Err

Cursor = LoadCursorFromFile(CurDir$ & "\" & FName)
Frm.MousePointer = 5
Cursor2 = GetCursor
HoldCursor = CopyIcon(Cursor2)
LoadAnimatedCursor = SetSystemCursor(Cursor, OCR_SIZENESW)

Exit Function
LoadAnimatedCursor_Err:
ErrH App.ProductName & " code library", "Function LoadAnimatedCursor"
Exit Function
End Function
Function RestoreCursor(Frm As Form) As Long
On Error GoTo RestoreCursor_Err

RestoreCursor = SetSystemCursor(HoldCursor, OCR_SIZENESW) ' Restore the cursor_
'to the previous copy.

Frm.MousePointer = 0 ' Return the form mouse pointer to default

DeleteObject Cursor
DeleteObject Cursor2
DeleteObject HoldCursor
' Be sure to clean up after yourself and get rid of any unused cursor handles

Exit Function
RestoreCursor_Err:
ErrH App.ProductName & " code library", "Function RestoreCursor"
Exit Function
End Function
Sub RoText(ByVal X_Place As Object, X_Text As String, X_Angle As Integer, Optional X_Color As Long)
On Error GoTo RoText_Error

X_Place.AutoRedraw = True

Dim I_Font As LogFont, PrevFont As Long, hFont As Long, Ret As Long, FontSize As Integer, OldColor As Long

    If Not IsMissing(X_Color) Then
    OldColor = X_Place.ForeColor
    X_Place.ForeColor = X_Color
    End If

FontSize = X_Place.Font.Size

I_Font.lfEscapement = X_Angle * 10
I_Font.lfFaceName = X_Place.Font.name & Chr$(0)
I_Font.lfHeight = (FontSize * -20) / Screen.TwipsPerPixelY
I_Font.lfItalic = X_Place.Font.Italic
I_Font.lfCharSet = X_Place.Font.Charset
I_Font.lfStrikeOut = X_Place.Font.Strikethrough
I_Font.lfUnderline = X_Place.Font.Underline
'I_Font.lfClipPrecision =
'I_Font.lfOrientation =
'I_Font.lfEscapement =
'I_Font.lfOutPrecision =
'I_Font.lfQuality =
'I_Font.lfPitchAndFamily =
    
hFont = CreateFontIndirect(I_Font)

PrevFont = SelectObject(X_Place.hdc, hFont)
X_Place.Print X_Text

' Clean up by restoring original font.

Ret = SelectObject(X_Place.hdc, PrevFont)
Ret = DeleteObject(hFont)

    If Not IsMissing(X_Color) Then X_Place.ForeColor = OldColor

Exit Sub

RoText_Error:
ErrH App.ProductName & " code library", "RoText"
Exit Sub
End Sub
Function CreateBitmapPicture(ByVal hBmp As Long, ByVal hPal As Long) As Picture
On Error GoTo CreateBitmapPicture_Error
'___
Dim R As Long
Dim Pic As PicBmp ' IPicture requires a reference to "Standard OLE Types"
Dim IPic As IPicture
Dim IID_IDispatch As GUID ' Fill in with IDispatch Interface ID

    With IID_IDispatch
    .DATA1 = &H20400
    .DATA4(0) = &HC0
    .DATA4(7) = &H46
    End With ' Fill Pic with necessary parts

    With Pic
    .Size = Len(Pic) ' Length of structure
    .Type = vbPicTypeBitmap ' Type of Picture (bitmap)
    .hBmp = hBmp ' Handle to bitmap
    .hPal = hPal ' andle to palette (may be null)
    End With ' Create Picture object
    
R = OleCreatePictureIndirect(Pic, IID_IDispatch, 1, IPic) ' Return the new Picture object
Set CreateBitmapPicture = IPic

Exit Function
'___
CreateBitmapPicture_Error:
ErrH App.ProductName & " code library", "Function CreateBitmapPicture (Public)"
Exit Function
End Function
Sub DrawHeader(ByRef FrmTarget As Form, Optional Kind As Byte)
On Error GoTo DrawHeader_Err

Dim Counter As Integer, CWidth As Integer, Rx As Integer, _
Gx As Integer, Bx As Integer, YPlace As Integer, _
GrpDisp As Single, DivParm As Byte

DivParm = 20 'Number of graphic block divisions

    Select Case Kind
    Case DH_Normal
    Rx = 0: Gx = &H80: Bx = &H80
    
    Case DH_Warning
    Rx = &HFF: Gx = &H40: Bx = &H0
    
    Case DH_Ok
    Rx = &H80: Gx = &HFF: Bx = &H80
    
    End Select

YPlace = IIf(Mid$(FrmTarget.Tag, 1, 1) = "B", 33, 22)

CWidth = FrmTarget.ScaleWidth - 7

    If FrmTarget.BorderStyle = 0 Then
    
    GrpDisp = CWidth / (DivParm + 1)
    
        For Counter = 0 To DivParm
        FrmTarget.Line ((Counter * GrpDisp) + 3, 3)-((Counter * GrpDisp) + 2 + GrpDisp, YPlace), RGB(Rx * (Counter / DivParm), Gx * (Counter / DivParm), Bx * (Counter / DivParm)), BF
        Next Counter
        
    End If

    DrawCaption FrmTarget
    
FrmTarget.Font.name = "Tahoma"
FrmTarget.Font.Bold = True
FrmTarget.Font.Italic = False
FrmTarget.Font.Size = 8
FrmTarget.Font.Strikethrough = False
FrmTarget.FontTransparent = True
FrmTarget.ForeColor = &H0

FrmTarget.Line (3, YPlace + 1)-(FrmTarget.ScaleWidth - 3, YPlace + 1), &H808080
FrmTarget.Line (3, YPlace + 2)-(FrmTarget.ScaleWidth - 3, YPlace + 2), &HFFFFFF

Exit Sub
DrawHeader_Err:
ErrH App.ProductName & " code library", "Sub DrawHeader"
Exit Sub
End Sub
Sub DrawCaption(ByRef FrmTarget As Form)
On Error GoTo DrawCaption_Err

    If Not IsNull(FrmTarget.Caption) Then
    
    FrmTarget.CurrentX = 8
    FrmTarget.CurrentY = 5
    FrmTarget.Font.name = "Tahoma"
    FrmTarget.Font.Size = IIf(FrmTarget.Tag = "B", 14, 8)
    FrmTarget.Font.Bold = True
    RoText FrmTarget, FrmTarget.Caption, 0, &HFFFFFF
    
    End If

Exit Sub
DrawCaption_Err:
ErrH App.ProductName & " code library", "Sub DrawCaption"
Exit Sub
End Sub
Sub DrawBorders(FrmTarget As Form, Optional FooterMode As EDB = DBNoFooter)
On Error GoTo DrawBorders_Err

Dim YPlace As Integer, uScale

    If FrmTarget.ScaleMode = 1 Then uScale = 15 Else uScale = 1

YPlace = IIf(Mid$(FrmTarget.Tag, 1, 1) = "B", 26 * uScale, 16 * uScale)

FrmTarget.AutoRedraw = True
FrmTarget.Line (1 * uScale, 1 * uScale)-((FrmTarget.ScaleWidth - 1 * uScale), 1 * uScale), &HFFFFFF
FrmTarget.Line (1 * uScale, 1 * uScale)-(1 * uScale, (FrmTarget.ScaleHeight - 1)), &HFFFFFF

FrmTarget.Line (FrmTarget.ScaleWidth - 1 * uScale, 1 * uScale)-(FrmTarget.ScaleWidth - 1 * uScale, FrmTarget.ScaleHeight - 1 * uScale), &H0
FrmTarget.Line (1 * uScale, FrmTarget.ScaleHeight - 1 * uScale)-(FrmTarget.ScaleWidth, FrmTarget.ScaleHeight - 1 * uScale), &H0

FrmTarget.Line (FrmTarget.ScaleWidth - 2 * uScale, 2 * uScale)-(FrmTarget.ScaleWidth - 2 * uScale, FrmTarget.ScaleHeight - 2 * uScale), &H808080
FrmTarget.Line (2 * uScale, FrmTarget.ScaleHeight - 2 * uScale)-(FrmTarget.ScaleWidth - 1 * uScale, FrmTarget.ScaleHeight - 2 * uScale), &H808080

    If FooterMode <> DBNoFooter Then
    FrmTarget.Line (3 * uScale, FrmTarget.ScaleHeight - 24 * uScale)-(FrmTarget.ScaleWidth - 3 * uScale, FrmTarget.ScaleHeight - 24 * uScale), &H808080
    FrmTarget.Line (3 * uScale, FrmTarget.ScaleHeight - 23 * uScale)-(FrmTarget.ScaleWidth - 3 * uScale, FrmTarget.ScaleHeight - 23 * uScale), &HFFFFFF
    End If
        
Exit Sub
DrawBorders_Err:
ErrH App.ProductName & " code library", "Sub DrawBorders"
Exit Sub
End Sub
Public Sub HideMouse()
On Error GoTo HideMouse_Err

Dim Result As Integer
   
   Do
      lShowCursor = lShowCursor - 1
      Result = ShowCursor(False)
   Loop Until Result < 0
   

Exit Sub
HideMouse_Err:
ErrH App.ProductName & " code library", "Public Sub HideMouse"
Exit Sub

End Sub
Public Sub RestoreMouse()
On Error GoTo RestoreMouse_Err

If lShowCursor > 0 Then
      Do While lShowCursor <> 0
         ShowCursor (False)
         lShowCursor = lShowCursor - 1
      Loop
   ElseIf lShowCursor < 0 Then
      Do While lShowCursor <> 0
         ShowCursor (True)
         lShowCursor = lShowCursor + 1
      Loop
   End If

Exit Sub
RestoreMouse_Err:
ErrH App.ProductName & " code library", "Public Sub RestoreMouse"
Exit Sub

End Sub
Public Sub ShowMouse()
On Error GoTo ShowMouse_Err

Dim Result
   
   Do
      lShowCursor = lShowCursor - 1
      Result = ShowCursor(True)
   Loop Until Result >= 0

Exit Sub
ShowMouse_Err:
ErrH App.ProductName & " code library", "Public Sub ShowMouse"
Exit Sub

End Sub
Sub FadeForm(frmIn As Form, fadeStyle As Integer)
'fadeStyle = 0 produces diagonal gradient
'fadeStyle = 1 produces vertical gradient
'fadeStyle = 2 produces horizontal gradient
'any other value produces solid medium-blue background
Static ColorBits As Long
Static RgnCnt As Integer

Dim NbrPlanes As Long
Dim BitsPerPixel As Long
Dim AreaHeight As Long
Dim AreaWidth As Long
Dim BlueLevel As Long
Dim prevScaleMode As Integer

Dim IntervalY As Long
Dim IntervalX As Long

Dim i As Integer
Dim R As Long
Dim ColorVal As Long

Dim FillArea As RECT
Dim hBrush As Long

'init code - performed only on the
'first pass through this routine.
If ColorBits = 0 Then

'determine number of color bits supported.
BitsPerPixel = GetDeviceCaps(frmIn.hdc, BITSPIXEL)
NbrPlanes = GetDeviceCaps(frmIn.hdc, PLANES)
ColorBits = (BitsPerPixel * NbrPlanes)

'Calculate the number of regions that the
'screen will be divided into. This is optimized
'for the current display's color depth.  Why
'waste time rendering 256 shades if you can
'only discern 32 or 64 of them?
Select Case ColorBits
Case 32:   RgnCnt = 256   '16M colors:  8 bits for blue
Case 24:   RgnCnt = 256   '16M colors:  8 bits for blue
Case 16:   RgnCnt = 256   '64K colors:  5 bits for blue
Case 15:   RgnCnt = 32    '32K colors:  5 bits for blue
Case 8:    RgnCnt = 64    '256 colors:  64 dithered blues
Case 4:    RgnCnt = 64    '16 colors :  64 dithered blues
Case Else: ColorBits = 4
RgnCnt = 64    '16 colors assumed: 64 dithered blues
End Select

End If

'if solid then set and bail out
If fadeStyle = 3 Then
frmIn.BackColor = &H7F0000       ' med blue
Exit Sub
End If

'save the current scalemode
'and set to pixel
prevScaleMode = frmIn.ScaleMode
frmIn.ScaleMode = 3
AreaHeight = frmIn.ScaleHeight

'calculate sizes
AreaWidth = frmIn.ScaleWidth
frmIn.ScaleMode = prevScaleMode

'reset to saved value
ColorVal = 256 / RgnCnt

'color diff between regions
IntervalY = AreaHeight / RgnCnt

'# vert pixels per region
IntervalX = AreaWidth / RgnCnt

'# horz pixels per region
'fill the client area from bottom/right
'to top/left except for top/left region
FillArea.Left = 0
FillArea.Top = 0
FillArea.Right = AreaWidth
FillArea.Bottom = AreaHeight
BlueLevel = 0

    For i = 0 To RgnCnt - 1
    
    'create a brush of the appropriate blue colour
    hBrush = CreateSolidBrush(RGB(0, 0, BlueLevel))
    
        If fadeStyle = 0 Then
        'diagonal gradient
        FillArea.Top = FillArea.Bottom - IntervalY
        FillArea.Left = 0
        R = FillRect(frmIn.hdc, FillArea, hBrush)
        
        FillArea.Top = 0
        FillArea.Left = FillArea.Right - IntervalX
        R = FillRect(frmIn.hdc, FillArea, hBrush)
        
        FillArea.Bottom = FillArea.Bottom - IntervalY
        FillArea.Right = FillArea.Right - IntervalX
        
        ElseIf fadeStyle = 1 Then
        'horizontal gradient
        FillArea.Top = FillArea.Bottom - IntervalY
        R = FillRect(frmIn.hdc, FillArea, hBrush)
        FillArea.Bottom = FillArea.Bottom - IntervalY
        
        Else
        'vertical gradient
        FillArea.Left = FillArea.Right - IntervalX
        R = FillRect(frmIn.hdc, FillArea, hBrush)
        FillArea.Right = FillArea.Right - IntervalX
        
        End If
        
    'done with the brush, so delete
    R = DeleteObject(hBrush)
    
    'increment the value by the appropriate
    'steps for the display colour depth
    BlueLevel = BlueLevel + ColorVal
    
    Next

'Fill any the remaining top/left holes of the
'client area with solid blue
FillArea.Top = 0
FillArea.Left = 0

hBrush = CreateSolidBrush(RGB(0, 0, 255))
R = FillRect(frmIn.hdc, FillArea, hBrush)
R = DeleteObject(hBrush)

End Sub
