Attribute VB_Name = "LibHTTP"
Option Explicit

    Public Type HTMLResult
    Status As Long
    HTTPVersion As Single
    Date As Date
    Date_Expire As Date
    Date_Modified As Date
    ServerType  As String
    Location As String
    Content_Type As String
    Content_Location As String
    Content_Length As Currency
    Accept_Ranges As String
    ETag As String
    Cookies As String
    Contents As String
    Cache_Control As String
    OnDisc As Boolean
    TempFile As String
    End Type
    
    Public Type LinkDataBlock
    Protocol As String
    server As String
    Path As String
    File As String
    End Type

    Public Type uGetInfo
    uSite As String
    uPage As String
    uCookie As String
    uPost As String
    Comments As String
    uOrigin As String
    uProxyAddress As String
    uProxyPort As Long
    uUseRetry As Byte
    uTimeOut As Byte
    uSilent As Boolean
    uSaveToDisk As Boolean
    uResults As String
    uRun As Boolean
    End Type

Global uFileInfo As uGetInfo
Function GetHTTP(uPlace As String) As String
Dim uTmp As LinkDataBlock, uTmpTxt As String, uHTML As HTMLResult
uTmp = BreakHTTPRequestData(uPlace)

uTmpTxt = GetHTTPRes(uTmp.server, uTmp.Path & IIf(uTmp.File & uTmp.Path <> "", "/", "") & uTmp.File, , , , , , , True, 20, True)
uHTML = ProccessHTTPRes(uTmpTxt, uTmpTxt)

Unload frmHTTP

    If Not uHTML.Status = 404 Then
    GetHTTP = Trim(uHTML.Contents)
    End If

End Function
Public Function GetHTTPRes(ByVal uSite As String, uPage As String, Optional uCookie As String, Optional uPost As String, Optional Comments As String, Optional uOrigin As String, Optional uProxyAddress As String, Optional uProxyPort As Long = 80, Optional uUseRetry As Byte = False, Optional uTimeOut As Byte = 10, Optional uSilent As Boolean = False, Optional uSaveToDisk As Boolean = False) As String

uFileInfo.uSite = uSite
uFileInfo.uPage = uPage
uFileInfo.uCookie = uCookie
uFileInfo.uPost = uPost
uFileInfo.Comments = Comments
uFileInfo.uOrigin = uOrigin
uFileInfo.uProxyAddress = uProxyAddress
uFileInfo.uProxyPort = uProxyPort
uFileInfo.uUseRetry = uUseRetry
uFileInfo.uTimeOut = uTimeOut
uFileInfo.uSilent = uSilent
uFileInfo.uSaveToDisk = uSaveToDisk
uFileInfo.uRun = False

uFileInfo.uResults = ""

GetHTTPRes = frmHTTP.Run
Unload frmHTTP

'GetHTTPRes = uFileInfo.uResults

End Function


Function BreakHTTPRequestData(ByVal uOriginalLink As String) As LinkDataBlock
Dim uTemp As String

uTemp = Trim(ClearSpaces(uOriginalLink))

    If uTemp = "" Then Exit Function
    
'1: Teste por Especificao de protocolo.

    If InStr(uTemp, "//") <> 0 Then
    BreakHTTPRequestData.Protocol = Left$(uTemp, InStr(uTemp, "//") - 2)
    uTemp = Right$(uTemp, Len(uTemp) - (InStr(uTemp, "//") + 1))
    End If
    
'Teste por especificao de servidor.

    If uTemp <> "" And InStr(uTemp, "/") <> 0 Then
    BreakHTTPRequestData.server = Left$(uTemp, InStr(uTemp, "/") - 1)
    uTemp = Right$(uTemp, Len(uTemp) - InStr(uTemp, "/"))
    
    uTemp = StrReverse(uTemp)
    
        If uTemp <> "" And InStr(uTemp, "/") <> 0 Then
        BreakHTTPRequestData.File = StrReverse(Left$(uTemp, InStr(uTemp, "/") - 1))
        BreakHTTPRequestData.Path = StrReverse(Right$(uTemp, Len(uTemp) - InStr(uTemp, "/")))
        
        Else
        BreakHTTPRequestData.Path = StrReverse(uTemp)
        
            If InStr(BreakHTTPRequestData.Path, ".") <> 0 Then
            BreakHTTPRequestData.File = BreakHTTPRequestData.Path
            BreakHTTPRequestData.Path = ""
            End If
        
        End If
    
    Else
    BreakHTTPRequestData.server = uTemp
    
    End If

End Function


Sub ClearHTTPEntry(ByVal uOriginal, Optional uJustTags As String, Optional uJustImportantTags As String)
On Error GoTo ClearHTTPEntry_Err

Dim Mark As Long, Pick1 As Long, Pick2 As Long
Dim uTmp As String
Dim uStr As String

uTmp = uOriginal
uJustImportantTags = ""
uJustTags = ""
Mark = 1

    Do While Len(uTmp) > 0
    Pick1 = InStr(Mark, uTmp, ">")
    Pick2 = InStr(Mark, uTmp, "<")
    
        If (Pick2 < Pick1) Then  '1 caso: Sem marcador final anterior.
        uStr = Mid$(uTmp, Pick2, (Pick1 - Pick2) + 1)
        
            If InStr(UCase(uStr), "NAME") <> 0 Or InStr(UCase(uStr), "LOCATION") <> 0 Then
            Add uJustImportantTags, uStr & vbCrLf
            End If
            
        Add uJustTags, uStr & vbCrLf
            
        uTmp = Right$(uTmp, Len(uTmp) - Pick1)
        
        Else
        uTmp = ""
        
        End If
    
    Loop

Exit Sub
ClearHTTPEntry_Err:
ErrH , "Sub ClearHTTPEntry"
Exit Sub

End Sub
Private Function GetTag(ByRef OriginText As String, uTag As String) As String
Dim uTmpStr As String

OriginText = StripLine(OriginText, , uTmpStr, uTag)

    If uTmpStr <> "" Then
    uTmpStr = Trim(ReplaceStr(uTmpStr, uTag, "", vbTextCompare))
    End If

GetTag = uTmpStr

End Function
Function HTMLMegaClear(ByVal uN As String) As String

uN = Replace(uN, Chr$(13), " ", , , vbBinaryCompare)
uN = Replace(uN, Chr$(10), " ", , , vbBinaryCompare)
uN = Replace(uN, "  ", " ", , , vbBinaryCompare)

uN = Replace(uN, "<P>", "", , , vbTextCompare)
uN = Replace(uN, "</P>", "", , , vbTextCompare)
uN = Replace(uN, "<B>", "", , , vbTextCompare)
uN = Replace(uN, "</B>", "", , , vbTextCompare)
uN = Replace(uN, "<BR>", "", , , vbTextCompare)
uN = Replace(uN, "</BR>", "", , , vbTextCompare)
uN = Replace(uN, "</A>", "", , , vbTextCompare)
uN = Replace(uN, "<LI>", "", , , vbTextCompare)
uN = Replace(uN, "</LI>", "", , , vbTextCompare)
uN = Replace(uN, "<HTML>", "", , , vbTextCompare)
uN = Replace(uN, "</HTML>", "", , , vbTextCompare)
uN = Replace(uN, "<HEAD>", "", , , vbTextCompare)
uN = Replace(uN, "</HEAD>", "", , , vbTextCompare)
uN = ReplaceStr(uN, "<TR*>", "", vbTextCompare)
uN = Replace(uN, "</TR>", "", , , vbTextCompare)
uN = ReplaceStr(uN, "<MAP*>", "", vbTextCompare)
uN = Replace(uN, "</MAP>", "", , , vbTextCompare)
uN = ReplaceStr(uN, "<SCRIPT*>", "", vbTextCompare)
uN = Replace(uN, "</SCRIPT>", "", , , vbTextCompare)
uN = ReplaceStr(uN, "<TD*>", "", vbTextCompare)
uN = Replace(uN, "</TD>", "", , , vbTextCompare)
uN = ReplaceStr(uN, "<TABLE*>", "", vbTextCompare)
uN = Replace(uN, "</TABLE>", "", , , vbTextCompare)
uN = ReplaceStr(uN, "<BODY*>", "", vbTextCompare)
uN = Replace(uN, "</BODY>", "", , , vbTextCompare)
uN = ReplaceStr(uN, "<FONT*>", "", vbTextCompare)
uN = Replace(uN, "</FONT>", "", , , vbTextCompare)
uN = ReplaceStr(uN, "<FORM*>", "", vbTextCompare)
uN = Replace(uN, "</FORM>", "", , , vbTextCompare)
uN = ReplaceStr(uN, "<TITLE>*</TITLE>", "", vbTextCompare)
uN = ReplaceStr(uN, "<!--*-->", "", vbTextCompare)
uN = ReplaceStr(uN, "<META*>", "", vbTextCompare)
uN = ReplaceStr(uN, "<STYLE*>", "", vbTextCompare)

uN = ReplaceStr(uN, "<SELECT*>", "", vbTextCompare)
uN = Replace(uN, "</SELECT>", "", , , vbTextCompare)
uN = Replace(uN, "<OPTION SELECTED>", "", , , vbTextCompare)

uN = ReplaceStr(uN, "ALT=""*""", "", vbTextCompare)
uN = ReplaceStr(uN, "WIDTH=""*""", "", vbTextCompare)
uN = ReplaceStr(uN, "HEIGHT=""*""", "", vbTextCompare)
uN = ReplaceStr(uN, "BORDER=""*""", "", vbTextCompare)
uN = ReplaceStr(uN, "NAME=""*""", "", vbTextCompare)
uN = ReplaceStr(uN, "USEMAP=""*""", "", vbTextCompare)
uN = ReplaceStr(uN, "SHAPE=""*""", "", vbTextCompare)
uN = ReplaceStr(uN, "COORDS=""*""", "", vbTextCompare)
uN = ReplaceStr(uN, "ONMOUSEOVER=""*""", "", vbTextCompare)
uN = ReplaceStr(uN, "ONMOUSEOUT=""*""", "", vbTextCompare)
uN = ReplaceStr(uN, "ALIGN=""*""", "", vbTextCompare)
uN = ReplaceStr(uN, "COLSPAN=""*""", "", vbTextCompare)
uN = ReplaceStr(uN, "TARGET=""*""", "", vbTextCompare)

HTMLMegaClear = uN

End Function

Function ProccessHTTPRes(ByVal uResult As String, Optional MacroResults As String) As HTMLResult
Dim uTmp As String, uParsed As String, uTmpStr As String, uPtn As String, uTmpTmp As String, uMark1 As Long, uMarkDelay As Byte

    
If uResult = "" Then Exit Function

MacroResults = ""
    
    With ProccessHTTPRes
    
    uMark1 = InStr(uResult, Chr$(10) & Chr$(10))
    If uMark1 = 0 Then uMark1 = 99999 Else uMarkDelay = 2
        
            If InStr(uResult, Chr$(13) & Chr$(13)) <> 0 And InStr(uResult, Chr$(13) & Chr$(13)) < uMark1 Then
            uMark1 = InStr(uResult, Chr$(13) & Chr$(13)): uMarkDelay = 2
            End If
            
            If InStr(uResult, Chr$(13) & Chr$(10) & Chr$(13) & Chr$(10)) <> 0 And InStr(uResult, Chr$(13) & Chr$(10) & Chr$(13) & Chr$(10)) < uMark1 Then
            uMark1 = InStr(uResult, Chr$(13) & Chr$(10) & Chr$(13) & Chr$(10)): uMarkDelay = 4
            End If
            
        If uMark1 <> 0 Then
        
            If uMark1 <> 99999 Then
            .Contents = Right$(uResult, Len(uResult) - (uMark1 + uMarkDelay) + 1)
            
            Else
            .Contents = ""
            
            End If
            
        uParsed = Left$(uResult, uMark1)
        End If
        
    
    'uParsed = ReplaceStr(uResult, "<html>*</html>", Chr$(13), vbTextCompare, 1, uTmp)
    uParsed = Replace(uParsed, Chr$(13) & Chr$(10), Chr$(13), , , vbBinaryCompare)
    uParsed = Replace(uParsed, Chr$(13) & Chr$(13), Chr$(13), , , vbBinaryCompare)
    
    uPtn = "Date:": uParsed = StripLine(uParsed, Chr$(13), uTmpStr, "Date:")
    
        If uTmpStr <> "" Then 'Date Tag exists...
        uTmpStr = Trim(ReplaceStr(uTmpStr, uPtn, "", vbTextCompare))
        uTmpStr = Right$(uTmpStr, Len(uTmpStr) - 5)
        uTmpStr = Left$(uTmpStr, Len(uTmpStr) - 4)
        Mid$(uTmpStr, 4, 3) = Format$(GetMonthNum(Mid$(uTmpStr, 4, 3)), "00") & "  "
        uTmpStr = Replace(uTmpStr, "  ", " ")
        .Date = CVDate(uTmpStr)
        .Date = DateAdd("h", -3, .Date)
        Add MacroResults, uPtn & .Date & Chr$(13)
        End If
        
    uPtn = "Server:": uParsed = StripLine(uParsed, Chr$(13), uTmpStr, uPtn)
    
        If uTmpStr <> "" Then 'Server Tag exists...
        uTmpStr = Trim(ReplaceStr(uTmpStr, uPtn, "", vbTextCompare))
        .ServerType = uTmpStr
        Add MacroResults, uPtn & .ServerType & Chr$(13)
        End If
        
    uPtn = GetTag(uParsed, "Content-Location:")
        If uPtn <> "" Then
        .Content_Location = uPtn
        Add MacroResults, "Content-Location: " & .Content_Location & Chr$(13)
        End If
    
    uPtn = GetTag(uParsed, "Content-Type:")
        If uPtn <> "" Then
        .Content_Type = uPtn
        Add MacroResults, "Content-Type: " & .Content_Type & Chr$(13)
        End If
    
    uPtn = GetTag(uParsed, "Accept-Ranges:")
        If uPtn <> "" Then
        .Accept_Ranges = uPtn
        Add MacroResults, "Accept-Ranges: " & .Accept_Ranges & Chr$(13)
        End If
    
    uPtn = GetTag(uParsed, "Last-Modified:")
        If uPtn <> "" Then
        uPtn = Right$(uPtn, Len(uPtn) - 5)
        uPtn = Left$(uPtn, Len(uPtn) - 4)
        Mid$(uPtn, 4, 3) = Format$(GetMonthNum(Mid$(uPtn, 4, 3)), "00") & "  "
        uPtn = Replace(uPtn, "  ", " ")
        .Date_Modified = CVDate(uPtn)
        .Date_Modified = DateAdd("h", -3, .Date_Modified)
        Add MacroResults, "Last-Modified: " & .Date_Modified & Chr$(13)
        End If
    
    uPtn = GetTag(uParsed, "Expires:")
        If uPtn <> "" Then
        uPtn = Right$(uPtn, Len(uPtn) - 5)
        uPtn = Left$(uPtn, Len(uPtn) - 4)
        Mid$(uPtn, 4, 3) = Format$(GetMonthNum(Mid$(uPtn, 4, 3)), "00") & "  "
        uPtn = Replace(uPtn, "  ", " ")
        .Date_Expire = CVDate(uPtn)
        .Date_Expire = DateAdd("h", -3, .Date_Expire)
        Add MacroResults, "Expiration date: " & .Date_Expire & Chr$(13)
        End If
    
    uPtn = GetTag(uParsed, "ETag:")
        If uPtn <> "" Then
        .ETag = uPtn
        Add MacroResults, "ETag: " & .ETag & Chr$(13)
        End If
    
    uPtn = GetTag(uParsed, "cache-control:")
        If uPtn <> "" Then
        .Cache_Control = uPtn
        Add MacroResults, "Cache Control: " & .Cache_Control & Chr$(13)
        End If
    
    uPtn = GetTag(uParsed, "Content-Length:")
        If uPtn <> "" Then
        .Content_Length = uPtn
        Add MacroResults, "Content-Length: " & .Content_Length & Chr$(13)
        End If
    
    uPtn = GetTag(uParsed, "HTTP/")
        If uPtn <> "" Then
        .HTTPVersion = Val(Left$(uPtn, InStr(uPtn, " ")))
        .Status = Val(Mid$(uPtn, InStr(uPtn, " "), 4))
        Add MacroResults, "Status: " & .Status & Chr$(13)
        Add MacroResults, "HTTP Version: " & .HTTPVersion & Chr$(13)
        End If
        
    uPtn = GetTag(uParsed, "Location:")
        If uPtn <> "" Then
        .Location = uPtn
        Add MacroResults, "Location: " & .Location & Chr$(13)
        End If
    
    uPtn = GetTag(uParsed, "local-temp-file:")
        If uPtn <> "" Then
        .OnDisc = True
        .TempFile = uPtn
        Add MacroResults, "local-temp-file: " & .TempFile & Chr$(13)
        End If
        
        Do
    
        uPtn = GetTag(uParsed, "Set-Cookie:")
            
            If uPtn = "" Then Exit Do
            
            If InStr(uPtn, ";") = 0 Then uPtn = uPtn & ";"
        
        .Cookies = IIf(.Cookies <> "", .Cookies & "; ", "") & Left$(uPtn, InStr(uPtn, ";") - 1)
        
        Loop
        
    If .Cookies <> "" Then Add MacroResults, "Cookies: " & .Cookies & Chr$(13)
        
    End With

    If Right$(MacroResults, 1) = Chr$(13) Then MacroResults = Left$(MacroResults, Len(MacroResults) - 1)

End Function
Function StripHTTPInnerText(ByVal uContents As String) As String
Dim uTmp As String

uTmp = uContents
uTmp = Replace(uContents, ">*<", ">" & Chr$(13) & Chr$(10) & "<")

StripHTTPInnerText = uTmp

End Function


