Attribute VB_Name = "LibMath"
Option Explicit
Function ChangeExpressionBase(ByVal uValue As String, Optional uOriginalbase As Long, Optional uFinalBase As Long) As String
On Error GoTo ChangeExpressionBase_Err

ChangeExpressionBase = "*CONVERROR*"

    If uValue = "" Then
    Err.Raise 50000, App.ProductName, "No expression passed to function."
    Exit Function
    End If

If uOriginalbase = 0 Then uOriginalbase = 10
If uFinalBase = 0 Then uFinalBase = 10

Dim Chars As String, Counter As Integer, RealVal As Currency, Resto As Byte, _
Divisao As Currency, uExp As String, uFactor As Currency, uVal As Currency

Chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ$%+-./"

    If uOriginalbase > Len(Chars) Or uFinalBase > Len(Chars) Then
    Err.Raise 50001, App.ProductName, "Invalid range of original or final base."
    Exit Function
    End If

    For Counter = 1 To Len(uValue) 'Antes de tudo, validar a expresso de entrada.
    
        If InStr(Chars, Mid$(uValue, Counter, 1)) > uOriginalbase Or InStr(Chars, Mid$(uValue, Counter, 1)) = 0 Then 'Caracter invlido para a base, ou para a frmula.
        Err.Raise 50002, App.ProductName, "Invalid char on expression, or out of range specified on original base."
        Exit Function
        End If
        
    Next Counter

'1 parte: Converso para base decimal, para facilitar os trabalhos.

    RealVal = 0

    For Counter = 1 To Len(uValue)
    uFactor = uOriginalbase ^ (Len(uValue) - Counter)
    uVal = (InStr(Chars, Mid$(uValue, Counter, 1)) - 1)
    RealVal = RealVal + uFactor * uVal
    Next Counter
    
'2 parte: Converso para base final.

    uExp = ""

    Do
    Resto = RealVal - Int(RealVal / uFinalBase) * uFinalBase
    Divisao = Int(RealVal / uFinalBase)
    uExp = Mid$(Chars, Resto + 1, 1) + uExp
    RealVal = Divisao
    
        If RealVal = 0 Then Exit Do
    
    Loop

ChangeExpressionBase = uExp

Exit Function
ChangeExpressionBase_Err:
    
    If Not Err.number >= 50000 Then
    ErrH , "Function ChangeExpressionBase"
    Exit Function
    Else
    Err.Raise Err.number, Err.Source, Err.DESCRiption, Err.HelpFile, Err.HelpContext
    
    End If

End Function
Sub Complex2Polar(A As Complex, Result As Polar)
On Error GoTo Complex2Polar_Err
'
' Converts a Complex number into Polar form
'
  Result.Z = IMMag(A)
  Result.Th = ATan2(A.R, A.i)       ' From Trig module
Exit Sub
Complex2Polar_Err:
ErrH App.ProductName & " code library", "Sub Complex2Polar"
Exit Sub
End Sub
Function ArcCos(X As Double) As Double
On Error GoTo ArcCos_Err
' Inverse Cosine
  If X = 1 Then
    ArcCos = 0
  ElseIf X = -1 Then
    ArcCos = -PI()
  Else
    ArcCos = Atn(X / Sqr(-X * X + 1)) + PI() / 2
  End If
Exit Function
ArcCos_Err:
ErrH App.ProductName & " code library", "Function ArcCos"
Exit Function
End Function
Function Arccosec(X As Double) As Double
On Error GoTo Arccosec_Err
' Inverse Cosecant
  Arccosec = Atn(X / Sqr(X * X - 1)) + (Sgn(X) - 1) * PI() / 2
Exit Function
Arccosec_Err:
ErrH App.ProductName & " code library", "Function Arccosec"
Exit Function
End Function
Function Arccotan(X As Double) As Double
On Error GoTo Arccotan_Err
' Inverse Cotangent
  Arccotan = Atn(X) + PI() / 2
Exit Function
Arccotan_Err:
ErrH App.ProductName & " code library", "Function Arccotan"
Exit Function
End Function
Function ArcSec(X As Double) As Double
On Error GoTo ArcSec_Err
' Inverse Secant
  ArcSec = Atn(X / Sqr(X * X - 1)) + Sgn(Sgn(X) - 1) * PI() / 2
Exit Function
ArcSec_Err:
ErrH App.ProductName & " code library", "Function ArcSec"
Exit Function
End Function
Function ArcSin(X As Double) As Double
On Error GoTo ArcSin_Err
' Inverse Sine
  If X = 1 Then
    ArcSin = PI() / 2
  ElseIf X = -1 Then
    ArcSin = -PI() / 2
  Else
    ArcSin = Atn(X / Sqr(-X * X + 1))
  End If
Exit Function
ArcSin_Err:
ErrH App.ProductName & " code library", "Function ArcSin"
Exit Function
End Function
Function ATan2(X As Double, Y As Double) As Double
On Error GoTo ATan2_Err
'
' Returns the ArcTangent based on X and Y coordinates
' If both X and Y are zero an error will occur.
'
' The positive X axis is assumed to be 0, going poistive in the
' counterclockwise direction, and negative in the clockwise direction.
'
  If X = 0 Then
    If Y = 0 Then
      ATan2 = 1 / 0
    ElseIf Y > 0 Then
      ATan2 = PI() / 2
    Else
      ATan2 = -PI() / 2
    End If
  ElseIf X > 0 Then
    If Y = 0 Then
      ATan2 = 0
    Else
      ATan2 = Atn(Y / X)
    End If
  Else
    If Y = 0 Then
      ATan2 = PI()
    Else
      ATan2 = (PI() - Atn(Abs(Y) / Abs(X))) * Sgn(Y)
    End If
  End If
Exit Function
ATan2_Err:
ErrH App.ProductName & " code library", "Function ATan2"
Exit Function
End Function
Function Cosec(X As Double) As Double
On Error GoTo Cosec_Err
' Cosecant
  Cosec = 1 / Sin(X)
Exit Function
Cosec_Err:
ErrH App.ProductName & " code library", "Function Cosec"
Exit Function
End Function
Function Cotan(X As Double) As Double
On Error GoTo Cotan_Err
' Cotangent
  Cotan = 1 / Tan(X)
Exit Function
Cotan_Err:
ErrH App.ProductName & " code library", "Function Cotan"
Exit Function
End Function
Function Deg2Rad(X As Double) As Double
On Error GoTo Deg2Rad_Err
' Degrees to radians
  Deg2Rad = X / 180 * PI()
Exit Function
Deg2Rad_Err:
ErrH App.ProductName & " code library", "Function Deg2Rad"
Exit Function
End Function
Function GetCoordsDistance(ByRef Coord1 As Coordinates, ByRef Coord2 As Coordinates) As Double
GetCoordsDistance = Sqr((Coord1.X - Coord2.X) ^ 2 + (Coord1.Y - Coord2.Y) ^ 2)
End Function
Function HArccos(X As Double) As Double
On Error GoTo HArccos_Err
' Inverse Hyperbolic Cosine
  HArccos = Log(X + Sqr(X * X - 1))
Exit Function
HArccos_Err:
ErrH App.ProductName & " code library", "Function HArccos"
Exit Function
End Function
Function HArccosec(X As Double) As Double
On Error GoTo HArccosec_Err
' Inverse Hyperbolic Cosecant
  HArccosec = Log((Sgn(X) * Sqr(X * X + 1) + 1) / X)
Exit Function
HArccosec_Err:
ErrH App.ProductName & " code library", "Function HArccosec"
Exit Function
End Function
Function HArccotan(X As Double) As Double
On Error GoTo HArccotan_Err
' Inverse Hyperbolic Tangent
  HArccotan = Log((X + 1) / (X - 1)) / 2
Exit Function
HArccotan_Err:
ErrH App.ProductName & " code library", "Function HArccotan"
Exit Function
End Function
Function HArcsec(X As Double) As Double
On Error GoTo HArcsec_Err
' Inverse Hyperbolic Secant
  HArcsec = Log((Sqr(-X * X + 1) + 1) / X)
Exit Function
HArcsec_Err:
ErrH App.ProductName & " code library", "Function HArcsec"
Exit Function
End Function
Function HArcsin(X As Double) As Double
On Error GoTo HArcsin_Err
' Inverse Hyperbolic Sine
  HArcsin = Log(X + Sqr(X * X + 1))
Exit Function
HArcsin_Err:
ErrH App.ProductName & " code library", "Function HArcsin"
Exit Function
End Function
Function HArctan(X As Double) As Double
On Error GoTo HArctan_Err
' Inverse Hyperbolic Tangent
  HArctan = Log((1 + X) / (1 - X)) / 2
Exit Function
HArctan_Err:
ErrH App.ProductName & " code library", "Function HArctan"
Exit Function
End Function
Function HCos(X As Double) As Double
On Error GoTo HCos_Err
' Hyperbolic Cosine
  HCos = (Exp(X) + Exp(-X)) / 2
Exit Function
HCos_Err:
ErrH App.ProductName & " code library", "Function HCos"
Exit Function
End Function
Function HCosec(X As Double) As Double
On Error GoTo HCosec_Err
' Hyperbolic Cosecant = 1/HSin(X)
  HCosec = 2 / (Exp(X) - Exp(-X))
Exit Function
HCosec_Err:
ErrH App.ProductName & " code library", "Function HCosec"
Exit Function
End Function
Function HCotan(X As Double) As Double
On Error GoTo HCotan_Err
' Hyperbolic Cotangent = 1/HTan(X)
  HCotan = (Exp(X) + Exp(-X)) / (Exp(X) - Exp(-X))
Exit Function
HCotan_Err:
ErrH App.ProductName & " code library", "Function HCotan"
Exit Function
End Function
Function HSec(X As Double) As Double
On Error GoTo HSec_Err
' Hyperbolic Secant = 1/HCos(X)
  HSec = 2 / (Exp(X) + Exp(-X))
Exit Function
HSec_Err:
ErrH App.ProductName & " code library", "Function HSec"
Exit Function
End Function
Function HSin(X As Double) As Double
On Error GoTo HSin_Err
' Hyperbolic Sine
  HSin = (Exp(X) - Exp(-X)) / 2
Exit Function
HSin_Err:
ErrH App.ProductName & " code library", "Function HSin"
Exit Function
End Function
Function HTan(X As Double) As Double
On Error GoTo HTan_Err
' Hyperbolic Tangent = HSin(X)/HCos(X)
  HTan = (Exp(X) - Exp(-X)) / (Exp(X) + Exp(-X))
Exit Function
HTan_Err:
ErrH App.ProductName & " code library", "Function HTan"
Exit Function
End Function
Function PI() As Double
On Error GoTo PI_Err
  PI = Atn(1) * 4
Exit Function
PI_Err:
ErrH App.ProductName & " code library", "Function PI"
Exit Function
End Function
Function Rad2Deg(X As Double) As Double
On Error GoTo Rad2Deg_Err
' Radians to Degrees
  Rad2Deg = X / PI() * 180
Exit Function
Rad2Deg_Err:
ErrH App.ProductName & " code library", "Function Rad2Deg"
Exit Function
End Function
Function Sec(X As Double) As Double
On Error GoTo Sec_Err
' Secant
' This will choke at PI/2 and 3PI/2 radians (90 & 270 degrees)
'
  Sec = 1# / Cos(X)
Exit Function
Sec_Err:
ErrH App.ProductName & " code library", "Function Sec"
Exit Function
End Function
Sub IMAdd(A As Complex, B As Complex, Result As Complex)
On Error GoTo IMAdd_Err
'
' Adds 2 complex numbers
'
  Result.i = A.i + B.i
  Result.R = A.R + B.R
Exit Sub
IMAdd_Err:
ErrH App.ProductName & " code library", "Sub IMAdd"
Exit Sub
End Sub
Sub IMConjugate(A As Complex, Result As Complex)
On Error GoTo IMConjugate_Err
'
' Returns the Conjugate of A
'
  Result.R = A.R
  Result.i = -A.i
Exit Sub
IMConjugate_Err:
ErrH App.ProductName & " code library", "Sub IMConjugate"
Exit Sub
End Sub
Sub IMDiv(A As Complex, B As Complex, Result As Complex)
On Error GoTo IMDiv_Err
'
' Divides A by B
'
Dim b1 As Complex
  IMInverse B, b1
  IMProduct A, b1, Result
Exit Sub
IMDiv_Err:
ErrH App.ProductName & " code library", "Sub IMDiv"
Exit Sub
End Sub
Sub IMExp(A As Complex, Result As Complex)
On Error GoTo IMExp_Err
'
' Does e^A where A is a complex number
'
Dim A1 As Complex, Z As Double
  A1 = A
  Z = Exp(A1.R)
  Result.R = Z * Cos(A1.i)
  Result.i = Z * Sin(A1.i)
Exit Sub
IMExp_Err:
ErrH App.ProductName & " code library", "Sub IMExp"
Exit Sub
End Sub
Function IMFormat(A As Complex) As String
On Error GoTo IMFormat_Err
'
' Formats a Complex number into a string
'
  If A.i >= 0 Then
    IMFormat = A.R & " + " & A.i & "i"
  Else
    IMFormat = A.R & " - " & Abs(A.i) & "i"
  End If
Exit Function
IMFormat_Err:
ErrH App.ProductName & " code library", "Function IMFormat"
Exit Function
End Function
Sub IMInverse(A As Complex, Result As Complex)
On Error GoTo IMInverse_Err
'
' Finds the inverse value of A, such that A * Result = 1
'
Dim Temp As Double
  Temp = A.R * A.R + A.i * A.i
  Result.R = A.R / Temp
  Result.i = -A.i / Temp
Exit Sub
IMInverse_Err:
ErrH App.ProductName & " code library", "Sub IMInverse"
Exit Sub
End Sub
Sub IMln(A As Complex, Result As Complex)
On Error GoTo IMln_Err
'
' Returns natural Logarithm of A
'
Dim A1 As Complex
  A1 = A
  Result.R = Log(IMMag(A1))
  Result.i = ATan2(A1.R, A1.i)
Exit Sub
IMln_Err:
ErrH App.ProductName & " code library", "Sub IMln"
Exit Sub
End Sub
Sub IMLog10(A As Complex, Result As Complex)
On Error GoTo IMLog10_Err
'
' Takes Log A base 10
'
  IMln A, Result
  IMRProduct Result, Log10(Exp(1)), Result
Exit Sub
IMLog10_Err:
ErrH App.ProductName & " code library", "Sub IMLog10"
Exit Sub
End Sub
Function Ceiling(N, ByVal Precision)
On Error GoTo Ceiling_Err
'
' Similar to Excel's Ceiling function
' Rounds up to the next higher level of precision.
' Precision cannot be 0.
'
Dim Temp As Double
  Precision = Abs(Precision)
  Temp = Int(N / Precision) * Precision
  If Temp = N Then
    Ceiling = N
  Else
    Ceiling = Temp + Precision * Sgn(Temp)
  End If
Exit Function
Ceiling_Err:
ErrH App.ProductName & " code library", "Function Ceiling"
Exit Function
End Function
Function DecToHex(ByVal X As Double) As String
On Error GoTo DecToHex_Err
Dim Result As String, i As Integer, Temp As Integer
  Result = Hex(Int(X)) & "."
  X = X - Int(X)
  For i = 1 To 16
    X = X * 16
    Result = Result & Hex(X)
    X = X - Int(X)
  Next i
  DecToHex = Result
Exit Function
DecToHex_Err:
ErrH App.ProductName & " code library", "Function DecToHex"
Exit Function
End Function
Function Floor(N, ByVal Precision)
On Error GoTo Floor_Err
'
' Similar to Excel's Floor function
' Rounds down (toward zero) to the next higher level of precision.
' Precision cannot be 0.
'
  Precision = Abs(Precision)
  Floor = Int(N / Precision) * Precision
Exit Function
Floor_Err:
ErrH App.ProductName & " code library", "Function Floor"
Exit Function
End Function
Function Frac2Num(X)
On Error GoTo Frac2Num_Err
'
' Parses a standard fraction of the form "a/b" or "a b/c" and returns a number.
' e.g. "2/5" or "3 1/2" are valid input.
'
Dim Temp As String, P As Integer, N As Double, Num As Double, Den As Double
  If VarType(X) < 2 Or VarType(X) = 7 Then
    Frac2Num = Null
  ElseIf VarType(X) <> 8 Then
    Frac2Num = X
  Else
    Temp = Trim$(X)
    P = InStr(Temp, " ")
    If P = 0 Then
      If InStr(Temp, "/") = 0 Then
        N = Val(Temp)
      Else
        N = 0
      End If
    Else
      N = Val(Left$(Temp, P - 1))
      Temp = Mid$(Temp, P + 1)
    End If
    P = InStr(Temp, "/")
    If P <> 0 Then
      Num = Val(Left$(Temp, P - 1))
      Den = Val(Mid$(Temp, P + 1))
      If Den <> 0 Then
        N = N + Num / Den
      End If
    End If
    Frac2Num = N
  End If
Exit Function
Frac2Num_Err:
ErrH App.ProductName & " code library", "Function Frac2Num"
Exit Function
End Function
Function GCF(ByVal X As Long, ByVal Y As Long) As Long
On Error GoTo GCF_Err
'
' Returns the Greatest Common Factor
' i.e. the largest number which will evenly divide into both X and Y
'
Dim Temp As Long
  X = Abs(X)        ' Make both numbers positive
  Y = Abs(Y)
  Temp = X Mod Y
  Do While Temp > 0
    X = Y
    Y = Temp
    Temp = X Mod Y
  Loop
  GCF = Y
Exit Function
GCF_Err:
ErrH App.ProductName & " code library", "Function GCF"
Exit Function
End Function
Function Hex2Dec(s As String) As Long
On Error GoTo Hex2Dec_Err

'
' Converts a string of hexadecimal digits into a decimal number.
' Valid input range '0' to 'FFFFFFFF'
'
  Hex2Dec = Val("&H" & s)
Exit Function
Hex2Dec_Err:
ErrH App.ProductName & " code library", "Function Hex2Dec"
Exit Function
End Function
Function IsPrime(ByVal X As Long) As Boolean
On Error GoTo IsPrime_Err
'
' Returns TRUE if the number is Prime.
' Treats negative numbers like positive numbers, so both -3 and 3
' return TRUE.
'
Dim i As Integer, A As Double
IsPrime = True
X = Abs(X)

    If X = 0 Or X = 1 Then
    IsPrime = False
    
    ElseIf X = 2 Then
    
    ElseIf (X And 1) = 0 Then
    IsPrime = False
    
    Else
    
        For i = 3 To Int(Sqr(X)) Step 2
        A = X / i
        
            If A = X \ i Then
            IsPrime = False
            Exit Function
            End If
    
        Next i
    
    End If

Exit Function
IsPrime_Err:
ErrH App.ProductName & " code library", "Function IsPrime"
Exit Function
End Function
Function LCM(ByVal X As Integer, ByVal Y As Integer) As Long
On Error GoTo LCM_Err
'
' Returns the Lowest Common Multiple
' i.e. the smallest number of which both X and Y are factors
'
Dim Temp As Long
  X = Abs(X)        ' Make both numbers positive
  Y = Abs(Y)
  LCM = Y * (X \ GCF(X, Y))
Exit Function
LCM_Err:
ErrH App.ProductName & " code library", "Function LCM"
Exit Function
End Function
Function Log10(X As Double) As Double
On Error GoTo Log10_Err
'
' Log base 10
'
  Log10 = Log(X) / Log(10)
Exit Function
Log10_Err:
ErrH App.ProductName & " code library", "Function Log10"
Exit Function
End Function
Function Log2(X As Double) As Double
On Error GoTo Log2_Err
'
' Log base 2
'
  Log2 = Log(X) / Log(2)
Exit Function
Log2_Err:
ErrH App.ProductName & " code library", "Function Log2"
Exit Function
End Function
Function LogN(X As Double, N As Double) As Double
On Error GoTo LogN_Err
'
' Log base N
'
  LogN = Log(X) / Log(N)
Exit Function
LogN_Err:
ErrH App.ProductName & " code library", "Function LogN"
Exit Function
End Function
Function Max2(A As Variant, B As Variant) As Variant
On Error GoTo Max2_Err
'
' Returns the greater of 2 values
'
  Max2 = IIf(A > B, A, B)
Exit Function
Max2_Err:
ErrH App.ProductName & " code library", "Function Max2"
Exit Function
End Function
Function Max3(A As Variant, B As Variant, c As Variant) As Variant
On Error GoTo Max3_Err
'
' Returns the greatest of 3 values
'
  If A > B Then Max3 = Max2(A, c) Else Max3 = Max2(B, c)
Exit Function
Max3_Err:
ErrH App.ProductName & " code library", "Function Max3"
Exit Function
End Function
Function Min2(A As Variant, B As Variant) As Variant
On Error GoTo Min2_Err
'
' Returns the lesser of 2 values
'
  Min2 = IIf(A < B, A, B)
Exit Function
Min2_Err:
ErrH App.ProductName & " code library", "Function Min2"
Exit Function
End Function
Function Min3(A As Variant, B As Variant, c As Variant) As Variant
On Error GoTo Min3_Err
'
' Returns the least of 3 values
'
  If A < B Then Min3 = Min2(A, c) Else Min3 = Min2(B, c)
Exit Function
Min3_Err:
ErrH App.ProductName & " code library", "Function Min3"
Exit Function
End Function
Function Num2Frac(X)
On Error GoTo Num2Frac_Err
'
' Converts a decimal number to a normalized fraction and automatically,
' determines a Denominator between 2 and 8.
'
Dim Temp As String, Fixed As Double
  If (VarType(X) < 2) Or (VarType(X) > 6) Then
    Num2Frac = X
  Else
    X = Abs(X)
    Fixed = Int(X)
    If Fixed > 0 Then
      Temp = str(Fixed)
    End If
    Select Case X - Fixed
      Case Is < 0.1
        If Fixed > 0 Then
          Temp = Temp
        Else
          Temp = str(X)
        End If
      Case 0.1 To 0.145
        Temp = Temp + " 1/8"
      Case 0.145 To 0.182
        Temp = Temp + " 1/6"
      Case 0.182 To 0.225
        Temp = Temp + " 1/5"
      Case 0.225 To 0.29
        Temp = Temp + " 1/4"
      Case 0.29 To 0.35
        Temp = Temp + " 1/3"
      Case 0.35 To 0.3875
        Temp = Temp + " 3/8"
      Case 0.3875 To 0.45
        Temp = Temp + " 2/5"
      Case 0.45 To 0.55
        Temp = Temp + " 1/2"
      Case 0.55 To 0.6175
        Temp = Temp + " 3/5"
      Case 0.6175 To 0.64
        Temp = Temp + " 5/8"
      Case 0.64 To 0.7
        Temp = Temp + " 2/3"
      Case 0.7 To 0.775
        Temp = Temp + " 3/4"
      Case 0.775 To 0.8375
        Temp = Temp + " 4/5"
      Case 0.8735 To 0.91
        Temp = Temp + " 7/8"
      Case Is > 0.91
        Temp = str(Int(X) + 1)
    End Select
    Num2Frac = Temp
  End If
Exit Function
Num2Frac_Err:
ErrH App.ProductName & " code library", "Function Num2Frac"
Exit Function
End Function
Function Num2FracA(X, Denominator As Long)
On Error GoTo Num2FracA_Err
'
' Converts a decimal number to a fraction but doesn't normalize it.
' i.e. 3 2/4 -> 3 2/4
'
Dim Temp As String, Fixed As Double, Numerator As Long
  If (VarType(X) < 2) Or (VarType(X) > 6) Then
    Num2FracA = X
    Exit Function
  End If
  X = Abs(X)
  Fixed = Int(X)
  Numerator = Int((X - Fixed) * Denominator + 0.5) 'Arithmatic rounding
  If Numerator = Denominator Then
    Fixed = Fixed + 1
    Numerator = 0
  End If
  If Fixed > 0 Then
    Temp = str(Fixed)
  End If
  If Numerator > 0 Then
    Temp = Temp & " " & Numerator & "/" & Denominator
  End If
  Num2FracA = Temp
Exit Function
Num2FracA_Err:
ErrH App.ProductName & " code library", "Function Num2FracA"
Exit Function
End Function
Function Num2FracB(X, ByVal Denominator As Long)
On Error GoTo Num2FracB_Err
'
' Converts a decimal number to a fraction and normalizes it.
' i.e. 3 2/4 -> 3 1/2
'
Dim Temp As String, Fixed As Double, Numerator As Long, Factor As Long
  If (VarType(X) < 2) Or (VarType(X) > 6) Then
    Num2FracB = X
    Exit Function
  End If
  X = Abs(X)
  Fixed = Int(X)
  Numerator = Int((X - Fixed) * Denominator + 0.5) 'Arithmatic rounding
  If Numerator = Denominator Then
    Fixed = Fixed + 1
    Numerator = 0
  End If
  If Fixed > 0 Then
    Temp = str(Fixed)
  End If
  If Numerator > 0 Then
    Factor = GCF(Numerator, Denominator)
    Temp = Temp & " " & Numerator / Factor & "/" & Denominator / Factor
  End If
  Num2FracB = Temp
Exit Function
Num2FracB_Err:
ErrH App.ProductName & " code library", "Function Num2FracB"
Exit Function
End Function
Function Num2Roman(ByVal N As Integer) As String
On Error GoTo Num2Roman_Err
'
' Converts a decimal number into a Roman number
' Valid input in the range 1-3999
'
Const Digits = "IVXLCDM"
Dim i As Integer, Digit As Integer, Temp As String
  i = 1
  Temp = ""
  Do While N > 0
    Digit = N Mod 10
    N = N \ 10
    Select Case Digit
      Case 1
        Temp = Mid(Digits, i, 1) & Temp
      Case 2
        Temp = Mid(Digits, i, 1) & Mid(Digits, i, 1) & Temp
      Case 3
        Temp = Mid(Digits, i, 1) & Mid(Digits, i, 1) & Mid(Digits, i, 1) & Temp
      Case 4
        Temp = Mid(Digits, i, 2) & Temp
      Case 5
        Temp = Mid(Digits, i + 1, 1) & Temp
      Case 6
        Temp = Mid(Digits, i + 1, 1) & Mid(Digits, i, 1) & Temp
      Case 7
        Temp = Mid(Digits, i + 1, 1) & Mid(Digits, i, 1) & Mid(Digits, i, 1) & Temp
      Case 8
        Temp = Mid(Digits, i + 1, 1) & Mid(Digits, i, 1) & Mid(Digits, i, 1) & Mid(Digits, i, 1) & Temp
      Case 9
        Temp = Mid(Digits, i, 1) & Mid(Digits, i + 2, 1) & Temp
    End Select
    i = i + 2
  Loop
  Num2Roman = Temp
Exit Function
Num2Roman_Err:
ErrH App.ProductName & " code library", "Function Num2Roman"
Exit Function
End Function
Function Oct2Dec(s As String) As Long
On Error GoTo Oct2Dec_Err
'
' Converts a string of Octal (base 8) digits into a decimal number.
' Valid input range '0' to '37777777777'
'
  Oct2Dec = Val("&O" & s)
Exit Function
Oct2Dec_Err:
ErrH App.ProductName & " code library", "Function Oct2Dec"
Exit Function
End Function
Function Round2(X)
On Error GoTo Round2_Err
'
' Rounds a number to 2 decimal places
' Uses arithmatic rounding
'
  Round2 = Int(X * 100 + 0.5) / 100
Exit Function
Round2_Err:
ErrH App.ProductName & " code library", "Function Round2"
Exit Function
End Function
Function Round2C(X)
On Error GoTo Round2C_Err
'
' Rounds number to 2 decimal places
' Uses arithmatic rounding
' Designed for use with Currency values
'
  If IsNull(X) Then
    Round2C = Null
  Else
    Round2C = CCur(Int(X * 100 + 0.5) / 100)
  End If
Exit Function
Round2C_Err:
ErrH App.ProductName & " code library", "Function Round2C"
Exit Function
End Function
Function Round2CB(X As Variant) As Variant
On Error GoTo Round2CB_Err
'
' Banker's rounding of Currency to 2 decimal places.
'
Dim Temp As Currency, ITemp As Currency, Digit As Integer
  If IsNull(X) Then Exit Function
  Round2CB = CCur(X / 100) * 100
Exit Function
Round2CB_Err:
ErrH App.ProductName & " code library", "Function Round2CB"
Exit Function
End Function
Function RoundN(X, N As Integer)
On Error GoTo RoundN_Err
'
' Rounds a number to N decimal places
' Uses arithmatic rounding
' N should be in the range 0-10 for proper results
'
Dim Factor As Long
  Factor = 10 ^ N
  RoundN = Int(X * Factor + 0.5) / Factor
Exit Function
RoundN_Err:
ErrH App.ProductName & " code library", "Function RoundN"
Exit Function
End Function
Sub Sieve()
On Error GoTo Sieve_Err
'
' Generates array of first 1000 prime numbers
' using the Sieve of Eratosthenes
'
ReDim P(1 To 1000)
Dim PCount As Integer, i As Long, J As Integer, IsPrime As Integer, X As Long
  PCount = 0
  i = 2
  Do While PCount < 1000
    IsPrime = True
    For J = 1 To PCount - 1
      X = P(J)
      If i / X = i \ X Then
        IsPrime = False
        Exit For
      End If
    Next J
    If IsPrime Then
      PCount = PCount + 1
      P(PCount) = i
      Debug.Print i;
    End If
    i = i + 1
  Loop
Exit Sub
Sieve_Err:
ErrH App.ProductName & " code library", "Sub Sieve"
Exit Sub
End Sub
Function ToBRoundInt(X As Variant) As Long
On Error GoTo ToBRoundInt_Err
'
' Takes a variant, convertis it to a number and rounds it using Banker's Rounding.
' Null/Non-numeric values mapped to zero.
'
' i.e. n.5 rounds to the nearest even number.
' e.g. 1.5 -> 2, but 0.5 -> 0
'
' Fractions less than .5 always round down, and fractions greater always round up.
'
  If Not IsNumeric(X) Then
    ToBRoundInt = 0
  Else
    ToBRoundInt = X ' Banker's rounding
  End If
Exit Function
ToBRoundInt_Err:
ErrH App.ProductName & " code library", "Function ToBRoundInt"
Exit Function
End Function
Function ToCurr(X As Variant) As Currency
On Error GoTo ToCurr_Err
'
' Converts a variant to currency.
' Null/non-numeric values mapped to zero.
'
  If Not IsNumeric(X) Then
    ToCurr = 0
  Else
    ToCurr = X
  End If
Exit Function
ToCurr_Err:
ErrH App.ProductName & " code library", "Function ToCurr"
Exit Function
End Function
Function ToFloat(X As Variant) As Double
On Error GoTo ToFloat_Err
'
' Converts a variant to a double.
' Null/non-numeric values get mapped to zero.
'
  If Not IsNumeric(X) Then
    ToFloat = 0
  Else
    ToFloat = X
  End If
Exit Function
ToFloat_Err:
ErrH App.ProductName & " code library", "Function ToFloat"
Exit Function
End Function
Function ToInt(X As Variant) As Long
On Error GoTo ToInt_Err
'
' Converts a variant to integer/long.
' Null/non-numeric values are mapped to zero.
'
  If Not IsNumeric(X) Then
    ToInt = 0
  Else
    ToInt = Int(X)   ' Truncates decimal digits
  End If
Exit Function
ToInt_Err:
ErrH App.ProductName & " code library", "Function ToInt"
Exit Function
End Function
Function ToRoundInt(X As Variant) As Long
On Error GoTo ToRoundInt_Err
'
' Converts a variant to an integer and rounds using Arithmatic rounding.
' Null/non-numeric values mapped to 0.
'
' .0-.4999... always rounds down
' .5-.9999... always rounds up
'
  If Not IsNumeric(X) Then
    ToRoundInt = 0
  Else
    ToRoundInt = Int(X + 0.5) ' Arithmatic rounding
  End If
Exit Function
ToRoundInt_Err:
ErrH App.ProductName & " code library", "Function ToRoundInt"
Exit Function
End Function
Function ToString(X As Variant) As String
On Error GoTo ToString_Err
'
' Converts a variant to a string.
' Null mapped to "".
'
  If IsNull(X) Then
    ToString = ""
  Else
    ToString = X
  End If
Exit Function
ToString_Err:
ErrH App.ProductName & " code library", "Function ToString"
Exit Function
End Function
Sub IMLog2(A As Complex, Result As Complex)
On Error GoTo IMLog2_Err
'
' Takes Log A base 10
'
  IMln A, Result
  IMRProduct Result, Log2(Exp(1)), Result
Exit Sub
IMLog2_Err:
ErrH App.ProductName & " code library", "Sub IMLog2"
Exit Sub
End Sub
Function IMMag(A As Complex) As Double
On Error GoTo IMMag_Err
'
' Returns Magnitude of Complex number
'
  IMMag = Sqr(A.R * A.R + A.i * A.i)
Exit Function
IMMag_Err:
ErrH App.ProductName & " code library", "Function IMMag"
Exit Function
End Function
Function IMPFormat(A As Polar) As String
On Error GoTo IMPFormat_Err
'
' Formats a Polar number into a string
'
  If A.Th >= 0 Then
    IMPFormat = A.Z & " + " & A.Th & "Th"
  Else
    IMPFormat = A.Z & " - " & Abs(A.Th) & "Th"
  End If
Exit Function
IMPFormat_Err:
ErrH App.ProductName & " code library", "Function IMPFormat"
Exit Function
End Function
Sub IMPower(A As Complex, B As Complex, Result As Complex)
On Error GoTo IMPower_Err
'
' A^B where both are complex numbers
'
Dim Temp1 As Complex, Temp2 As Complex
  IMln A, Temp1
  IMProduct Temp1, B, Temp2
  IMExp Temp2, Result
Exit Sub
IMPower_Err:
ErrH App.ProductName & " code library", "Sub IMPower"
Exit Sub
End Sub
Sub IMProduct(A As Complex, B As Complex, Result As Complex)
On Error GoTo IMProduct_Err
'
' Multiples 2 complex numbers
'
Dim A1 As Complex, b1 As Complex          ' Prevents problems if do IMult A, A, A
  A1 = A
  b1 = B
  Result.i = A1.i * b1.R + A1.R * b1.i
  Result.R = A1.R * b1.R - A1.i * b1.i
Exit Sub
IMProduct_Err:
ErrH App.ProductName & " code library", "Sub IMProduct"
Exit Sub
End Sub
Sub IMRDiv(A As Complex, B As Double, Result As Complex)
On Error GoTo IMRDiv_Err
'
' Divides A by the scalar value B
'
  Result.R = A.R / B
  Result.i = A.i / B
Exit Sub
IMRDiv_Err:
ErrH App.ProductName & " code library", "Sub IMRDiv"
Exit Sub
End Sub
Sub IMRPower(A As Complex, B As Double, Result As Complex)
On Error GoTo IMRPower_Err
'
' Does A^B where A in a Complex number and B is Real number
'
Dim APolar As Polar
  Complex2Polar A, APolar
  APolar.Z = APolar.Z ^ B
  APolar.Th = APolar.Th * B
  Polar2Complex APolar, Result
Exit Sub
IMRPower_Err:
ErrH App.ProductName & " code library", "Sub IMRPower"
Exit Sub
End Sub
Sub IMRProduct(A As Complex, B As Double, Result As Complex)
On Error GoTo IMRProduct_Err
'
' Multiplies A by the scalar value B
'
  Result.R = A.R * B
  Result.i = A.i * B
Exit Sub
IMRProduct_Err:
ErrH App.ProductName & " code library", "Sub IMRProduct"
Exit Sub
End Sub
Sub IMSqr(A As Complex, Result As Complex)
On Error GoTo IMSqr_Err
'
' Takes the square root of a complex number
'
Dim A1 As Polar
  Complex2Polar A, A1
  A1.Z = Sqr(A1.Z)
  A1.Th = A1.Th / 2
  Polar2Complex A1, Result
Exit Sub
IMSqr_Err:
ErrH App.ProductName & " code library", "Sub IMSqr"
Exit Sub
End Sub
Sub IMSub(A As Complex, B As Complex, Result As Complex)
On Error GoTo IMSub_Err
'
' Subtracts 2 complex numbers
'
  Result.i = A.i - B.i
  Result.R = A.R - B.R
Exit Sub
IMSub_Err:
ErrH App.ProductName & " code library", "Sub IMSub"
Exit Sub
End Sub
Sub Polar2Complex(A As Polar, Result As Complex)
On Error GoTo Polar2Complex_Err
'
' Converts a Polar form into Complex number
'
  Result.R = A.Z * Cos(A.Th)
  Result.i = A.Z * Sin(A.Th)
Exit Sub
Polar2Complex_Err:
ErrH App.ProductName & " code library", "Sub Polar2Complex"
Exit Sub
End Sub
Function ACircle(Radius As Double) As Double
On Error GoTo ACircle_Err
'
' Area of circle given radius
' Uses PI() from Trig module
'
  ACircle = Radius * Radius * PI()
Exit Function
ACircle_Err:
ErrH App.ProductName & " code library", "Function ACircle"
Exit Function
End Function
Function ARect(L As Double, w As Double) As Double
On Error GoTo ARect_Err
'
' Area of rectangle
'
  ARect = L * w
Exit Function
ARect_Err:
ErrH App.ProductName & " code library", "Function ARect"
Exit Function
End Function
Function ARing(InnerRadius As Double, OuterRadius As Double) As Double
On Error GoTo ARing_Err
'
' Area of a ring defined by 2 radii
'
  ARing = ACircle(OuterRadius) - ACircle(InnerRadius)
Exit Function
ARing_Err:
ErrH App.ProductName & " code library", "Function ARing"
Exit Function
End Function
Function ASphere(R As Double) As Double
On Error GoTo ASphere_Err
'
' Area of a sphere given the radius
'
  ASphere = 4 * PI() * R * R
Exit Function
ASphere_Err:
ErrH App.ProductName & " code library", "Function ASphere"
Exit Function
End Function
Function ASquare(Side As Double) As Double
On Error GoTo ASquare_Err
'
' Area of square give length of a side
'
  ASquare = Side * Side
Exit Function
ASquare_Err:
ErrH App.ProductName & " code library", "Function ASquare"
Exit Function
End Function
Function ASquare2(Diag As Double) As Double
On Error GoTo ASquare2_Err
'
' Area of square given length of diagonal
'
  ASquare2 = Diag * Diag / 2
Exit Function
ASquare2_Err:
ErrH App.ProductName & " code library", "Function ASquare2"
Exit Function
End Function
Function ATrap(H As Double, L1 As Double, L2 As Double)
On Error GoTo ATrap_Err
'
' Area of Trapezoid or Trapezium given lengths of parallel sides
' and perpendicular height
'
  ATrap = H * (L1 + L2) / 2
Exit Function
ATrap_Err:
ErrH App.ProductName & " code library", "Function ATrap"
Exit Function
End Function
Function ATriangle(L As Double, H As Double) As Double
On Error GoTo ATriangle_Err
'
' Area of triangle given length of a side and perpendicular height
'
  ATriangle = L * H / 2
Exit Function
ATriangle_Err:
ErrH App.ProductName & " code library", "Function ATriangle"
Exit Function
End Function
Function ATriangle2(A As Double, B As Double, c As Double) As Double
On Error GoTo ATriangle2_Err
'
' Area of a triangle given the lengths of the 3 sides
'
Dim CosC As Double
  CosC = (A * A + B * B - c * c) / (2 * A * B)
  ATriangle2 = A * B * Sqr(1 - CosC * CosC) / 2
Exit Function
ATriangle2_Err:
ErrH App.ProductName & " code library", "Function ATriangle2"
Exit Function
End Function
Function RectDiag(w As Double, L As Double) As Double
On Error GoTo RectDiag_Err
'
' Length of diagonal of a rectangle given the 2 sides
'
  RectDiag = Sqr(w * w + L * L)
Exit Function
RectDiag_Err:
ErrH App.ProductName & " code library", "Function RectDiag"
Exit Function
End Function
Function SquareDiag(L As Double) As Double
On Error GoTo SquareDiag_Err
'
' Length of the diagonal of a square side length L
'
  SquareDiag = L * Sqr(2)
Exit Function
SquareDiag_Err:
ErrH App.ProductName & " code library", "Function SquareDiag"
Exit Function
End Function
Function VCone(H As Double, R As Double) As Double
On Error GoTo VCone_Err
'
' Volume of a cone given radius of base and height
'
  VCone = H * R * R * PI() / 3
Exit Function
VCone_Err:
ErrH App.ProductName & " code library", "Function VCone"
Exit Function
End Function
Function VCylinder(H As Double, R As Double) As Double
On Error GoTo VCylinder_Err
'
' Volume of Cylider given height and radius
' Uses PI() from Trig module
'
  VCylinder = PI() * R * R * H
Exit Function
VCylinder_Err:
ErrH App.ProductName & " code library", "Function VCylinder"
Exit Function
End Function
Function VPipe(H As Double, OuterRadius As Double, InnerRadius As Double) As Double
On Error GoTo VPipe_Err
'
' Volume of a pipe by subtracting 2 cylinders
'
  VPipe = VCylinder(H, OuterRadius) - VCylinder(H, InnerRadius)
Exit Function
VPipe_Err:
ErrH App.ProductName & " code library", "Function VPipe"
Exit Function
End Function
Function VPyramid(H As Double, BaseArea As Double) As Double
On Error GoTo VPyramid_Err
'
' Volume of pyramid or cone given are of the base and the height
'
  VPyramid = H * BaseArea / 3
Exit Function
VPyramid_Err:
ErrH App.ProductName & " code library", "Function VPyramid"
Exit Function
End Function
Function VSphere(R As Double) As Double
On Error GoTo VSphere_Err
'
' Volume of a sphere given the radius
'
  VSphere = PI() * R * R * R * 4 / 3
Exit Function
VSphere_Err:
ErrH App.ProductName & " code library", "Function VSphere"
Exit Function
End Function
Function VTruncPyramid(H As Double, BaseArea1 As Double, BaseArea2 As Double) As Double
On Error GoTo VTruncPyramid_Err
'
' Volume of truncated pyramid given height and area of base and top
'
  VTruncPyramid = H * (BaseArea1 + BaseArea2 + Sqr(BaseArea1) * Sqr(BaseArea2)) / 3
Exit Function
VTruncPyramid_Err:
ErrH App.ProductName & " code library", "Function VTruncPyramid"
Exit Function
End Function

Public Function Base2Long(s As String, ByVal nB As Integer) As Long
On Error GoTo Base2Long_Err

Dim s2 As String
   Dim i As Long
   Dim J As Long
   Dim X As Long
   Dim N As Boolean
   Dim s3 As String
   
   If Len(s) < 1 Then
      Base2Long = 0
      Exit Function
   End If
   
   s2 = UCase(s)
   
   If Left$(s2, 1) = "-" Then
      N = True
      s2 = Right$(s2, Len(s2) - 1)
   Else
      N = False
   End If
   
   J = 1
   X = 0
   
   For i = Len(s2) To 1 Step -1
      s3 = Mid$(s2, i, 1)
      Select Case s3
      Case "0" To "9":
         X = X + J * (Asc(s3) - 48)
      Case "A" To "Z":
         X = X + J * (Asc(s3) - 55)
      End Select
      
      J = J * nB
   Next i
   
   If N Then
      X = -X
   End If
   
   Base2Long = X

Exit Function
Base2Long_Err:
ErrH App.ProductName & " code library", "Public Function Base2Long"
Exit Function

End Function
Public Function Long2Base(ByVal N As Long, ByVal nB As Integer) As String
On Error GoTo Long2Base_Err

Dim s As String
  Dim nD As Integer
  Dim Negative As Boolean

  Negative = N < 0
  N = Abs(N)
  
  Do
    nD = N Mod nB
    If nD > 9 Then
       nD = nD + 7
    End If
    
    s = Chr$(48 + nD) & s
    N = N \ nB
  Loop Until N = 0
  
  If Negative Then
    s = "-" & s
  End If
  
  Long2Base = s

Exit Function
Long2Base_Err:
ErrH App.ProductName & " code library", "Public Function Long2Base"
Exit Function

End Function
Function Combin(N As Integer, M As Integer) As Double
On Error GoTo Combin_Err
'
' Returns the number of combinations, without regard to order,
' of M items that can be made from a pool of N items.
'
' N must be greater of equal to M.
' M must be between 0 and N.
'
  Combin = Factorial(N) / Factorial(M) / Factorial(N - M)
Exit Function
Combin_Err:
ErrH App.ProductName & " code library", "Function Combin"
Exit Function
End Function
Function Factorial(X As Integer) As Double
On Error GoTo Factorial_Err
'
' Non-recursive factorial
'
Dim i As Integer, f As Double
  If X < 0 Or X > 170 Then
    Factorial = 0#
    Exit Function
  End If
  f = 1#
  For i = 2 To X
    f = f * i
  Next i
  Factorial = f
Exit Function
Factorial_Err:
ErrH App.ProductName & " code library", "Function Factorial"
Exit Function
End Function
Function FactorialR(X As Integer) As Double
On Error GoTo FactorialR_Err
'
' Recursive factorial
'
  If X < 0 Or X > 170 Then
    FactorialR = 0#
  ElseIf X = 0 Then
    FactorialR = 1#
  Else
    FactorialR = X * FactorialR(X - 1)
  End If
Exit Function
FactorialR_Err:
ErrH App.ProductName & " code library", "Function FactorialR"
Exit Function
End Function
Function Permut(N As Integer, M As Integer) As Double
On Error GoTo Permut_Err
'
' Returns the number of combinations, with regard to order,
' of M items that can be made from a pool of N items.
'
' Use this for lottory-style calculations.
'
' N must be greater of equal to M.
' M must be between 0 and N.
'
  Permut = Factorial(N) / Factorial(N - M)
Exit Function
Permut_Err:
ErrH App.ProductName & " code library", "Function Permut"
Exit Function
End Function
Sub Regress(A() As Double, ByVal XCol As Integer, YCol As Integer, ByVal N As Integer, Slope As Double, YIntercept As Double)
On Error GoTo Regress_Err
'
' Performs Linear regression on array A()
' A() must be a 2-dimensional array - e.g. Redim A(50, 0 To 1) as Double
' XCol indicates which column represents the X Axis
' YCol indicates which column represents the Y Axis
' The slope of the best fit line is returned in Slope
' The Y intercept is returned in YIntercept
' The X intercept = -YIntercept/Slope - This will produce a run-time error if the line is horizontal
'
' The function will produce a run-time error if there are less than 2 points,
' the line is vertical, or XCol or YCol are invalid
'
' The function sums all rows from 1 to N
'
Dim i As Integer, SumX As Double, SumY As Double, SumXY As Double, SumXX As Double, X As Double, Y As Double
  SumX = 0
  SumY = 0
  SumXY = 0
  SumXX = 0
  For i = 1 To N
    X = A(i, XCol)
    Y = A(i, YCol)
    SumX = SumX + X
    SumY = SumY + Y
    SumXY = SumXY + X * Y
    SumXX = SumXX + X * X
  Next i
  Slope = (N * SumXY - SumX * SumY) / (N * SumXX - SumX * SumX)
  YIntercept = (SumY * SumXX - SumX * SumXY) / (N * SumXX - SumX * SumX)
Exit Sub
Regress_Err:
ErrH App.ProductName & " code library", "Sub Regress"
Exit Sub
End Sub
