Attribute VB_Name = "LibMultimedia"
Option Explicit

Sub Play(ByVal FName As String)
On Error GoTo Play_Err
Dim wFlags As Integer, X As Integer

On Error Resume Next

wFlags = SND_ASYNC Or SND_NODEFAULT
X = sndPlaySound(FName, wFlags)

Exit Sub
Play_Err:
ErrH App.ProductName & " code library", "Sub Play"
Exit Sub
End Sub
Public Function CanPlaySound() As Integer
On Error GoTo CanPlaySound_Err

Dim i As Integer

   i = AUDIO_NONE
   
   If waveOutGetNumDevs > 0 Then
      i = AUDIO_WAVE
   End If
   
   If midiOutGetNumDevs > 0 Then
      i = i + AUDIO_MIDI
   End If
   
   CanPlaySound = i

Exit Function
CanPlaySound_Err:
ErrH App.ProductName & " code library", "Public Function CanPlaySound"
Exit Function

End Function
Public Function GetVolume(Optional rt As Variant, Optional lt As Variant, Optional audiotype As Variant) As Integer
On Error GoTo GetVolume_Err

Dim i As Long
   Dim k As Integer
   
   rt = 0
   lt = 0
   k = 0
   
   If IsMissing(audiotype) Then
      audiotype = AUDIO_MIDI + AUDIO_WAVE
   End If
   
   If (audiotype And AUDIO_MIDI) = AUDIO_MIDI Then
      midiOutGetVolume 0, i
      rt = ((i And &HFFFF0000) \ &HFFFF&) And &HFFFF&
      lt = i And &HFFFF&
      k = 1
   End If
   
   If (audiotype And AUDIO_WAVE) = AUDIO_WAVE Then
      waveOutGetVolume 0, i
      rt = rt + ((i And &HFFFF0000) / &H10000) And &HFFFF&
      lt = lt + (i And &HFFFF&)
      k = k + 1
   End If

   If k = 0 Then
      GetVolume = 0
   Else
      GetVolume = (rt + lt) / (k * 2)
      rt = rt / k
      lt = lt / k
   End If

Exit Function
GetVolume_Err:
ErrH App.ProductName & " code library", "Public Function GetVolume"
Exit Function

End Function
Public Sub SetVolume(ByVal rt As Integer, ByVal lt As Integer, Optional audiotype As Variant)
On Error GoTo SetVolume_Err

If IsMissing(audiotype) Then
      audiotype = AUDIO_MIDI + AUDIO_WAVE
   End If
   
   If (audiotype And AUDIO_MIDI) = AUDIO_MIDI Then
      midiOutSetVolume 0, (rt * &HFFFF&) + lt
   End If
   
   If (audiotype And AUDIO_WAVE) = AUDIO_WAVE Then
      waveOutSetVolume 0, (rt * &HFFFF&) + lt
   End If

Exit Sub
SetVolume_Err:
ErrH App.ProductName & " code library", "Public Sub SetVolume"
Exit Sub

End Sub
Public Function SoundPlay(FileName As String, Optional async As Variant, Optional sLoop As Variant) As Boolean
On Error GoTo SoundPlay_Err

Dim i As Integer
   Dim f As String
   Dim J As Long
         
   i = Len(FileName)
   f = UCase(FileName)
   
   If IsMissing(async) Then
      J = SND_ASYNC
   Else
      If async Then
         J = SND_ASYNC
      Else
         J = SND_SYNC
      End If
   End If
   
   If Not IsMissing(sLoop) Then
      If sLoop And (J = SND_ASYNC) Then
         J = J + SND_LOOP
      End If
   End If
   
   J = J + SND_NOSTOP + SND_NOWAIT
   
   If InStr(f, ".WAV") = i - 3 Then
      If CanPlaySound And AUDIO_WAVE = AUDIO_WAVE Then
         J = J + SND_FILENAME + SND_NODEFAULT
         i = PlaySound(FileName, 0, J)
         SoundPlay = IIf(i = 0, False, True)
      Else
         Beep
         SoundPlay = True
      End If
      
   'Assume media player for other file names   .MID .RMI etc..
   ElseIf InStr(f, ".") = i - 3 Then
      If CanPlaySound And AUDIO_MIDI = AUDIO_MIDI Then
         i = mciSendString("open " & FileName & " type sequencer ALIAS filename", 0&, 0, 0)
         'Note the true/false order is supposed to be opposite of the others.
         SoundPlay = IIf(i = 0, True, False)
         If (J And SND_ASYNC) = SND_ASYNC Then
            If (J And SND_LOOP) = SND_LOOP Then
               'Bug: repeat doesn't work.
               mciSendString "play filename repeat", 0&, 0, 0
            Else
               mciSendString "play filename", 0&, 0, 0
            End If
         Else
            mciSendString "play filename wait", 0&, 0, 0
            mciSendString "close filename", 0&, 0, 0
         End If
      Else
         Beep
         SoundPlay = True
      End If
   Else
      J = J + SND_ALIAS
      i = PlaySound(FileName, 0, J)
      SoundPlay = IIf(i = 0, False, True)
   End If

Exit Function
SoundPlay_Err:
ErrH App.ProductName & " code library", "Public Function SoundPlay"
Exit Function

End Function
Public Function SoundStop(Optional audiotype As Variant)
On Error GoTo SoundStop_Err

If IsMissing(audiotype) Then
      mciSendString "close filename", 0&, 0, 0
      SoundPlay vbNullString, 0, 0
   Else
      If (audiotype And AUDIO_MIDI) = AUDIO_MIDI Then
         mciSendString "close filename", 0&, 0, 0
      End If
      If (audiotype And AUDIO_WAVE) = AUDIO_WAVE Then
         SoundPlay vbNullString, 0, 0
      End If
   End If

Exit Function
SoundStop_Err:
ErrH App.ProductName & " code library", "Public Function SoundStop"
Exit Function

End Function
