Attribute VB_Name = "LibNetwork"
'**********************************************************
'               ServerTime
' Parmetros: nome do servidor (Ex: "\\ALFA")
' Retorno: Retorna uma Variant com a Hora/Data do servidor
'          passado como parmetro
'**********************************************************
Public Function ServerTime(ByVal pServerName As String) As Variant
Dim T As TIME_OF_DAY
Dim tPtr As Long
Dim Result As Long
Dim szServer As String
Dim ServDate As Date

'Converte o nome do servidor para UniCode
    If Left(pServerName, 2) = "\\" Then
    szServer = StrConv(pServerName, vbUnicode)
    
    Else
    szServer = StrConv("\\" & pServerName, vbUnicode)
    
    End If

Result = NetRemoteTOD(szServer, tPtr)

    If Result = 0 Then
    Call CopyMemory(T, ByVal tPtr, Len(T))  'Copia o ponteiro retornado para a estrutura TIME_OF_DAY
    ServDate = DateSerial(70, 1, 1) + (T.t_elapsedt / 60 / 60 / 24)
    ServDate = ServDate - (T.t_timezone / 60 / 24)  'ajusta de acordo com a regio
    NetApiBufferFree (tPtr) 'tira o ponteiro da memria
    ServerTime = ServDate 'retorna a hora do servidor para funo
    
    Else
    
        If Result = 53 Then mAPIErrName = "Cannot find server " & pServerName
    
    End If

End Function
'*******************************************************************
'                           PDC Name
'  Parmetros: Nenhum
'  Retorno: uma string que contm o Nome do Primary Domain Controller
'********************************************************************
Public Function PDCName() As String
Dim szServer   As String
Dim ptmpBuffer As Long
Dim sByte()    As Byte
Dim lGotNameOK As Long
Dim lBufferOK  As Long

'no retorna nada se a mquina no faz parte do domnio
lGotNameOK = NetGetDCName(vbNullString, vbNullString, ptmpBuffer)

    If lGotNameOK = 0 Then ' successo
    ReDim sByte(256)
    
    ' ptmpbuffer  um ponteiro que copia o contedo usando a API
    MoveMemory sByte(0), ptmpBuffer, 256
    
    ' tira o ponteiro da memria
    lBufferOK = NetApiBufferFree(ptmpBuffer)
    
    'pega o nome do servidor e o retorna a funo
    szServer = sByte
    szServer = szServer & vbNullChar
    PDCName = Left$(szServer, InStr(szServer, vbNullChar) - 1)
    
    Else
    PDCName = ""
    
    End If

End Function
Public Function EthernetAddress(LanaNumber As Long) As String
Dim udtNCB As NCB, bytResponse As Byte, udtASTAT As ASTAT, udtTempASTAT As ASTAT, lngASTAT As Long, strOut As String, X As Integer

udtNCB.ncb_command = NCBRESET
bytResponse = NetBios(udtNCB)
udtNCB.ncb_command = NCBASTAT
udtNCB.ncb_lana_num = LanaNumber
udtNCB.ncb_callname = "* "
udtNCB.ncb_length = Len(udtASTAT)
lngASTAT = HeapAlloc(GetProcessHeap(), HEAP_GENERATE_EXCEPTIONS Or HEAP_ZERO_MEMORY, udtNCB.ncb_length)
strOut = ""

    If lngASTAT Then
    udtNCB.ncb_buffer = lngASTAT
    bytResponse = NetBios(udtNCB)
    CopyMemory udtASTAT, udtNCB.ncb_buffer, Len(udtASTAT)
    
        With udtASTAT.adapt
        
            For X = 0 To 5
            If strOut <> "" Then strOut = strOut & "."
            strOut = strOut & Right$("00" & Hex$(.adapter_address(X)), 2)
            Next X
            
        End With
    
    HeapFree GetProcessHeap(), 0, lngASTAT
    
    End If

EthernetAddress = strOut

End Function
Public Function GetComputerName() As String
On Error GoTo GetComputerName_Err

Dim UserName As String * 255

Call GetComputerNameA(UserName, 255)
GetComputerName = Left$(UserName, InStr(UserName, Chr$(0)) - 1)

Exit Function
GetComputerName_Err:
ErrH App.ProductName & " code library", "Public Function GetComputerName"
Exit Function
End Function
Public Function GetUserName() As String
On Error GoTo GetUserName_Err

Dim UserName As String * 255

   Call GetUserNameA(UserName, 255)
   GetUserName = Left$(UserName, InStr(UserName, Chr$(0)) - 1)

Exit Function
GetUserName_Err:
ErrH App.ProductName & " code library", "Public Function GetUserName"
Exit Function
End Function
Public Function NetUserName() As String
On Error GoTo NetUserName_Err

Dim i As Long
   Dim UserName As String * 255

   i = WNetGetUser("", UserName, 255)
   
   If i = 0 Then
      NetUserName = Left$(UserName, InStr(UserName, Chr$(0)) - 1)
   Else
      NetUserName = ""
   End If

Exit Function
NetUserName_Err:
ErrH App.ProductName & " code library", "Public Function NetUserName"
Exit Function
End Function
Public Function NetUse(sLocalDevice As String, sShareName As String, Optional sUserID As Variant, Optional sPassword As Variant, Optional varPersistent As Variant) As WNetStatus
' The function accepts the following parameters:'
' sLocalDevice - a (case insensitive) string containing the local device to redirect (ie. "F:" or "LPT1"). If sLocalDevice is empty or is undefined/NULL, a connection to sShareName is made without redirecting a local device (ie. pipe/IPC$).
' sShareName - the UNC Name for the share to connect to. Must be in the format of "\\server\share"
' sUserID - optional, the User ID to login with (ie. "TAS01"). If it isn't passed, the User ID and password of the person currently logged in is used. (Actually the program is running in)
' sPassword - optional, the Password to login with. If it isn't passed, the User ID and password of the person currently logged in is used. (Actually the program is running in)
' varPersistent - must be passed True (-1) or False (0) to be considered. Default is True. If False, the connection remains until disconnected, or until the user is logged off.'

' The following (long datatype) result codes are returned:
' NO_ERROR(0) Drive sLocalDevice was mapped successfully to sShareName.
' ERROR_ACCESS_DENIED (5) Access to the network resource was denied.
' ERROR_ALREADY_ASSIGNED (85)The local device specified by sShareName is already connected to a network resource.
' ERROR_BAD_DEV_TYPE (66)The type of local device and the type of network resource do not match. '
' ERROR_BAD_DEVICE(1200) The value specified by sLocalDevice is invalid. '
' ERROR_BAD_NET_NAME (67)The value specified by sShareName is not acceptable to any network resource '
' provider. The resource name is invalid, or the named resource cannot be located.'
' ERROR_BAD_PROFILE(1206) The user profile is in an incorrect format. '
' ERROR_BAD_PROVIDER (1204) The default network provider is invalid.'
' ERROR_BUSY (170)The router or provider is busy, possibly initializing. The caller should retry. '
' ERROR_CANNOT_OPEN_PROFILE(1205) The system is unable to open the user profile to process persistent connections.'
' ERROR_DEVICE_ALREADY_REMEMBERED (1202) An entry for the device specified in sShareName is already in the user profile. '
' ERROR_EXTENDED_ERROR(1208) An unknown network-specific error occured. '
' ERROR_INVALID_PASSWORD (86)The password sPassword is invalid.
' ERROR_NO_NET_OR_BAD_PATH(1203) A network component has not started, or the specified name could not be handled.'
' ERROR_NO_NETWORK(1222) There is no network present.'
       
Dim netAddCxn As NETRESOURCE
Dim lCxnType As Long
Dim rc As Long
On Error GoTo ErrorHandler
'Identify the type of connection to make. If unidentified, then r
'eturn ERROR_BAD_DEVICE and exit the subroutine.
    If (sLocalDevice Like "[D-Z]:") Then lCxnType = RESOURCETYPE_DISK
    
'Network drive
    If (sLocalDevice Like "LPT[1-3]") Then lCxnType = RESOURCETYPE_PRINT 'Network printer

    If ((sLocalDevice = "") And (sShareName Like "\\*\IPC$")) Then
    lCxnType = RESOURCETYPE_ANY 'Pipe
    
    
        If ((Not sLocalDevice Like "[D-Z]:") And (Not sLocalDevice Like "LPT[1-3]") And ((Not sShareName Like "\\*\IPC$") And (Not sLocalDevice = ""))) Or (Not sShareName Like "\\*\*") Then
        NetUse = ERROR_BAD_DEVICE
        Exit Function
        End If
    
    'Handle varPersistent
    
        If IsMissing(varPersistent) Then
        varPersistent = CONNECT_UPDATE_PROFILE
        
        Else
    
            If varPersistent = False Then
            varPersistent = 0&
            
            Else
            varPersistent = CONNECT_UPDATE_PROFILE
            
            End If
    
    
        End If
    
    'Fill in the required members of netAddCxn
    
        With netAddCxn
        .dwType = RESOURCETYPE_DISK
        .lpLocalName = sLocalDevice
        .lpRemoteName = sShareName
        .lpProvider = Chr(0)
        End With
    
    'Perform the Net Use statement
    
        If IsMissing(sUserID) Or IsMissing(sPassword) Then
        rc = WNetAddConnection2(netAddCxn, sNull, sNull, varPersistent)
        
        Else
        rc = WNetAddConnection2(netAddCxn, sPassword, sUserID, varPersistent)
        
        End If
    
    
    'Process and return the result
    NetUse = rc
    'Handle Errors
    
    End If

Exit Function

ErrorHandler:
varTemp = MsgBox("Error #" & Err.number & Chr(10) & Err.Description, vbCritical)

End Function
Function GetMACAddress() As String

Dim lObj As New cls_Network

   Dim MACAdd(0 To 19) As String
   Dim i As Integer
   
   lObj.MAC_DoSearch
   
   For i = 0 To 19
      If lObj.MAC_Address(i) <> "" Then
        GetMACAddress = lObj.MAC_Address(i)
      End If
   Next

End Function
