Attribute VB_Name = "LibSystem"
Option Explicit

Private Const SE_PRIVILEGE_ENABLED = &H2
Private Const TH32CS_SNAPPROCESS As Long = 2&
Private Const TOKEN_ADJUST_PRIVILEGES = &H20
Private Const TOKEN_QUERY = &H8

Private Type LUID: UsedPart As Long: IgnoredForNowHigh32BitPart As Long: End Type
Private Type OSVERSIONINFO: dwOSVersionInfoSize As Long: dwMajorVersion As Long: dwMinorVersion As Long: dwBuildNumber As Long: dwPlatformId As Long: szCSDVersion As String * 128: End Type
Private Type PROCESSENTRY32: dwSize As Long: cntUsage As Long: th32ProcessID As Long: th32DefaultHeapID As Long: th32ModuleID As Long: cntThreads As Long: th32ParentProcessID As Long: pcPriClassBase As Long: dwFlags As Long: szExeFile As String * MAX_PATH: End Type
Private Type TOKEN_PRIVILEGES: PrivilegeCount As Long: TheLuid As LUID: Attributes As Long: End Type

Private Declare Function AdjustTokenPrivileges Lib "advapi32" (ByVal TokenHandle As Long, ByVal DisableAllPrivileges As Long, NewState As TOKEN_PRIVILEGES, ByVal BufferLength As Long, PreviousState As TOKEN_PRIVILEGES, ReturnLength As Long) As Long
Private Declare Function CreateToolhelp32Snapshot Lib "kernel32" (ByVal lFlags As Long, ByVal lProcessID As Long) As Long
Private Declare Function GetCurrentProcess Lib "kernel32" () As Long
Private Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hwnd As Long, lpdwProcessId As Long) As Long
Private Declare Function LookupPrivilegeValue Lib "advapi32" Alias "LookupPrivilegeValueA" (ByVal lpSystemName As String, ByVal lpName As String, lpLuid As LUID) As Long
Private Declare Function OpenProcessToken Lib "advapi32" (ByVal ProcessHandle As Long, ByVal DesiredAccess As Long, TokenHandle As Long) As Long
Private Declare Function ProcessFirst Lib "kernel32" Alias "Process32First" (ByVal hSnapShot As Long, uProcess As PROCESSENTRY32) As Long
Private Declare Function ProcessNext Lib "kernel32" Alias "Process32Next" (ByVal hSnapShot As Long, uProcess As PROCESSENTRY32) As Long
Private Declare Function TerminateProcess Lib "kernel32" (ByVal hProcess As Long, ByVal uExitCode As Long) As Long
Function RebootSystem() As Integer
On Error GoTo RebootSystem_Err

    Dim i As Integer
    Dim EW_REBOOTSYSTEM As Long
    EW_REBOOTSYSTEM = &H43
    i = ExitWindows(EW_REBOOTSYSTEM, 0)

Exit Function
RebootSystem_Err:
ErrH App.ProductName & " code library", "Function RebootSystem"
Exit Function
End Function
Function RestartWindows() As Integer
On Error GoTo RestartWindows_Err

Dim i As Integer
Dim EW_RESTARTWINDOWS As Long
EW_RESTARTWINDOWS = &H42
i = ExitWindows(EW_RESTARTWINDOWS, 0)

Exit Function
RestartWindows_Err:
ErrH App.ProductName & " code library", "Function RestartWindows"
Exit Function
End Function
Function GetWindowsVersion() As String
On Error GoTo GetWindowsVersion_Err

Dim x As Long
Dim y As String
Dim Z As Integer
Dim T As String
Dim HN As String
Dim LN As String

x = GetVersion()
x = x - 117440512     ' Don't need High Word returned for Windows version
T = Hex$(x)           ' Make the numeric value a Hexadecimal string
y = str$(Val(Right$(T, 2))) + "." ' Hold the MAJOR release # (ie  3.xx)
HN = MakeNybble(Left$(T, 1))
LN = MakeNybble(Mid$(T, 2, 1))
Z = DecimalValue(HN + LN)

If Z = 95 Then
GetWindowsVersion = "Windows 95"

Else
GetWindowsVersion = "Windows " & Trim(CStr(y + Trim$(str$(Z))))

End If

Exit Function
GetWindowsVersion_Err:
ErrH App.ProductName & " code library", "Function GetWindowsVersion"
Exit Function
End Function
Function MakeNybble(HexCharacter As String)
On Error GoTo MakeNybble_Err

'   This routine is called from the GetWindowsVersion routine
    Select Case Left$(HexCharacter, 1)
        Case "0": MakeNybble = "0000"
        Case "1": MakeNybble = "0001"
        Case "2": MakeNybble = "0010"
        Case "3": MakeNybble = "0011"
        Case "4": MakeNybble = "0100"
        Case "5": MakeNybble = "0101"
        Case "6": MakeNybble = "0110"
        Case "7": MakeNybble = "0111"
        Case "8": MakeNybble = "1000"
        Case "9": MakeNybble = "1001"
        Case "A": MakeNybble = "1010"
        Case "B": MakeNybble = "1011"
        Case "C": MakeNybble = "1100"
        Case "D": MakeNybble = "1101"
        Case "E": MakeNybble = "1110"
        Case "F": MakeNybble = "1111"
    End Select

Exit Function
MakeNybble_Err:
ErrH App.ProductName & " code library", "Function MakeNybble"
Exit Function
End Function
Private Function DecimalValue(BinaryByte As String) As Integer
On Error GoTo DecimalValue_Err

    Dim x As Integer
    Dim v As Integer
    Dim tmpVal As Integer
    
    v = 128
    For x = 1 To 8
        If Mid$(BinaryByte, x, 1) = "1" Then tmpVal = tmpVal + v
        v = v / 2
    Next x
    DecimalValue = tmpVal

Exit Function
DecimalValue_Err:
ErrH App.ProductName & " code library", "Function DecimalValue"
Exit Function
End Function
Sub ClipBoardApps(iChoice As Integer)
On Error GoTo ClipBoardApps_Err

If TypeOf Screen.ActiveControl Is TextBox Then
        
        Select Case iChoice
        
        Case 0          ' Cut.
        Clipboard.SetText Screen.ActiveControl.SelText
        Screen.ActiveControl.SelText = ""
        
        Case 1          ' Copy.
        Clipboard.SetText Screen.ActiveControl.SelText
        
        Case 2          ' Paste.
        Screen.ActiveControl.SelText = Clipboard.GetText()
        
        Case 3          ' Delete.
        Screen.ActiveControl.SelText = ""
        
        End Select
    
    End If

Exit Sub
ClipBoardApps_Err:
ErrH App.ProductName & " code library", "Sub ClipBoardApps"
Exit Sub
End Sub
Sub InstallFontFile(ByVal FileName As String)
On Error GoTo InstallFontFile_Err

Dim Result&

Result& = CreateScalableFontResource(0, App.Path & "\" & FileName & ".fot", FileName & ".ttf", App.Path)
Result& = AddFontResource(App.Path & "\" & FileName & ".fot")
Result& = WriteProfileString(App.Title, "Fonts", FileName, App.Path & "\" & FileName & ".fot")
Result& = SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0, 0&)

Exit Sub
InstallFontFile_Err:
ErrH App.ProductName & " code library", "Sub InstallFontFile"
Exit Sub
End Sub
Sub CloseWindows()
On Error GoTo CloseWindows_Err

ExitWindows EWX_LOGOFF, &HFFFFFFFF

Exit Sub
CloseWindows_Err:
ErrH App.ProductName & " code library", "Sub CloseWindows"
Exit Sub
End Sub
Sub InstallFont(ByVal FontName As String)
On Error GoTo InstallFont_Err

AddFontResource FontName

Exit Sub
InstallFont_Err:
ErrH App.ProductName & " code library", "Sub InstallFont"
Exit Sub
End Sub
Public Sub ShutdownNT()
AdjustToken
ExitWindowsEx (EWX_SHUTDOWN), &HFFFF
End Sub
Public Sub RebooTNT()
AdjustToken
ExitWindowsEx (EWX_REBOOT), &HFFFF
End Sub
Public Sub LogOffNT()
AdjustToken
ExitWindowsEx (EWX_FORCE), &HFFFF
End Sub
Private Sub AdjustToken()
Dim hdlProcessHandle As Long
Dim hdlTokenHandle As Long
Dim tmpLuid As LUID
Dim tkp As TOKEN_PRIVILEGES
Dim tkpNewButIgnored As TOKEN_PRIVILEGES
Dim lBufferNeeded As Long

hdlProcessHandle = GetCurrentProcess()
OpenProcessToken hdlProcessHandle, (TOKEN_ADJUST_PRIVILEGES Or _
TOKEN_QUERY), hdlTokenHandle

' Get the LUID for shutdown privilege.
LookupPrivilegeValue "", "SeShutdownPrivilege", tmpLuid

tkp.PrivilegeCount = 1    ' One privilege to set
tkp.TheLuid = tmpLuid
tkp.Attributes = SE_PRIVILEGE_ENABLED

' Enable the shutdown privilege in the access token of this process.
AdjustTokenPrivileges hdlTokenHandle, False, _
tkp, Len(tkpNewButIgnored), tkpNewButIgnored, lBufferNeeded

End Sub
Function ProcessTerminate(Optional lProcessID As Long, Optional lHwndWindow As Long) As Boolean
    Dim lhwndProcess As Long
    Dim lExitCode As Long
    Dim lRetVal As Long
    Dim lhThisProc As Long
    Dim lhTokenHandle As Long
    Dim tLuid As LUID
    Dim tTokenPriv As TOKEN_PRIVILEGES, tTokenPrivNew As TOKEN_PRIVILEGES
    Dim lBufferNeeded As Long
    
    Const PROCESS_ALL_ACCESS = &H1F0FFF, PROCESS_TERMINATE = &H1
    Const ANYSIZE_ARRAY = 1, TOKEN_ADJUST_PRIVILEGES = &H20
    Const TOKEN_QUERY = &H8, SE_DEBUG_NAME As String = "SeDebugPrivilege"
    Const SE_PRIVILEGE_ENABLED = &H2

    On Error Resume Next
    If lHwndWindow Then
        'Get the process ID from the window handle
        lRetVal = GetWindowThreadProcessId(lHwndWindow, lProcessID)
    End If
    
    If lProcessID Then
        'Give Kill permissions to this process
        lhThisProc = GetCurrentProcess
        
        OpenProcessToken lhThisProc, TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY, lhTokenHandle
        LookupPrivilegeValue "", SE_DEBUG_NAME, tLuid
        'Set the number of privileges to be change
        tTokenPriv.PrivilegeCount = 1
        tTokenPriv.TheLuid = tLuid
        tTokenPriv.Attributes = SE_PRIVILEGE_ENABLED
        'Enable the kill privilege in the access token of this process
        AdjustTokenPrivileges lhTokenHandle, False, tTokenPriv, Len(tTokenPrivNew), tTokenPrivNew, lBufferNeeded

        'Open the process to kill
        lhwndProcess = OpenProcess(PROCESS_TERMINATE, 0, lProcessID)
    
        If lhwndProcess Then
            'Obtained process handle, kill the process
            ProcessTerminate = CBool(TerminateProcess(lhwndProcess, lExitCode))
            Call CloseHandle(lhwndProcess)
        End If
    End If
    On Error GoTo 0
End Function
Function ProcessList() As String
    
Dim hSnapShot As Long
Dim uProcess As PROCESSENTRY32
Dim R As Long, lStrtemp As String

hSnapShot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0&)

    If hSnapShot = -1 Then Exit Function

uProcess.dwSize = Len(uProcess)
R = ProcessFirst(hSnapShot, uProcess)

    Do While R
    
    'List1.AddItem Hex$(uProcess.th32ProcessID) & "-" & uProcess.szExeFile
    lStrtemp = lStrtemp & IIf(lStrtemp <> "", vbCrLf, "") & _
    uProcess.th32ProcessID & "|" & uProcess.szExeFile & "|" & uProcess.cntThreads & "|" & uProcess.cntUsage & "|" & uProcess.dwSize
    R = ProcessNext(hSnapShot, uProcess)
    
    Loop

Call CloseHandle(hSnapShot)

End Function
Function GetProcessIDByEXEName(ByVal EXEName As String) As Long
    
Dim hSnapShot As Long
Dim uProcess As PROCESSENTRY32
Dim R As Long, lStrtemp As String

hSnapShot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0&)

    If hSnapShot = -1 Then Exit Function

uProcess.dwSize = Len(uProcess)
R = ProcessFirst(hSnapShot, uProcess)

    Do While R
    
        If InStr(UCase(uProcess.szExeFile), UCase(EXEName)) <> 0 Then
        GetProcessIDByEXEName = uProcess.th32ProcessID
        Call CloseHandle(hSnapShot)
        Exit Function
        End If
    
    R = ProcessNext(hSnapShot, uProcess)
    
    Loop

Call CloseHandle(hSnapShot)

End Function
Function GetProcessList() As String
Dim hSnapShot As Long
Dim uProcess As PROCESSENTRY32
Dim R As Long, lStrtemp As String
Dim uResults As String

hSnapShot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0&)

    If hSnapShot = -1 Then Exit Function

uProcess.dwSize = Len(uProcess)
R = ProcessFirst(hSnapShot, uProcess)

uResults = "*ProcessID|EXEFile|Threads|ParentProcessID|PriorityClassBase"
    Do While R
        
        With uProcess
        lStrtemp = .szExeFile
        
            If InStr(lStrtemp, Chr$(0)) <> 0 Then
            lStrtemp = Left$(lStrtemp, InStr(lStrtemp, Chr$(0)) - 1)
            End If
            
        uResults = uResults & vbCrLf & .th32ProcessID & "|" & lStrtemp & "|" & .cntThreads & "|" & .th32ParentProcessID & "|" & .pcPriClassBase
        
        R = ProcessNext(hSnapShot, uProcess)
        End With
    
    Loop

Call CloseHandle(hSnapShot)

GetProcessList = uResults

End Function
