Attribute VB_Name = "LibVariables"
Option Explicit
Option Compare Text
Function ShortMemText(ByVal uQuantity As String, Optional CutZeroes As Boolean = False) As String
On Error GoTo fShortMemTextErr 'EHCG.UID.fShortMemText

Dim uQtName(7) As String, uCounter As Byte, utempValue As String

uQtName(0) = "b"
uQtName(1) = "Kb"
uQtName(2) = "Mb"
uQtName(3) = "Gb"
uQtName(4) = "Tb"
uQtName(5) = "Pb"
uQtName(6) = "Ob"
uQtName(7) = "Nb"

    If uQuantity > 0 Then
    
        Do
    
            If uQuantity < (1024 ^ uCounter) Then
            uCounter = uCounter - 1
            Exit Do
            End If
    
        uCounter = uCounter + 1
        Loop
        
    End If

    If CutZeroes Then
    utempValue = CDbl(Format$(uQuantity / (1024 ^ uCounter), "0.##"))
    Else
    utempValue = Format$(CDbl(Format$(uQuantity / (1024 ^ uCounter), "0.##")), "0.00")
    End If
    

ShortMemText = utempValue & " " & uQtName(uCounter)

Exit Function
fShortMemTextErr:
Err.Raise Err.number, Err.Source, "f.ShortMemText (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Function
Function IsNullArray(Parms()) As Boolean
On Error Resume Next
Dim A As Long

A = UBound(Parms())

    If Err.number <> 0 Then
    IsNullArray = True
    End If

End Function

Public Sub Swap(ByRef Parm1, ByRef Parm2)
On Error GoTo Swap_Err

Dim c As Variant

c = Parm1
Parm1 = Parm2
Parm2 = c

Exit Sub
Swap_Err:
ErrH , "Public Sub Swap"
Exit Sub

End Sub
Function CountChars(ByVal OriginString As String, uChar As String) As Integer
Dim Counter As Integer, uMax As Integer

If OriginString = "" Then Exit Function

    For Counter = 1 To Len(OriginString)
    If Mid$(OriginString, Counter, 1) = uChar Then Inc uMax
    Next Counter
    
CountChars = uMax
    
End Function
Function File2String(ByVal uFile As String, Optional uControl As Control) As String
On Error GoTo File2String_Err

Dim Counter As Long, tmpVar As String * 8192, uFileHolder As String, _
uFree As Integer, uPart As Boolean, uPartSize As Integer, uLen As Long, _
tmpStr As String, uCount As Long, uMiss As Boolean, uBigCount As Byte
Dim uMaxLen As Long, uCantUseControl As Boolean

    uMiss = IsMissing(uControl)

uFree = FreeFile()
uLen = FileLen(uFile)

Open uFile For Random Access Read Lock Write As #uFree Len = 8192
    
    For Counter = 1 To Int(uLen / 8192) + 1
    
        If Not uMiss Then
        uBigCount = (uBigCount + 1) Mod 10
        
            If uBigCount = 1 Then
            
            uMaxLen = Int(((Counter * 8192) / uLen) * 100)
            If uMaxLen > 100 Then uMaxLen = 100
            
            If Not uCantUseControl Then uControl.Value = uMaxLen
            End If
        
        End If
        
        If Counter = Int(uLen / 8192) + 1 Then
        uPart = True
        uPartSize = uLen - (Counter - 1) * 8192
        
        Else
        uPart = False
        uPartSize = 8192
        
        End If
        
    Get #uFree, Counter, tmpVar
    tmpStr = tmpVar
    uFileHolder = uFileHolder + Left$(tmpStr, uPartSize)
    uCount = uCount + uPartSize
    
    Next Counter
    
If uCount = uLen Then File2String = uFileHolder

        If Not uMiss Then
        uControl.Value = 0
        End If

Exit Function
File2String_Err:

    If Err.number = 91 Then
    uCantUseControl = True
    Resume Next
    End If

ErrH App.ProductName & " code library", "Function File2String"
Exit Function

End Function
Public Function GetDateCode(Optional uDate As Date) As String

    If uDate = "00:00:00" Then uDate = Now()

GetDateCode = Format$(Year(uDate), "0000") & "." & _
Format$(Month(uDate), "00") & "." & _
Format$(Day(uDate), "00") & "." & _
Format$(Hour(uDate), "00") & "." & _
Format$(Minute(uDate), "00") & "." & _
Format$(Second(uDate), "00")

End Function

Function String2File(ByVal uFile As String, uContents As String) As Boolean
On Error GoTo String2File_Err

Dim uFree As Integer

uFree = FreeFile()

Open uFile For Output As #uFree
Print #1, uContents;
Close #1

String2File = True

Exit Function
String2File_Err:
ErrH App.ProductName & " code library", "Function String2File"
Exit Function

End Function

Function FixWidthText(ByVal uText As String, ByVal uSize As Long, Optional uUseDots As Boolean = False) As String
Dim uTmp As String

    If Len(uText) < uSize Then
    FixWidthText = uText & Space$(uSize - Len(uText))
        
    ElseIf Len(uText) = uSize Then
    FixWidthText = uText
    
    Else
    uText = Left$(uText, uSize)
    
        If uSize > 3 And uUseDots Then
        Mid$(uText, Len(uText) - 2, 3) = "..."
        End If
        
    FixWidthText = uText
    
    End If

End Function
Function ParseDataBlock(ByVal DATABlock As String, ByVal Index As Integer, Optional Char As String) As String
On Error GoTo ParseDataBlock_Err

Dim Counter As Integer, Mark1 As Integer, Mark2 As Integer, intBuffer As Integer, strBuffer As String

If Char = "" Then Char = Chr$(0)

    For Counter = 0 To Index
    intBuffer = InStr(Mid$(DATABlock, Mark2 + 1), Char)
    
        If intBuffer > 0 Then
        Mark2 = Mark2 + intBuffer + Len(Char) - 1
        strBuffer = Mid$(DATABlock, Mark1 + 1, (Mark2 - Mark1) - 1 - (Len(Char) - 1))
        Mark1 = Mark2

        Else
        strBuffer = Mid$(DATABlock, Mark1 + 1)
        Mark1 = Mark1 + Len(strBuffer)
        
        End If
            
    Next Counter

ParseDataBlock = strBuffer

Exit Function
ParseDataBlock_Err:
ErrH App.ProductName & " code library", "Function ParseDataBlock"
Exit Function
End Function

Sub AddString(ByRef N As String, ByVal M As String)

    If InStr(N, M) = 0 Then N = N & " " & M
    
End Sub


Function StripLine(ByVal OldText As String, Optional uChar As String, Optional StrippedLine As String, Optional IntrinsicSearch As String) As String

StrippedLine = ""

Dim uRes As Integer, Pointer As Long, uOutput As String
Dim ubAddedChar As Boolean

    If IntrinsicSearch <> "" Then
    Pointer = InStr(OldText, IntrinsicSearch)
    
        If Pointer = 0 Then
        StripLine = OldText
        Exit Function
        End If
        
    End If

    If uChar = "" Then
    'OldText = Replace(OldText, Chr$(13), Chr$(10))
    uChar = vbCrLf
    End If

    If Right$(OldText, 1) <> uChar Then
    OldText = OldText & uChar
    ubAddedChar = True
    End If

uRes = InStr(IIf(Pointer = 0, 1, Pointer), OldText, uChar)

    If uRes Then
    
        If Pointer <> 0 Then
        Pointer = Pointer - InStr(StrReverse(Left$(OldText, Pointer - 1)), uChar) - 1
        uOutput = Left$(OldText, Pointer)
        End If
    
        If Right$(uOutput, 1) <> uChar And Pointer <> 0 Then Add uOutput, uChar
    
    Add uOutput, Right$(OldText, Len(OldText) - (uRes + Len(uChar) - 1))
    
    StrippedLine = Mid$(OldText, IIf(Pointer <> 0, Pointer + 1, 1), uRes - (Pointer + (Len(uChar) - 1)))
    StrippedLine = Replace(StrippedLine, uChar, "")
    
    Else
    StrippedLine = OldText
    
    End If

'   If Left$(uOutput, 1) = Chr$(13) Or Left$(uOutput, 1) = Chr$(10) Then
'   uOutput = Right$(uOutput, Len(uOutput) - 1)
'   End If


    If ubAddedChar Then
        
        If Right$(uOutput, Len(uChar)) = uChar Then
        uOutput = Left$(uOutput, Len(uOutput) - Len(uChar))
        ubAddedChar = False
        End If
    
    End If

StripLine = uOutput

End Function
Function ValidDate(ByVal uParm1) As Date
On Error Resume Next

ValidDate = CVDate(uParm1)

End Function

Function xDate(Optional uDay As Byte, Optional uMonth As Byte, Optional uYear As Long) As Date
On Error GoTo PutDate_Err

Dim uIntlFlag As Boolean, tmpDate As Date

If uDay = 0 Then uDay = Day(Now)
If uMonth = 0 Then uMonth = Month(Now)
If uYear = 0 Then uYear = Year(Now)

tmpDate = Format$(uMonth, "00") & "/" & Format$(uDay, "00") & "/" & Format$(uYear, "0000")

uIntlFlag = (Month(tmpDate) <> uMonth)

    If uIntlFlag Then
    xDate = Format$(uDay, "00") & "/" & Format$(uMonth, "00") & "/" & Format$(uYear, "0000")

    Else
    xDate = Format$(uMonth, "00") & "/" & Format$(uDay, "00") & "/" & Format$(uYear, "0000")

    End If

Exit Function
PutDate_Err:
ErrH , "Function xDate"
Exit Function

End Function
Function BritishDate(Optional uDay As String) As Date
On Error GoTo BritishDate_Err

Dim uIntlFlag As Boolean, tmpDate1 As Date, tmpDate2 As Date, FakeDate As String
FakeDate = "1/10"

tmpDate1 = CVDate(uDay)
tmpDate2 = CVDate(FakeDate)

uIntlFlag = (Day(tmpDate2) = 10)

    If uIntlFlag Then
    BritishDate = Format$(Day(tmpDate1), "00") & "/" & Format$(Month(tmpDate1), "00") & "/" & Format$(Year(tmpDate1), "0000")

    Else
    BritishDate = tmpDate1

    End If

Exit Function
BritishDate_Err:
ErrH , "Function BritishDate"
Exit Function

End Function

Function SeparatePunctuation(ByVal uText As String) As String
Dim uTmp As String, Counter As Integer

    For Counter = 1 To Len(uText)
        If InStr(".,;:!?/-", Mid$(uText, Counter, 1)) <> 0 Then
        Add uTmp, " " & Mid$(uText, Counter, 1)
        
        Else
        Add uTmp, Mid$(uText, Counter, 1)
        
        End If
    Next Counter

SeparatePunctuation = uTmp

End Function


Function SwapDecVirg(ByVal numN As String) As String
On Error GoTo SwapDecVirg_Err

Dim Counter As Integer, lgt As Integer, tmpN As String

tmpN = numN
lgt = Len(tmpN)

    For Counter = 1 To lgt

        If Mid$(tmpN, Counter, 1) = "," Then
        Mid$(tmpN, Counter, 1) = "."
        
        ElseIf Mid$(tmpN, Counter, 1) = "." Then
        Mid$(tmpN, Counter, 1) = ","
        
        End If

    Next Counter

SwapDecVirg = tmpN

Exit Function
SwapDecVirg_Err:
ErrH App.ProductName & " code library", "Function SwapDecVirg"
Exit Function

End Function
Public Function GetToken(S As String, token As String, ByVal Nth As Integer) As String
On Error GoTo GetToken_Err

Dim I As Integer
   Dim P As Integer
   Dim R As Integer

   If Nth < 1 Then
      GetToken = ""
      Exit Function
   End If

   R = 0

   For I = 1 To Nth
      P = R
      R = InStr(P + 1, S, token)
      If R = 0 Then
         If I = Nth Then
            GetToken = Mid$(S, P + 1, Len(S) - P)
         Else
            GetToken = ""
         End If
         Exit Function
      End If
   Next I

   GetToken = Mid$(S, P + 1, R - P - 1)

Exit Function
GetToken_Err:
ErrH App.ProductName & " code library", "Public Function GetToken"
Exit Function

End Function
Public Function GetTokens(sTxt As String, sToken As String) As Variant
On Error GoTo GetTokens_Err

Dim iTokenLen As Integer
Dim iTokenCnt As Integer
Dim lOffset As Long
Dim lPrevOffset As Long
Dim aTokens() As String

iTokenLen = Len(sToken)
lOffset = InStr(sTxt, sToken)

    Do While lOffset > 0
    ReDim Preserve aTokens(iTokenCnt)
    
        If lOffset - lPrevOffset > 1 Then
        aTokens(iTokenCnt) = Mid$(sTxt, lPrevOffset + 1, lOffset - 1 - lPrevOffset)
        
        Else
        aTokens(iTokenCnt) = ""
        
        End If
    
    lPrevOffset = lOffset
    lOffset = InStr(lOffset + iTokenLen, sTxt, sToken)
    iTokenCnt = iTokenCnt + 1
    Loop

ReDim Preserve aTokens(iTokenCnt)
aTokens(iTokenCnt) = Mid$(sTxt, lPrevOffset + 1)
GetTokens = CVar(aTokens)

Exit Function
GetTokens_Err:
ErrH App.ProductName & " code library", "Public Function GetTokens"
Exit Function

End Function
Function Int2String(ByVal L As Double) As String
On Error GoTo Int2String_Err

Dim Tmp As String
   Dim str As String
   Dim I As Integer
   Dim J As Integer
   
   Tmp = Format(L, "000000000000")
   str = ""
   
   ' Opps... it's more than 999 trillion
   ' One could easily add bigger number
   ' support.
   If Len(Tmp) > 12 Then
      Int2String = ""
      Exit Function
   End If
   
   
   ' zero is a SPECial case.
   ' you may want to change this to "no"
   ' as in "no dollars and 12/100" for writing
   ' checks.
   
   If Val(Tmp) = 0 Then
      Int2String = "zero"
      Exit Function
   End If
   
   
   I = Val(Left$(Tmp, 3))
   If I <> 0 Then
      GoSub do_hundreds
      str = str + " trillion"
   End If
   
   I = Val(Mid$(Tmp, 4, 3))
   If I <> 0 Then
      GoSub do_hundreds
      str = str + " million"
   End If
   
   I = Val(Mid$(Tmp, 7, 3))
   If I <> 0 Then
      GoSub do_hundreds
      str = str + " thousand"
   End If
   
      
   I = Val(Right$(Tmp, 3))
   If I <> 0 Then
      GoSub do_hundreds
   End If
   
   Int2String = str
   Exit Function
   
   

do_hundreds:
   If I > 99 Then
      J = I
      I = I \ 100
      GoSub do_ones
      str = str + " hundred"
      I = J Mod 100
   End If

   If I <> 0 Then
      GoSub do_tens
   End If
   Return
   
do_tens:
   Select Case I Mod 100
      Case 90 To 99:
         str = str + " ninety"
         GoSub do_ones
      Case 80 To 89:
         str = str + " eighty"
         GoSub do_ones
      Case 70 To 79:
         str = str + " seventy"
         GoSub do_ones
      Case 60 To 69:
         str = str + " sixty"
         GoSub do_ones
      Case 50 To 59:
         str = str + " fifty"
         GoSub do_ones
      Case 40 To 49:
         str = str + " fourty"
         GoSub do_ones
      Case 30 To 39:
         str = str + " thirty"
         GoSub do_ones
      Case 20 To 29:
         str = str + " twenty"
         GoSub do_ones
         
      Case 19: str = str + " nineteen"
      Case 18: str = str + " eighteen"
      Case 17: str = str + " seventeen"
      Case 16: str = str + " sixteen"
      Case 15: str = str + " fifteen"
      Case 14: str = str + " fourteen"
      Case 13: str = str + " thirteen"
      Case 12: str = str + " twelve"
      Case 11: str = str + " eleven"
      Case 10: str = str + " ten"
      
      Case Else
         GoSub do_ones
   End Select
   Return
   
   
do_ones:
   If I < 10 Or I Mod 10 = 0 Then
      str = str + " "
   Else
      str = str + "-"
   End If
   
   Select Case I Mod 10
      Case 9: str = str + "nine"
      Case 8: str = str + "eight"
      Case 7: str = str + "seven"
      Case 6: str = str + "six"
      Case 5: str = str + "five"
      Case 4: str = str + "four"
      Case 3: str = str + "three"
      Case 2: str = str + "two"
      Case 1: str = str + "one"
   End Select
   
   Return

Exit Function
Int2String_Err:
ErrH App.ProductName & " code library", "Function Int2String"
Exit Function

End Function
Public Function IsStringAlpha(S As String) As Long
On Error GoTo IsStringAlpha_Err

Dim I As Long
   
   For I = 1 To Len(S)
      If IsCharAlpha(Asc(Mid$(S, I, 1))) = 0 Then
         IsStringAlpha = I
         Exit Function
      End If
   Next I
   
   IsStringAlpha = 0

Exit Function
IsStringAlpha_Err:
ErrH App.ProductName & " code library", "Public Function IsStringAlpha"
Exit Function

End Function
Public Function IsStringAlphaNumeric(S As String) As Long
On Error GoTo IsStringAlphaNumeric_Err

Dim I As Long
   
   For I = 1 To Len(S)
      If IsCharAlphaNumeric(Asc(Mid$(S, I, 1))) = 0 Then
         IsStringAlphaNumeric = I
         Exit Function
      End If
   Next I
   
   IsStringAlphaNumeric = 0

Exit Function
IsStringAlphaNumeric_Err:
ErrH App.ProductName & " code library", "Public Function IsStringAlphaNumeric"
Exit Function

End Function
Public Function IsStringNumeric(S As String) As Long
On Error GoTo IsStringNumeric_Err

Dim I As Long
   Dim J As Byte
   
   For I = 1 To Len(S)
      J = Asc(Mid$(S, I, 1))
      If IsCharAlphaNumeric(J) = 1 Then
         If IsCharAlpha(J) = 1 Then
            IsStringNumeric = I
            Exit Function
         End If
      Else
         IsStringNumeric = I
         Exit Function
      End If
   Next I
   
   IsStringNumeric = 0

Exit Function
IsStringNumeric_Err:
ErrH App.ProductName & " code library", "Public Function IsStringNumeric"
Exit Function

End Function
Public Function STrim(S As String) As String
On Error GoTo STrim_Err

Dim I As Integer
   Dim s2 As String
   
   s2 = Trim(S)
   I = InStr(s2, Chr$(0))
   
   If I > 0 Then
      s2 = Left$(s2, I - 1)
   End If
   
   STrim = s2

Exit Function
STrim_Err:
ErrH App.ProductName & " code library", "Public Function STrim"
Exit Function

End Function
Public Sub ShuffleArray(ByRef vArray As Variant, Optional startIndex As Variant, Optional endIndex As Variant)
On Error GoTo ShuffleArray_Err

Dim I As Long
Dim rndIndex As Long
Dim Temp As Variant

    If IsMissing(startIndex) Then
    startIndex = LBound(vArray)
    End If

    If IsMissing(endIndex) Then
    endIndex = UBound(vArray)
    End If

    For I = startIndex To endIndex
    rndIndex = Int((endIndex - startIndex + 1) * Rnd() + startIndex)
    
    Temp = vArray(I)
    vArray(I) = vArray(rndIndex)
    vArray(rndIndex) = Temp
    Next I

Exit Sub
ShuffleArray_Err:
ErrH App.ProductName & " code library", "Public Sub ShuffleArray"
Exit Sub

End Sub
Sub ClearNumKeyAscii(ByRef N As Integer, Optional UseDecimal As Boolean = False)
On Error GoTo ClearNumKeyAscii_Err

        If IsCharAlpha(N) Or InStr("!@#$%^&*(){}~`[];:'<>./?\|" & IIf(UseDecimal, "", ","), Chr$(N)) <> 0 Then N = 0

Exit Sub
ClearNumKeyAscii_Err:
ErrH App.ProductName & " code library", "Sub ClearNumKeyAscii"
Exit Sub

End Sub
Function FormatToMask(ByVal N As String) As String
On Error GoTo FormatToMask_Err

Dim M As String, Counter As Integer

N = Trim(N)

    For Counter = 1 To Len(N)
        
        If InStr("0123456789DMYNSH", UCase(Mid$(N, Counter, 1))) Then M = M + "#"
        If InStr(".,/\;':[]{}`~!@#$%^&*()_+-=", Mid$(N, Counter, 1)) Then M = M + "\" + Mid$(N, Counter, 1)
                
    Next Counter

Rem If Right$(M, 1) = "#" Then M = Left$(M, Len(M) - 1) + "0"

FormatToMask = M

Exit Function
FormatToMask_Err:
ErrH App.ProductName & " code library", "Function FormatToMask"
Exit Function

End Function
Function InvStr(ByVal strN As String) As String
On Error GoTo InvStr_Err

Dim Counter As Integer, Results As String, intLen As Integer

intLen = Len(strN)

    For Counter = 0 To intLen - 1
    Results = Results + Mid$(strN, intLen - Counter, 1)
    Next Counter
    
InvStr = Results

Exit Function
InvStr_Err:
ErrH App.ProductName & " code library", "Function InvStr"
Exit Function

End Function
Function CountCSVWords(ByVal S As String) As Integer
On Error GoTo CountCSVWords_Err

'
' Counts words in a string separated by commas
'
Dim WC As Integer, Pos As Integer
  If VarType(S) <> 8 Or Len(S) = 0 Then
    CountCSVWords = 0
    Exit Function
  End If
  WC = 1
  Pos = InStr(S, ",")
  Do While Pos > 0
    WC = WC + 1
    Pos = InStr(Pos + 1, S, ",")
  Loop
  CountCSVWords = WC

Exit Function
CountCSVWords_Err:
ErrH App.ProductName & " code library", "Function CountCSVWords"
Exit Function

End Function
Function CountWords(ByVal S As String) As Integer
On Error GoTo CountWords_Err

'
' Counts words in a string separated by 1 or more spaces
'
Dim WC As Integer, I As Integer, OnASpace As Integer
  If VarType(S) <> 8 Or Len(Trim(S)) = 0 Then
    CountWords = 0
    Exit Function
  End If
  WC = 0
  OnASpace = True
  For I = 1 To Len(S)
    If Mid(S, I, 1) = " " Then
      OnASpace = True
    Else
      If OnASpace Then
        OnASpace = False
        WC = WC + 1
      End If
    End If
  Next I
  CountWords = WC

Exit Function
CountWords_Err:
ErrH App.ProductName & " code library", "Function CountWords"
Exit Function

End Function
Function CutFirstWord(ByVal S As String, ByRef Remainder As String) As String
On Error GoTo CutFirstWord_Err

'
' CutWord: returns the first word in S.
' Remainder: returns the rest.
'
' Words are delimited by spaces
'
Dim Tmp, I As Integer, P As Integer
  Tmp = Trim(S)
  P = InStr(Tmp, " ")
  If P = 0 Then
    CutFirstWord = Tmp
    Remainder = ""
  Else
    CutFirstWord = Left(Tmp, P - 1)
    Remainder = Trim(Mid(Tmp, P + 1))
  End If

Exit Function
CutFirstWord_Err:
ErrH App.ProductName & " code library", "Function CutFirstWord"
Exit Function

End Function
Function CutLastWord(ByVal S As String, ByRef Remainder As String) As String
On Error GoTo CutLastWord_Err

' CutWord: returns the first word in S.
' Remainder: returns the rest.
'
' Words are delimited by spaces
'
Dim Tmp, I As Integer, P As Integer
  Tmp = Trim(S)
  P = 1
  For I = Len(Tmp) To 1 Step -1
    If Mid(Tmp, I, 1) = " " Then
      P = I + 1
      Exit For
    End If
  Next I
  If P = 1 Then
    CutLastWord = Tmp
    Remainder = Null
  Else
    CutLastWord = Mid(Tmp, P)
    Remainder = Trim(Left(Tmp, P - 1))
  End If

Exit Function
CutLastWord_Err:
ErrH App.ProductName & " code library", "Function CutLastWord"
Exit Function

End Function
Function CutWord(ByVal S As String, ByRef Remainder As String) As String
On Error GoTo CutWord_Err

'
' CutWord: returns the first word in S.
' Remainder: returns the rest.
'
Dim Tmp, P As Integer
  Tmp = Trim(S)
  P = InStr(Tmp, " ")
  If P = 0 Then P = Len(Tmp) + 1
  CutWord = Left(Tmp, P - 1)
  Remainder = Trim(Mid(Tmp, P + 1))

Exit Function
CutWord_Err:
ErrH App.ProductName & " code library", "Function CutWord"
Exit Function

End Function
Function GetCSVWord(ByVal S As String, Indx As Integer)
On Error GoTo GetCSVWord_Err

Dim WC As Integer, Count As Integer, SPos As Integer, EPos As Integer
  WC = CountCSVWords(S)
  If Indx < 1 Or Indx > WC Then
    GetCSVWord = Null
    Exit Function
  End If
  Count = 1
  SPos = 1
  For Count = 2 To Indx
    SPos = InStr(SPos, S, ",") + 1
  Next Count
  EPos = InStr(SPos, S, ",") - 1
  If EPos <= 0 Then EPos = Len(S)
  GetCSVWord = Mid(S, SPos, EPos - SPos + 1)

Exit Function
GetCSVWord_Err:
ErrH App.ProductName & " code library", "Function GetCSVWord"
Exit Function

End Function
Function GetWord(ByVal S As String, Indx As Integer)
On Error GoTo GetWord_Err

'
' Extracts a word in text where words are separated by 1 or more spaces
'
Dim I As Integer, WC As Integer, Count As Integer, SPos As Integer, EPos As Integer, OnASpace As Integer
  WC = CountWords(S)
  If Indx < 1 Or Indx > WC Then
    GetWord = Null
    Exit Function
  End If
  Count = 0
  OnASpace = True
  For I = 1 To Len(S)
    If Mid(S, I, 1) = " " Then
      OnASpace = True
    Else
      If OnASpace Then
        OnASpace = False
        Count = Count + 1
        If Count = Indx Then
          SPos = I
          Exit For
        End If
      End If
    End If
  Next I
  EPos = InStr(SPos, S, " ") - 1
  If EPos <= 0 Then EPos = Len(S)
  GetWord = Mid(S, SPos, EPos - SPos + 1)

Exit Function
GetWord_Err:
ErrH App.ProductName & " code library", "Function GetWord"
Exit Function

End Function
Function Like2(ByVal Text As String, ByVal Mask As String) As Integer
On Error GoTo Like2_Err

'
' This function does simple pattern matching.
' It allows the following wildcards:
'   # (digit)
'   ? (any character)
'   @ (alpha)
'
Dim Match As Integer, I As Integer, c As String * 1, MC As String * 1
  If Len(Text) <> Len(Mask) Then
    Match = False
  Else
    Match = True
    For I = 1 To Len(Mask)
      c = Mid(Text, I, 1)
      MC = Mid(Mask, I, 1)
      Select Case MC
        Case "#"  ' Match digit
          If c < "0" Or c > "9" Then
            Match = False
            Exit For
          End If
        Case "@"  ' Match A-Z
          If Not (c >= "A" And c <= "Z") And Not (c >= "a" And c <= "z") Then
            Match = False
            Exit For
          End If
        Case "?"  ' Match anything
        Case Else ' Exact match
          If c <> MC Then
            Match = False
            Exit For
          End If
      End Select
    Next I
  End If
  Like2 = Match

Exit Function
Like2_Err:
ErrH App.ProductName & " code library", "Function Like2"
Exit Function

End Function
Function LPad(ByVal S As String, ByVal c As String, N As Integer) As String
On Error GoTo LPad_Err

'
' Adds character C to the left of S to make it right justified
'
  If Len(c) = 0 Then c = " "
  If N < 1 Then
    LPad = ""
  Else
    LPad = Right$(String$(N, Left$(c, 1)) & S, N)
  End If

Exit Function
LPad_Err:
ErrH App.ProductName & " code library", "Function LPad"
Exit Function

End Function
Function ParseItemsToArray(ByVal S As String, A() As String, ByVal Delim As String, ByVal Compare As Integer) As Integer
On Error GoTo ParseItemsToArray_Err

'
' Function parses S, using delimiter Delim, and copies each element into array A().
' The function returns the number of items copied.
'
' Compare:
'   0 = Binary comparison     - can search for Tabs (chr$(9))
'   1 = Text comparison       - can't search for Tabs
'   2 = DATAbase comparison   - can't search for Tabs
'
' Calling convention:
'   ReDim Items(20)
'   ItemCount = ParseItemsToArray("A,B,C",Items(),Delim)
'
Dim P As Integer, I As Integer
'
' Check for valid delimiter
'
  If Delim = "" Then
    ParseItemsToArray = -1
    Exit Function
  End If
'
' Copy Items
'
  I = 0
  P = InStr(1, S, Delim, Compare)
  Do While P > 0
    A(LBound(A) + I) = Left$(S, P - 1)
    I = I + 1
    S = Mid$(S, P + 1)
    P = InStr(1, S, Delim, Compare)
  Loop
'
' Copy Last Item
'
  A(LBound(A) + I) = S
  I = I + 1
'
  ParseItemsToArray = I

Exit Function
ParseItemsToArray_Err:
ErrH App.ProductName & " code library", "Function ParseItemsToArray"
Exit Function

End Function
Function ReplaceStr(ByVal TextIn As String, ByVal SearchStr As String, ByVal Replacement As String, Optional CompMode As VbCompareMethod = vbBinaryCompare, Optional Tries As Long = -1, Optional CroppedString As String)
On Error GoTo ReplaceStr_Err

    If InStr(SearchStr, "*") <> 0 Then
    Dim SrchPtr As Currency, Pointer1 As Integer, Pointer2 As Integer, Counter As Long, uPart1 As String, uPart2 As String, uTmp As String
    
    uTmp = TextIn
    uPart1 = Left$(SearchStr, InStr(SearchStr, "*") - 1)
    uPart2 = Right$(SearchStr, Len(SearchStr) - (Len(uPart1) + 1))
    SrchPtr = 1
    
        Do While Not Counter = Tries
        Pointer1 = InStr(SrchPtr, uTmp, uPart1)
        
            If Pointer1 = 0 Then
            ReplaceStr = IIf(uTmp = "", TextIn, uTmp)
            Exit Function
            
            Else
            Pointer2 = InStr(Pointer1, uTmp, uPart2)
            
                If Pointer2 = 0 Then
                ReplaceStr = uTmp
                Exit Function
                
                Else
                SrchPtr = Len(Left$(uTmp, Pointer1) & Replacement) + 1
                CroppedString = Mid$(uTmp, Pointer1, Pointer2 - IIf(Pointer1 = 0, 2, Pointer1 - Len(uPart2)))
                uTmp = Left$(uTmp, Pointer1 - 1) & Replacement & Right$(uTmp, Len(uTmp) - (Pointer2 + Len(uPart2) - 1))
                
                End If

            End If
        
        Inc Counter
        Loop
        
    Else
    uTmp = Replace(TextIn, SearchStr, Replacement, , , CompMode)
    
    End If

ReplaceStr = IIf(uTmp = "", TextIn, uTmp)

Exit Function
ReplaceStr_Err:
ErrH App.ProductName & " code library", "Function ReplaceStr"
Exit Function

End Function
Function GetMonthNum(ByVal uStr As String) As Byte

Const uMnt = "JANFEBMARAPRMAYJUNJULAUGSEPOCTNOVDEC"
GetMonthNum = (InStr(1, uMnt, uStr, vbTextCompare) / 3) + 1

End Function

Function RPad(ByVal S As String, ByVal c As String, N As Integer) As String
On Error GoTo RPad_Err

'
' Adds character C to the right of S to make it left justified
'
  If Len(c) = 0 Then c = " "
  If N < 1 Then
    RPad = ""
  Else
    RPad = Left$(S & String$(N, Left$(c, 1)), N)
  End If

Exit Function
RPad_Err:
ErrH App.ProductName & " code library", "Function RPad"
Exit Function

End Function
Function LowerCC()
On Error GoTo LowerCC_Err

' Converts the current control to lower case
  Screen.ActiveControl = LCase(Screen.ActiveControl)

Exit Function
LowerCC_Err:
ErrH App.ProductName & " code library", "Function LowerCC"
Exit Function

End Function
Sub ParseCSZ(ByVal S As String, City As String, State As String, Zip As String)
On Error GoTo ParseCSZ_Err

'
' Parses address "New York NY 00123" into separate fields.
' Supports the following formats:
'   New York NY 12345-9876
'   Pierre, North Dakota 45678-7654
'   San Diego, CA, 98765-4321
'
' Words are extracted in the following order if no commas are found to delimit the values:
'   Zip, State, City
'
Dim P As Integer
'
' Check for comma after city name
'
  P = InStr(S, ",")
  If P > 0 Then
    City = Trim$(Left$(S, P - 1))
    S = Trim$(Mid$(S, P + 1))
'
'   Check for comma after state
'
    P = InStr(S, ",")
    If P > 0 Then
      State = Trim$(Left$(S, P - 1))
      Zip = Trim$(Mid$(S, P + 1))
    Else                           ' No comma between state and zip
      Zip = CutLastWord(S, S)
      State = S
    End If
  Else                             ' No commas between city, state, or zip
    Zip = CutLastWord(S, S)
    State = CutLastWord(S, S)
    City = S
  End If
'
' Clean up any dangling commas
'
  If Right$(State, 1) = "," Then
    State = Left$(State, Len(State) - 1)
  End If
  If Right$(City, 1) = "," Then
    City = Left$(City, Len(City) - 1)
  End If

Exit Sub
ParseCSZ_Err:
ErrH App.ProductName & " code library", "Sub ParseCSZ"
Exit Sub

End Sub
Sub ParseName(ByVal S As String, Title As String, FName As String, MName As String, LName As String, Pedigree As String, Degree As String)
On Error GoTo ParseName_Err

'
' Parses name "Mr. Bill A. Jones III, PhD" into separate fields.
' Words are extracted in the following order: Title, Degree, Pedigree, LName, FName, MName
' Assumes Pedigree is not preceded by a comma, or else it will end up with the Degree(s).
'
Dim Word As String, P As Integer, Found As Integer
Const Titles = "Mr.Mrs.Ms.Dr.Mme.Mssr.Mister,Miss,Doctor,Sir,Lord,Lady,Madam,Mayor,President"
Const Pedigrees = "Jr.Sr.III,IV,VIII,IX,XIII"
  Title = ""
  FName = ""
  MName = ""
  LName = ""
  Pedigree = ""
  Degree = ""
'
' Get Title
'
  Word = CutWord(S, S)
  If InStr(Titles, Word) Then
    Title = Word
  Else
    S = Word & " " & S
  End If
'
' Get Degree
'
  P = InStr(S, ",")
  If P > 0 Then
    Degree = Trim$(Mid$(S, P + 1))
    S = Trim$(Left$(S, P - 1))
  End If
'
' Get Pedigree
'
  Word = CutLastWord(S, S)
  If InStr(Pedigrees, Word) Then
    Pedigree = Word
  Else
    S = S & " " & Word
  End If
'
' Get Last Name
'
  LName = CutLastWord(S, S)
'
' Get First Name
'
  FName = CutWord(S, S)
'
' Get Middle Name(s)
'
  MName = Trim(S)

Exit Sub
ParseName_Err:
ErrH App.ProductName & " code library", "Sub ParseName"
Exit Sub

End Sub
Function Proper(ByVal X As String)
On Error GoTo Proper_Err

'  Capitalize first letter of every word in a field.
'  Use in an event procedure in AfterUpdate of control;
'  for example, [Last Name] = Proper([Last Name]).
'  Names such as O'Brien and Wilson-Smythe are properly capitalized,
'  but MacDonald is changed to Macdonald, and van Buren to Van Buren.
'  Note: For this function to work correctly, you must SPECify
'  Option Compare DATAbase in the Declarations section of this module.
Dim Tmp$, c$, OldC$, I As Integer
  If IsNull(X) Then
    Exit Function
  Else
    Tmp$ = CStr(LCase(X))
    '  Initialize OldC$ to a single space because first
    '  letter needs to be capitalized but has no preceding letter.
    OldC$ = " "
    For I = 1 To Len(Tmp$)
      c$ = Mid$(Tmp$, I, 1)
      If c$ >= "a" And c$ <= "z" And (OldC$ < "a" Or OldC$ > "z") Then
        Mid$(Tmp$, I, 1) = UCase$(c$)
      End If
      OldC$ = c$
    Next I
    Proper = Tmp$
  End If

Exit Function
Proper_Err:
ErrH App.ProductName & " code library", "Function Proper"
Exit Function

End Function
Function ProperCC()
On Error GoTo ProperCC_Err

' Applies the Proper function to the current control
  Screen.ActiveControl = Proper(Screen.ActiveControl)

Exit Function
ProperCC_Err:
ErrH App.ProductName & " code library", "Function ProperCC"
Exit Function

End Function
Function ProperWord(N)
On Error GoTo ProperWord_Err

'
' Assumes N contains a single word
' N: can be null
'
  ProperWord = UCase(Left(Trim(N), 1)) & LCase(Mid(Trim(N), 2))

Exit Function
ProperWord_Err:
ErrH App.ProductName & " code library", "Function ProperWord"
Exit Function

End Function
Function StripChars(ByVal parm As String, CharsToStrip As String) As String
On Error GoTo StripChars_Err

Dim M As String, Counter As Integer

    For Counter = 1 To Len(parm)
    If InStr(CharsToStrip, Mid$(parm, Counter, 1)) = 0 Then M = M + Mid$(parm, Counter, 1)
    Next Counter
    
StripChars = M

Exit Function
StripChars_Err:
ErrH App.ProductName & " code library", "Function StripChars"
Exit Function

End Function
Function StrToHex(S As Variant) As Variant
On Error GoTo StrToHex_Err

'
' Converts a string to a series of hexadecimal digits.
' Useful if you want a true ASCII sort in your query.
'
' StrToHex(Chr(9) & "A~") returns "09417E"
'
Dim Tmp As String, I As Integer
  If VarType(S) <> 8 Then
    StrToHex = S
  Else
    Tmp = ""
    For I = 1 To Len(S)
      Tmp = Tmp & Format(Hex(Asc(Mid(S, I, 1))), "00")
    Next I
    StrToHex = Tmp
  End If

Exit Function
StrToHex_Err:
ErrH App.ProductName & " code library", "Function StrToHex"
Exit Function

End Function
Function UpperCC()
On Error GoTo UpperCC_Err

' Converts the current control to upper case
  Screen.ActiveControl = UCase(Screen.ActiveControl)

Exit Function
UpperCC_Err:
ErrH App.ProductName & " code library", "Function UpperCC"
Exit Function

End Function
Function GetDateAdvance(ByVal TimeAmount As Integer, ByVal TimeID As Integer) As Date
On Error GoTo GetDateAdvance_Err

    Select Case TimeID
    Case 1
    GetDateAdvance = DateAdd("d", TimeAmount, Now())
    
    Case 2
    GetDateAdvance = DateAdd("m", TimeAmount, Now())
    
    Case 3
    GetDateAdvance = DateAdd("yyyy", TimeAmount, Now())
    
    End Select

Exit Function
GetDateAdvance_Err:
ErrH App.ProductName & " code library", "Function GetDateAdvance"
Exit Function

End Function
Function PurgeNumericInput(ByVal StringVal As Variant) As Variant
On Error GoTo PurgeNumericInput_Err

On Local Error Resume Next
Dim X As Integer
Dim WorkString As String

    If Len(Trim(StringVal)) = 0 Then Exit Function

    For X = 1 To Len(StringVal)
    
        Select Case Mid(StringVal, X, 1)
        Case "0" To "9", "."
        WorkString = WorkString + Mid(StringVal, X, 1)
        End Select
        
    Next X
    
PurgeNumericInput = WorkString

Exit Function
PurgeNumericInput_Err:
ErrH App.ProductName & " code library", "Function PurgeNumericInput"
Exit Function

End Function
Function PurgeString(Partial As String, Whole As String) As String
On Error GoTo PurgeString_Err

'   This routine will search the <Whole> text string for the first
'   occurence of <Partial>.  If it is found, it will be removed from
'   the string.

    On Error Resume Next
    PurgeString = ""
    If Len(Partial) < 1 Then Exit Function
    If Len(Whole) < 1 Then Exit Function
    Dim X As Integer
    Dim WorkStr As String
    WorkStr = Whole
    Do
        X = InStr(WorkStr, Partial)
        If X = 0 Then Exit Do
        WorkStr = Left(WorkStr, X - 1) + Mid(WorkStr, X + Len(Partial))
    Loop
    PurgeString = WorkStr

Exit Function
PurgeString_Err:
ErrH App.ProductName & " code library", "Function PurgeString"
Exit Function

End Function
Function FullDate(ByVal RawDate As Date) As String
On Error GoTo FullDate_Err

ReDim dia(7) As String
ReDim Mes(12) As String
Dim A As String

dia(1) = "Domingo"
dia(2) = "Segunda feira"
dia(3) = "Tera feira"
dia(4) = "Quarta feira"
dia(5) = "Quinta feira"
dia(6) = "Sexta feira"
dia(7) = "Sbado"

Mes(1) = "Janeiro"
Mes(2) = "Fevereiro"
Mes(3) = "Maro"
Mes(4) = "Abril"
Mes(5) = "Maio"
Mes(6) = "Junho"
Mes(7) = "Julho"
Mes(8) = "Agosto"
Mes(9) = "Setembro"
Mes(10) = "Outubro"
Mes(11) = "Novembro"
Mes(12) = "Dezembro"

FullDate = dia(Weekday(RawDate)) & ", " & Day(RawDate) & " de " & Mes(Month(RawDate)) & " de " & Year(RawDate)

Exit Function
FullDate_Err:
ErrH App.ProductName & " code library", "Function FullDate"
Exit Function

End Function
Function SQLDate(ByVal RawDate As Date) As String
On Error GoTo SQLDate_Err

SQLDate = "#" & Month(RawDate) & "/" & Day(RawDate) & "/" & Year(RawDate) & IIf(Hour(RawDate) + Minute(RawDate) + Second(RawDate) <> 0, " " & Hour(RawDate) & ":" & Minute(RawDate) & ":" & Second(RawDate), "") & "#"

Exit Function
SQLDate_Err:
ErrH App.ProductName & " code library", "Function SQLDate"
Exit Function

End Function
Function NumberToString(ByVal RawValue As String, Optional uGenderMale As Boolean = True) As String
On Error GoTo NumberToString_Err

Dim Buffer As String, _
Unit(20, 1) As String, _
DecUnit(10) As String, _
HundrUnit(10, 1) As String, _
Clausules(8, 1) As String, _
InnerCounter As Byte, _
NumBuff As Integer, _
FlagHundred As Boolean, _
StringBuff As String

RawValue = Trim(RawValue)

    If Val(RawValue) = 0 Then
    NumberToString = "Zero"
    Exit Function
    End If


    Do
    
        If Not Left$(RawValue, 1) = "0" Then Exit Do
        
    RawValue = Right$(RawValue, Len(RawValue) - 1)
    Loop

Unit(1, 0) = "um"
Unit(2, 0) = "dois"
Unit(3, 0) = "trs"
Unit(4, 0) = "quatro"
Unit(5, 0) = "cinco"
Unit(6, 0) = "seis"
Unit(7, 0) = "sete"
Unit(8, 0) = "oito"
Unit(9, 0) = "nove"
Unit(10, 0) = "dez"
Unit(11, 0) = "onze"
Unit(12, 0) = "doze"
Unit(13, 0) = "treze"
Unit(14, 0) = "quatorze"
Unit(15, 0) = "quinze"
Unit(16, 0) = "dezesseis"
Unit(17, 0) = "dezessete"
Unit(18, 0) = "dezoito"
Unit(19, 0) = "dezenove"

Unit(1, 1) = "uma"
Unit(2, 1) = "duas"

DecUnit(1) = "dez"
DecUnit(2) = "vinte"
DecUnit(3) = "trinta"
DecUnit(4) = "quarenta"
DecUnit(5) = "cinquenta"
DecUnit(6) = "sessenta"
DecUnit(7) = "setenta"
DecUnit(8) = "oitenta"
DecUnit(9) = "noventa"

HundrUnit(0, 0) = "cem":          HundrUnit(0, 1) = "cem"
HundrUnit(1, 0) = "cento":        HundrUnit(1, 1) = "cento"
HundrUnit(2, 0) = "duzentos":      HundrUnit(2, 1) = "duzentas"
HundrUnit(3, 0) = "trezentos":     HundrUnit(3, 1) = "trezentas"
HundrUnit(4, 0) = "quatrocentos":  HundrUnit(4, 1) = "quatrocentas"
HundrUnit(5, 0) = "quinhentos":    HundrUnit(5, 1) = "quinhentas"
HundrUnit(6, 0) = "seiscentos":    HundrUnit(6, 1) = "seiscentas"
HundrUnit(7, 0) = "setecentos":    HundrUnit(7, 1) = "setecentas"
HundrUnit(8, 0) = "oitocentos":    HundrUnit(8, 1) = "oitocentas"
HundrUnit(9, 0) = "novecentos":    HundrUnit(9, 1) = "novecentas"

Clausules(1, 0) = "mil"
Clausules(1, 1) = "mil"
Clausules(2, 0) = "milho"
Clausules(2, 1) = "milhes"
Clausules(3, 0) = "bilho"
Clausules(3, 1) = "bilhes"
Clausules(4, 0) = "trilho"
Clausules(4, 1) = "trilhes"
Clausules(5, 0) = "quatrilho"
Clausules(5, 1) = "quatrilhes"
Clausules(6, 0) = "quintilho"
Clausules(6, 1) = "quintilhes"
Clausules(7, 0) = "sextilho"
Clausules(7, 1) = "sextilhes"
Clausules(8, 0) = "septilho"
Clausules(8, 1) = "septilhes"

Do

    If (Len(RawValue) - InnerCounter * 3) <= 0 Then Exit Do

NumBuff = Val(Mid$("00" & RawValue, 1 + Len("00" & RawValue) - ((InnerCounter + 1) * 3), 3))
Inc InnerCounter

    If NumBuff Mod 100 Then
        If NumBuff Mod 100 < 20 Then
        StringBuff = Unit(NumBuff Mod 100, 0)
        Else
            If NumBuff Mod 10 Then StringBuff = Unit(NumBuff Mod 10, 0)
            If (Int(NumBuff / 10) Mod 10) Then StringBuff = IIf(StringBuff = "", DecUnit(Int(NumBuff / 10) Mod 10), DecUnit(Int(NumBuff / 10) Mod 10) & " e " & StringBuff)
        End If
    End If
        
    If Int(NumBuff / 100) Then StringBuff = IIf(StringBuff <> "", HundrUnit(Int(NumBuff / 100), Abs(Not uGenderMale)) & " e " & StringBuff, IIf(Int(NumBuff / 100) = 1, HundrUnit(0, Abs(Not uGenderMale)), HundrUnit(Int(NumBuff / 100), Abs(Not uGenderMale))))

If NumBuff <> 0 Then Buffer = IIf(Buffer <> "", StringBuff & " " & Clausules(InnerCounter - 1, IIf(NumBuff = 1, 0, 1)) & ", " & Buffer, StringBuff & " " & Clausules(InnerCounter - 1, IIf(NumBuff = 1, 0, 1)))

Loop

Buffer = Trim(Buffer)

Buffer = UCase(Left$(Buffer, 1)) + Right$(Buffer, Len(Buffer) - 1)

NumberToString = Buffer

Exit Function
NumberToString_Err:
ErrH App.ProductName & " code library", "Function NumberToString"
Exit Function

End Function
Function ValidNum(ByRef A)
On Error GoTo ValidNum_Err

If IsNull(A) Then ValidNum = 0 Else ValidNum = Val(Replace(Replace(A, ".", ""), ",", "."))

Exit Function
ValidNum_Err:
ErrH App.ProductName & " code library", "Function ValidNum"
Exit Function

End Function
Function ValidStr(ByVal A)
On Error GoTo ValidStr_Err

If Not IsNull(A) Then ValidStr = A Else ValidStr = ""

Exit Function
ValidStr_Err:
ErrH App.ProductName & " code library", "Function ValidStr"
Exit Function

End Function
Function CutSpaces(ByVal Texto As String, Optional UseUnderscore As Boolean = False) As String
On Error GoTo CutSpaces_Err

Dim X As Integer, Buffer As String

Buffer = Trim(Texto)

    Do
    X = InStr(Buffer, " ")
        If X = 0 Then Exit Do
        
    Buffer = Left$(Buffer, X - 1) & IIf(UseUnderscore, "_", "") & Trim(Right$(Buffer, Len(Buffer) - (X)))
    
    Loop

Buffer = Trim(Buffer)

CutSpaces = Buffer

Exit Function
CutSpaces_Err:
ErrH App.ProductName & " code library", "Function CutSpaces"
Exit Function

End Function
Function ClearSpaces(ByVal Texto As String) As String
On Error GoTo ClearSpaces_Err

Dim X As Integer, Buffer As String

Buffer = Texto

    Do
    X = InStr(Buffer, "  ")
        If X = 0 Then Exit Do
        
    Buffer = Left$(Buffer, X - 1) & " " & Right$(Buffer, Len(Buffer) - (X + 1))
    
    Loop

Buffer = Trim(Buffer)

ClearSpaces = Buffer

Exit Function
ClearSpaces_Err:
ErrH App.ProductName & " code library", "Function ClearSpaces"
Exit Function

End Function

Function NameFormat(ByVal Texto As String) As String
On Error GoTo NameFormat_Err

Texto = ClearSpaces(Texto)

Dim Counter As Integer

    For Counter = 1 To Len(Texto)
    
        Select Case Counter
        
        Case 1
        Mid$(Texto, Counter, 1) = UCase(Mid$(Texto, Counter, 1))
        
        Case Is > 1
            If Mid$(Texto, Counter - 1, 1) = " " Then
            Mid$(Texto, Counter, 1) = UCase(Mid$(Texto, Counter, 1))
            Else
            Mid$(Texto, Counter, 1) = LCase(Mid$(Texto, Counter, 1))
            End If
                    
            If Counter > 3 Then
            
                If Mid$(Texto, Counter - 2, 1) = " " And Mid$(Texto, Counter, 1) = " " Then
                Mid$(Texto, Counter - 1, 1) = LCase(Mid$(Texto, Counter - 1, 1))
                End If
                
                If Mid$(Texto, Counter - 3, 1) = " " And Mid$(Texto, Counter, 1) = " " Then
                Mid$(Texto, Counter - 2, 1) = LCase(Mid$(Texto, Counter - 2, 1))
                End If
                
            End If
        
        End Select
    
    Next Counter

NameFormat = Texto

Exit Function
NameFormat_Err:
ErrH App.ProductName & " code library", "Function NameFormat"
Exit Function

End Function
Function FixDP(ByVal number, ByVal NumOfDecPlaces As Integer)
On Error GoTo FixDP_Err

FixDP = Int((number + 5 * (10 ^ (-1 * (NumOfDecPlaces + 1)))) * (10 ^ NumOfDecPlaces)) / (10 ^ NumOfDecPlaces)

Exit Function
FixDP_Err:
ErrH App.ProductName & " code library", "Function FixDP"
Exit Function

End Function
Sub Inc(ByRef Value)
On Error GoTo Inc_Err

Value = Value + 1

Exit Sub
Inc_Err:
ErrH App.ProductName & " code library", "Sub Inc"
Exit Sub

End Sub
Sub Dec(ByRef Value)
On Error GoTo Dec_Err

Value = Value - 1

Exit Sub
Dec_Err:
ErrH App.ProductName & " code library", "Sub Dec"
Exit Sub

End Sub
Function GetTimeCode()
On Error GoTo GetTimeCode_Err

GetTimeCode = Format(Year(Now), "00") & Format(Month(Now), "00") & Format(Day(Now), "00") & Format(Hour(Now), "00") & Format(Minute(Now), "00") & Format(Second(Now), "00")

Exit Function
GetTimeCode_Err:
ErrH App.ProductName & " code library", "Function GetTimeCode"
Exit Function

End Function
Function AssembleSQL(SQL As SQLPattern, Optional U_FROM As String, Optional U_WHERE As String, Optional utopSpec As String) As String
On Error GoTo AssembleSQL_Err

Dim Dummy As String, OtherFROM As String, OtherWHERE As String

    If U_WHERE <> "" Then
        If SQL.Where = "" Then
            If Trim(UCase(Left$(U_WHERE, 5))) = "AND" Then
            OtherWHERE = Right$(U_WHERE, Len(U_WHERE) - 5)
            
            Else
            OtherWHERE = U_WHERE
            
            End If
            
       Else
       
            If Trim(UCase(Left$(U_WHERE, 5))) <> "AND" Then
            OtherWHERE = " AND " & U_WHERE
        
            Else
            OtherWHERE = U_WHERE
            
            End If
        
        End If
        
    End If

Dummy = "SELECT " & IIf(utopSpec <> "", utopSpec & " ", "") & _
SQL.Select & " FROM " & SQL.from & U_FROM
Dummy = Dummy & IIf(Exists(SQL.Where) Or Exists(OtherWHERE), " WHERE " & SQL.Where & OtherWHERE, "")
Dummy = Dummy & IIf(Exists(SQL.Group), " GROUP " & SQL.Group, "")
Dummy = Dummy & IIf(Exists(SQL.Having), " HAVING " & SQL.Having, "")
Dummy = Dummy & IIf(Exists(SQL.Order), " ORDER BY " & SQL.Order, "")
If Not InStr(Dummy, ";") Then Dummy = Dummy & ";" 'SQL Format Security

AssembleSQL = Dummy

Exit Function
AssembleSQL_Err:
ErrH App.ProductName & " code library", "Function AssembleSQL"
Exit Function

End Function
Function Exists(ByVal parm As Variant) As Boolean
On Error GoTo Exists_Err

    Select Case VarType(parm)
    
    Case 0 To 1
    Exists = False
    Exit Function
    
    Case 2 To 6
        If parm = 0 Then
        Exists = False
        Exit Function
        End If
    
    Case 7 To 8
    
        If parm = "" Then
        Exists = False
        Exit Function
        End If
    
    End Select

Exists = True

Exit Function
Exists_Err:
ErrH App.ProductName & " code library", "Function Exists"
Exit Function

End Function
Function GetDateDifference(ByVal TimeAmount As Date, TimeID As Integer) As String
On Error GoTo GetDateDifference_Err

    Select Case TimeID
    Case 1
    GetDateDifference = DateDiff("d", Now(), TimeAmount) & " dia(s)"
    
    Case 2
    GetDateDifference = DateDiff("m", Now(), TimeAmount) & " mes(es)"
    
    Case 3
    GetDateDifference = DateDiff("yyyy", Now(), TimeAmount) & " ano(s)"
    
    End Select

Exit Function
GetDateDifference_Err:
ErrH App.ProductName & " code library", "Function GetDateDifference"
Exit Function

End Function
Function LastDayOfMonth(Optional RawDate) As Date
On Error GoTo LastDayOfMonth_Err

Dim ShortMonth As Boolean, _
tmpDate As Date, _
Month_ As String, _
Year_ As String

    If IsMissing(RawDate) Then RawDate = Now
    
Month_ = Month(DateAdd("m", 1, RawDate))
Year_ = Year(DateAdd("m", 1, RawDate))

tmpDate = "1/" & Month_ & "/" & Year_

LastDayOfMonth = DateAdd("d", -1, tmpDate)

Exit Function
LastDayOfMonth_Err:
ErrH App.ProductName & " code library", "Function LastDayOfMonth"
Exit Function

End Function
Function FirstDayOfMonth(Optional RawDate) As Date
On Error GoTo FirstDayOfMonth_Err

FirstDayOfMonth = CVDate("1/" & Month(RawDate) & "/" & Year(RawDate))

Exit Function
FirstDayOfMonth_Err:
ErrH App.ProductName & " code library", "Function FirstDayOfMonth"
Exit Function

End Function
Sub Add(ByRef ParmA As Variant, ByVal ParmB As Variant, Optional Inverse As Boolean = False)

    If Inverse Then
    ParmA = ParmB + ParmA
    
    Else
    ParmA = ParmA + ParmB
    
    End If

End Sub
Function YearDiff(pDatePrev As Date, pDatePost As Date) As Long
Dim lDatTemp As Date

lDatTemp = pDatePost - pDatePrev
YearDiff = Year(lDatTemp) Mod 100

End Function
