Attribute VB_Name = "ctl2ListView"
Option Explicit
' ===========================================================================
' Filename: mListView
' Author:   Steve McMahon (steve@dogma.demon.co.uk)
' Date:     15 February 1998
'
' Requires:
'
' Description:
' Declares to support advanced ListView features.
'
' ---------------------------------------------------------------------------
' Visit vbAccelerator - the VB Programmers resource for advanced,free VB
' source code.
'     http://vbaccelerator.com
' ===========================================================================

Public Const CLR_NONE = &HFFFFFFFF

Public Const LVM_FIRST = &H1000                   '// ListView messages
Public Const LVM_SETBKCOLOR = (LVM_FIRST + 1)
Public Const LVM_GETHEADER = (LVM_FIRST + 31)
Public Const LVM_SETTEXTBKCOLOR = (LVM_FIRST + 38)
Public Const LVM_SETICONSPACING = (LVM_FIRST + 53)


Public Const LVM_SETHOVERTIME = (LVM_FIRST + 71)
Public Const LVM_GETHOVERTIME = (LVM_FIRST + 72)

Public Const LVM_GETEXTENDEDLISTVIEWSTYLE = (LVM_FIRST + 55)
Public Const LVM_SETEXTENDEDLISTVIEWSTYLE = (LVM_FIRST + 54) '// optional wParam == mask

Public Const LVS_EX_GRIDLINES = &H1
Public Const LVS_EX_SUBITEMIMAGES = &H2
Public Const LVS_EX_CHECKBOXES = &H4
Public Const LVS_EX_TRACKSELECT = &H8
Public Const LVS_EX_HEADERDRAGDROP = &H10
Public Const LVS_EX_FULLROWSELECT = &H20         '// applies to report mode only
Public Const LVS_EX_ONECLICKACTIVATE = &H40
Public Const LVS_EX_TWOCLICKACTIVATE = &H80
Public Const LVS_EX_FLATSB = &H100
Public Const LVS_EX_REGIONAL = &H200
Public Const LVS_EX_INFOTIP = &H400              '// listview does InfoTips for you
Public Const LVS_EX_UNDERLINEHOT = &H800
Public Const LVS_EX_UNDERLINECOLD = &H1000
Public Const LVS_EX_MULTIWORKAREAS = &H2000
'#endif

' Bitmaps in list views!
Type LVBKIMAGE: ulFlags As Long: hbm As Long: pszImage As String: cchImageMax As Long: xOffsetPercent As Long: yOffsetPercent As Long: End Type
Enum LVS_EX3: GridLines = 0: Checkboxes = 1: TrackBoxes = 2: HeaderDragDrop = 3: FullRowSelect = 4: OneClickActivate = 5: TwoClickActivate = 6: FlatHeader = 7: HeaderTrackSelect = 8: End Enum
Enum LVS_EX4: FlatScrollBar = 0: InfoTips = 1: MultiWorkAreas = 2: UnderlineCold = 3: End Enum

' 4.71:
Public Const LVBKIF_SOURCE_NONE = &H0
Public Const LVBKIF_SOURCE_HBITMAP = &H1    ' Not supported
Public Const LVBKIF_SOURCE_URL = &H2
Public Const LVBKIF_SOURCE_MASK = &H3
Public Const LVBKIF_STYLE_NORMAL = &H0
Public Const LVBKIF_STYLE_TILE = &H10
Public Const LVBKIF_STYLE_MASK = &H10

Public Const LVM_SETBKIMAGEA = (LVM_FIRST + 68)
Public Const LVM_GETBKIMAGEA = (LVM_FIRST + 69)
Public Const LVM_SETBKIMAGE = LVM_SETBKIMAGEA
Public Const LVM_GETBKIMAGE = LVM_GETBKIMAGEA

' Manipulating ListView Columns
Type LVCOLUMN: Mask As Long: fmt As Long: cx As Long: pszText As String: cchTextMax As Long: iSubItem As Long: iImage As Long: iOrder As Long: End Type

' LVCOLUMN mask values:
Public Const LVCF_FMT = &H1
Public Const LVCF_WIDTH = &H2
Public Const LVCF_TEXT = &H4
Public Const LVCF_SUBITEM = &H8
'#if (_WIN32_IE >= =&H0300)
Public Const LVCF_IMAGE = &H10
Public Const LVCF_ORDER = &H20
'#End If

' LVCOLUMN fmt values:
Public Const LVCFMT_LEFT = &H0
Public Const LVCFMT_RIGHT = &H1
Public Const LVCFMT_CENTER = &H2
Public Const LVCFMT_JUSTIFYMASK = &H3
'#if (_WIN32_IE >= =&H0300)
Public Const LVCFMT_IMAGE = &H800
Public Const LVCFMT_BITMAP_ON_RIGHT = &H1000
Public Const LVCFMT_COL_HAS_IMAGES = &H8000
'#End If

Public Const LVM_GETCOLUMNA = (LVM_FIRST + 25)
Public Const LVM_GETCOLUMN = LVM_GETCOLUMNA
Public Const LVM_SETCOLUMNA = (LVM_FIRST + 26)
Public Const LVM_SETCOLUMN = LVM_SETCOLUMNA

Public Const LVM_GETCOLUMNORDERARRAY = (LVM_FIRST + 59)
Public Const LVM_SETCOLUMNORDERARRAY = (LVM_FIRST + 58)

' Manipulating ListView items:
Type LVITEM: Mask As Long: iItem As Long: iSubItem As Long: State As Long: stateMask As Long: pszText As String: cchTextMax As Long: iImage As Long: lParam As Long: iIndent As Long: End Type

' LVITEM mask values:
Public Const LVIF_TEXT = &H1
Public Const LVIF_IMAGE = &H2
Public Const LVIF_PARAM = &H4
Public Const LVIF_STATE = &H8
'#if (_WIN32_IE >= =&H0300)
Public Const LVIF_INDENT = &H10
Public Const LVIF_NORECOMPUTE = &H800
'#End If

Public Const LVM_GETITEMA = (LVM_FIRST + 5)
Public Const LVM_GETITEM = LVM_GETITEMA
Public Const LVM_SETITEMA = (LVM_FIRST + 6)
Public Const LVM_SETITEM = LVM_SETITEMA

' Check boxes:
Public Const LVM_GETITEMSTATE = (LVM_FIRST + 44)
Public Const LVM_SETITEMSTATE = (LVM_FIRST + 43)

Public Const LVIS_FOCUSED = &H1&
Public Const LVIS_SELECTED = &H2&
Public Const LVIS_CUT = &H4&
Public Const LVIS_DROPHILITED = &H8&
Public Const LVIS_ACTIVATING = &H20&

Public Const LVIS_OVERLAYMASK = &HF00&
Public Const LVIS_STATEIMAGEMASK = &HF000&

' Finding:
Public Type POINT: X As Long: Y As Long: End Type
   
Public Type LVFINDINFO: flags As Long: psz As String: lParam As Long: pt As POINT: vkDirection As Long: End Type

Private Const LVFI_PARAM = 1
Public Const LVFI_STRING = &H2
Public Const LVFI_PARTIAL = &H8
Public Const LVFI_WRAP = &H20
Public Const LVFI_NEARESTXY = &H40

Private Const LVM_FINDITEM = LVM_FIRST + 13
Private Const LVM_GETITEMTEXT = LVM_FIRST + 45
Public Const LVM_SORTITEMS = LVM_FIRST + 48

Public Const LVM_GETNEXTITEM = (LVM_FIRST + 12)

Public Const LVNI_ALL = &H0
Public Const LVNI_FOCUSED = &H1
Public Const LVNI_SELECTED = &H2
Public Const LVNI_CUT = &H4
Public Const LVNI_DROPHILITED = &H8

Public Const LVNI_ABOVE = &H100
Public Const LVNI_BELOW = &H200
Public Const LVNI_TOLEFT = &H400
Public Const LVNI_TORIGHT = &H800

' Header control styles
Public Const HDS_HOTTRACK = &H4 ' v 4.70
Public Const HDS_BUTTONS = &H2

' Message functions:
Declare Function SendMessageByString Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
Declare Function SendMessageByLong Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Declare Function GetWindow Lib "user32" (ByVal hWnd As Long, ByVal wCmd As Long) As Long
Public Const GW_CHILD = 5
Public Const GW_HWNDFIRST = 0
Public Const GW_HWNDLAST = 1
Public Const GW_HWNDNEXT = 2
Public Const GW_HWNDPREV = 3
Public Const GW_MAX = 5
Public Const GW_OWNER = 4

Declare Function ShowWindow Lib "user32" (ByVal hWnd As Long, ByVal nCmdShow As Long) As Long
Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long
Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long

' Window style bit functions:
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" _
    (ByVal hWnd As Long, ByVal nIndex As Long, _
    ByVal dwNewLong As Long _
    ) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" _
    (ByVal hWnd As Long, ByVal nIndex As Long _
    ) As Long
' Window Long indexes:
Public Const GWL_EXSTYLE = (-20)
Public Const GWL_HINSTANCE = (-6)
Public Const GWL_HWNDPARENT = (-8)
Public Const GWL_ID = (-12)
Public Const GWL_STYLE = (-16)
Public Const GWL_USERDATA = (-21)
'Public Const GWL_WNDPROC = (-4) 'Already in Common

Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Public Declare Function CoInitialize Lib "ole32.dll" (ByVal pvReserved As Long) As Long
Public Declare Sub CoUninitialize Lib "ole32.dll" ()
Public Const NOERROR = &H0&
Public Const S_OK = &H0&
Public Const S_FALSE = &H1&

Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal hdc As Long) As Long
Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Declare Function SetBkColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long

Public m_iSortCol As Long
Public m_eSortOrder As ComctlLib.ListSortOrderConstants

Public Enum ELVSortTypes: elvstText: elvstInteger: elvstFloat: elvstDate: End Enum

Public m_eSortType As ELVSortTypes

Function ListViewGetColumnOrder(ByRef uControl As ListView, ByRef uSet() As Long) As String
On Error GoTo ListViewGetColumnOrder_Err

Dim lC As Long, L As Long, sI As String

    lC = uControl.ColumnHeaders.Count
    ReDim uSet(0 To lC - 1) As Long
    SendMessage uControl.hWnd, LVM_GETCOLUMNORDERARRAY, lC, uSet(0)
    
    For L = 0 To lC - 1
    sI = sI & uSet(L) & ","
    Inc uSet(L)
    Next L

ListViewGetColumnOrder = sI

Exit Function
ListViewGetColumnOrder_Err:
ErrH , "Function ListViewGetColumnOrder"
Exit Function

End Function
Function ListViewGetHoverTime(ByVal uControl As ListView) As Long
On Error GoTo ListViewGetHoverTime_Err

ListViewGetHoverTime = SendMessageByLong(uControl.hWnd, LVM_GETHOVERTIME, 0, 0)

Exit Function
ListViewGetHoverTime_Err:
ErrH , "Function ListViewGetHoverTime"
Exit Function

End Function
Function ListViewGetIconSpacing(ByVal uControl As ListView) As POINTAPI
On Error GoTo ListViewGetIconSpacing_Err

Dim lXYD As Long
Dim lXYC As Long
Dim cx As Long, cy As Long

'Dim lI As Long
'Dim lXY As Long

    ' Set cx=-1, cy=-1 to reset to default and return current settings:
    lXYD = &HFFFFFFFF
    lXYC = SendMessageByLong(uControl.hWnd, LVM_SETICONSPACING, 0, lXYD)
    ' cX is loword:
    cx = (lXYC And &HFFFF&)
    ' cY is hiword:
    cy = (lXYC \ &H10000)
    
ListViewGetIconSpacing.X = cx
ListViewGetIconSpacing.Y = cy

Exit Function
ListViewGetIconSpacing_Err:
ErrH , "Function ListViewGetIconSpacing"
Exit Function

End Function
Function ListViewGetItemChecked(ByRef uControl As ListView) As Boolean
On Error GoTo ListViewGetItemChecked_Err

Dim lI As Long
Dim lR As Long
   
   ' Get whether a ListView item is checked or not (if the ListView
   ' checkboxes style is set):
   
   ' The ListView Index does not correspond to the API index if a custom
   ' sort has been performed:
   lR = LVNI_ALL Or LVNI_SELECTED
   lI = SendMessageByLong(uControl.hWnd, LVM_GETNEXTITEM, -1, lR)
    
   lR = SendMessage(uControl.hWnd, LVM_GETITEMSTATE, lI, LVIS_STATEIMAGEMASK)
   
   ListViewGetItemChecked = ((lR And &H2000&) = &H2000&)

Exit Function
ListViewGetItemChecked_Err:
ErrH , "Function ListViewGetItemChecked"
Exit Function

End Function
Function ListViewSetColumnOrder(ByRef uControl As ListView, ByRef uSet() As Long, Optional uStringSet As String) As Boolean
On Error GoTo ListViewSetColumnOrder_Err

Dim lC As Long
Dim L As Long
Dim iLP As Long, iNP As Long

lC = uControl.ColumnHeaders.Count

    If (Len(Trim$(uStringSet)) > 0) Then
    iLP = 1
    
        For L = 0 To lC - 1
        iNP = InStr(iLP, uStringSet, ",")
            
            If (iNP = 0) Then
            iNP = Len(uStringSet)
                
                If (L <> 3) Then
                MsgBox "There is an error in your entry: " & uStringSet, vbInformation
                Exit Function
                
                End If
            
            End If
        
            If (iNP = iLP) Then
            uSet(L) = CLng(Mid$(uStringSet, iLP))
            
            Else
            uSet(L) = CLng(Mid$(uStringSet, iLP, (iNP - iLP)))
            
            End If
        
        iLP = iNP + 1
        
        Next L
    
    End If

SendMessage uControl.hWnd, LVM_SETCOLUMNORDERARRAY, lC, uSet(0)
uControl.Refresh

ListViewSetColumnOrder = True

Exit Function
ListViewSetColumnOrder_Err:
ErrH , "Function ListViewSetColumnOrder"
Exit Function

End Function
Function ListViewSetIconSpacing(ByRef uControl As ListView, uSize As POINTAPI) As Boolean
On Error GoTo ListViewSetIconSpacing_Err

Dim lXY As Long

lXY = uSize.X And &HFFFF
lXY = lXY Or (uSize.Y * &H10000)

SendMessageByLong uControl.hWnd, LVM_SETICONSPACING, 0, lXY

Exit Function
ListViewSetIconSpacing_Err:
ErrH , "Function ListViewSetIconSpacing"
Exit Function

End Function
Function ListViewSetItemChecked(ByRef uControl As ListView, uParm As Boolean, Optional uInvert As Boolean = False) As Boolean
On Error GoTo ListViewSetItemChecked_Err

Dim lI As Long
Dim lR As Long
Dim tLV As LVITEM

' Set whether a ListView item is checked or not (if the ListView
' checkboxes style is set):

' The ListView Index does not correspond to the API index if a custom
' sort has been performed:
'lI = lvwTest.SelectedItem.Index - 1
lR = LVNI_ALL Or LVNI_SELECTED
lI = SendMessageByLong(uControl.hWnd, LVM_GETNEXTITEM, -1, lR)

tLV.iItem = lI
tLV.Mask = LVIF_STATE
tLV.stateMask = &H3000&

    If uInvert Then

        If (SendMessage(uControl.hWnd, LVM_GETITEMSTATE, lI, LVIS_STATEIMAGEMASK) And &H2000&) = &H2000& Then
        ' uncheck
        tLV.State = &H1000&
        
        Else
        ' check
        tLV.State = &H2000&
        
        End If
        
    Else
    
    tLV.State = IIf(uParm, &H2000, &H1000)
    
    End If
    
lR = SendMessage(uControl.hWnd, LVM_SETITEMSTATE, lI, tLV)

Exit Function
ListViewSetItemChecked_Err:
ErrH , "Function ListViewSetItemChecked"
Exit Function

End Function
Sub ListViewLoadBG(ByVal uImage As String, ByRef uControl As ListView)
On Error GoTo ListViewLoadBG_Err

Dim lHDC As Long
    
   ' Set a background image:
   
    If (Len(uImage) > 0) Then
    
        If (InStr(uImage, "\")) = 0 Then
        uImage = App.Path & "\" & uImage
        End If
        
    On Error Resume Next
    
        If (Dir(uImage) <> "") Then
            
            If (Err.number = 0) Then
            ' Set the background:
            Dim tLBI As LVBKIMAGE
            tLBI.pszImage = uImage & Chr$(0)
            tLBI.cchImageMax = Len(uImage) + 1
            tLBI.ulFlags = LVBKIF_SOURCE_URL Or LVBKIF_STYLE_TILE
            SendMessage uControl.hWnd, LVM_SETBKIMAGE, 0, tLBI
            ' Set the background colour of the ListView to &HFFFFFFFF (-1)
            ' so it will be transparent!
            SendMessageByLong uControl.hWnd, LVM_SETTEXTBKCOLOR, 0, CLR_NONE
            
            Else
            MsgBox "Error with File '" & uImage & "' :" & Err.DESCRiption & ".", vbExclamation
            
            End If
        
        Else
        MsgBox "File '" & uImage & "' not found.", vbExclamation
        
        End If
    
    End If

Exit Sub
ListViewLoadBG_Err:
ErrH , "Sub ListViewLoadBG"
Exit Sub

End Sub
Function ListViewSetHoverTime(ByRef uControl As ListView, ByVal uValue As String) As Boolean
On Error GoTo ListViewSetHoverTime_Err

    If (uValue <> "") Then
        
        If IsNumeric(uValue) And Len(Trim$(uValue)) > 0 Then
        Dim lI  As String
        
        lI = CLng(uValue)
        SendMessageByLong uControl.hWnd, LVM_SETHOVERTIME, 0, lI
        
        Else
        MsgBox "Could not interpret: " & uValue, vbInformation
        
        End If
    
    End If

Exit Function
ListViewSetHoverTime_Err:
ErrH , "Function ListViewSetHoverTime"
Exit Function

End Function
Sub ListViewIE4SetStyle(ByRef uControl As ListView, ByVal uIndex As LVS_EX4, Optional uStatus As Boolean = True)
On Error GoTo ListViewIE4SetStyle_Err

Dim lP As Long
Dim lStyle As Long
Dim lS As Long

' Set Extended List View Styles supported by COMCTL32.DLL v4.71 or
' higher (IE4 version or above):
lStyle = SendMessageByLong(uControl.hWnd, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0)

    Select Case uIndex
    Case LVS_EX4.FlatScrollBar
    lS = LVS_EX_FLATSB
    
    Case LVS_EX4.InfoTips
    lS = LVS_EX_INFOTIP
    
    Case LVS_EX4.MultiWorkAreas
    lS = LVS_EX_MULTIWORKAREAS
    
    Case LVS_EX4.UnderlineCold
    lS = LVS_EX_UNDERLINECOLD
    
    End Select

    lStyle = IIf(uStatus, lStyle Or lS, lStyle And Not lS)
    
SendMessageByLong uControl.hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, lStyle

Exit Sub
ListViewIE4SetStyle_Err:
ErrH , "Sub ListViewIE4SetStyle"
Exit Sub

End Sub
Sub ListViewIE3SetStyle(ByRef uControl As ListView, ByVal uIndex As LVS_EX3, Optional uStatus As Boolean = True)
On Error GoTo ListViewIE3SetStyle_Err

Dim lP As Long
Dim lStyle As Long
Dim lS As Long
Dim lhWnd As Long

' Set Extended List View Styles supported by COMCTL32.DLL v4.70 or
' higher (IE3 version or above):
lStyle = SendMessageByLong(uControl.hWnd, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0)

    Select Case uIndex
    Case LVS_EX3.GridLines
    
    lS = LVS_EX_GRIDLINES
    
    Case LVS_EX3.Checkboxes
    lS = LVS_EX_CHECKBOXES
    
    Case LVS_EX3.TrackBoxes
    lS = LVS_EX_TRACKSELECT
    
    Case LVS_EX3.HeaderDragDrop
    lS = LVS_EX_HEADERDRAGDROP
    
    Case LVS_EX3.FullRowSelect
    lS = LVS_EX_FULLROWSELECT
    
    Case LVS_EX3.OneClickActivate, LVS_EX3.TwoClickActivate
    
        If (uIndex = LVS_EX3.OneClickActivate) Then
        lStyle = lStyle Or LVS_EX_ONECLICKACTIVATE
        lStyle = lStyle And Not LVS_EX_TWOCLICKACTIVATE
        
        Else
        lStyle = lStyle Or LVS_EX_TWOCLICKACTIVATE
        lStyle = lStyle And Not LVS_EX_ONECLICKACTIVATE
        
        End If
    
    Case LVS_EX3.FlatHeader
    
    ' Set the Buttons mode of the ListView's header control:
    lhWnd = SendMessageByLong(uControl.hWnd, LVM_GETHEADER, 0, 0)
    
        If (lhWnd <> 0) Then
        lS = GetWindowLong(lhWnd, GWL_STYLE)
        
            If uStatus Then
            lS = lS And Not HDS_BUTTONS
            
            Else
            lS = lS Or HDS_BUTTONS
            
            End If
        
        SetWindowLong lhWnd, GWL_STYLE, lS
        Exit Sub
        
        End If
        
    Case LVS_EX3.HeaderTrackSelect
    
    lhWnd = SendMessageByLong(uControl.hWnd, LVM_GETHEADER, 0, 0)
    
        If (lhWnd <> 0) Then
        lS = GetWindowLong(lhWnd, GWL_STYLE)
        
            If uStatus Then
            lS = lS And Not HDS_HOTTRACK
            
            Else
            lS = lS Or HDS_HOTTRACK
            
            End If
        
        SetWindowLong lhWnd, GWL_STYLE, lS
        
        End If
      
    Exit Sub
    
    End Select

lStyle = IIf(uStatus, lStyle Or lS, lStyle And Not lS)

SendMessageByLong uControl.hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, lStyle

Exit Sub
ListViewIE3SetStyle_Err:
ErrH , "Sub ListViewIE3SetStyle"
Exit Sub

End Sub
Public Function ListViewSortCompare(ByVal lParam1 As Long, ByVal lParam2 As Long, ByVal hWnd As Long) As Long
On Error GoTo ListViewSortCompare_Err

Dim lI1 As Long, lI2 As Long
Dim v1 As Variant, v2 As Variant, vt As Variant

    lI1 = ListViewGetIndexForlParam(hWnd, lParam1)
    lI2 = ListViewGetIndexForlParam(hWnd, lParam2)
    
    'Compare the items
    'Return -ve if lI1<lI2,
    '       0 if lI1 = lI2
    '       +ve if lI1 > lI2
    On Error Resume Next
    Select Case m_eSortType
    Case elvstInteger
        v1 = CLng(ListViewGetItem(hWnd, lI1))
        v2 = CLng(ListViewGetItem(hWnd, lI2))
    Case elvstFloat
        v1 = CDbl(ListViewGetItem(hWnd, lI1))
        v2 = CDbl(ListViewGetItem(hWnd, lI2))
    Case elvstDate
        v1 = CDate(ListViewGetItem(hWnd, lI1))
        v2 = CDate(ListViewGetItem(hWnd, lI2))
    Case elvstText
        v1 = ListViewGetItem(hWnd, lI1)
        v2 = ListViewGetItem(hWnd, lI2)
    End Select
        
    If (m_eSortOrder = lvwDescending) Then
        vt = v2
        v2 = v1
        v1 = vt
    End If
    If (v1 < v2) Then
        ListViewSortCompare = -1
    ElseIf (v1 = v2) Then
        ListViewSortCompare = 0
    Else
        ListViewSortCompare = 1
    End If
    

Exit Function
ListViewSortCompare_Err:
ErrH , "Public Function ListViewSortCompare"
Exit Function

End Function
Function ListViewGetIndexForlParam(ByVal hWnd As Long, ByVal lParam As Long)
On Error GoTo ListViewGetIndexForlParam_Err

Dim tLV As LVFINDINFO
Dim lIndex As Long

    ' Convert the input parameter to an index in the list view
    tLV.flags = LVFI_PARAM
    tLV.lParam = lParam
    ListViewGetIndexForlParam = SendMessage(hWnd, LVM_FINDITEM, -1, tLV)
    

Exit Function
ListViewGetIndexForlParam_Err:
ErrH , "Function ListViewGetIndexForlParam"
Exit Function

End Function
Function ListViewGetItem(ByVal hWnd As Long, ByVal lIndex As Long) As String
On Error GoTo ListViewGetItem_Err

Dim tLV As LVITEM
Dim lLength As Long

    tLV.Mask = LVIF_TEXT
    tLV.iSubItem = m_iSortCol - 1
    tLV.pszText = String$(32, Chr$(0))
    tLV.cchTextMax = 32
    lLength = SendMessage(hWnd, LVM_GETITEMTEXT, lIndex, tLV)
    If lLength > 0 Then
      ListViewGetItem = Left$(tLV.pszText, lLength)
    End If
   

Exit Function
ListViewGetItem_Err:
ErrH , "Function ListViewGetItem"
Exit Function

End Function
