VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Machines"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "The actual collection of Machines in the LAN."
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"Machine"
Attribute VB_Ext_KEY = "Member0" ,"Machine"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'local variable to hold collection
Private mCol As Collection
Public Function CheckStatus() As String
On Error GoTo pfCheckStatusErr 'EHCG.UID.pfCheckStatus

Dim uItem As Machine

    For Each uItem In mCol

        If uItem.Status <> MSDisconnected Then

            If uItem.LastStatusUpdate + Data.Settings.ICAEventPeriod < GetTickCount Then ' O client no teve seu status atualizado em um perodo maior do que o permitido. Trocando seu status para Disconected.
            uItem.Status = MSDisconnected
            CheckStatus = CheckStatus & uItem.Macaddress & "|"
            End If

        End If

    Next uItem

Exit Function
pfCheckStatusErr:
Err.Raise Err.number, Err.Source, "pf.CheckStatus (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Function
Public Sub SetTime(ByVal uTime As String)
On Error GoTo psSetTimeErr 'EHCG.UID.psSetTime

SendBroadcast "SETTIME|" & Now()

Exit Sub
psSetTimeErr:
Err.Raise Err.number, Err.Source, "ps.SetTime (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Public Sub SetResolution(ByVal uWidth As Integer, ByVal uHeight As Integer, Optional uBitDepth As Byte)
On Error GoTo psSetResolutionErr 'EHCG.UID.psSetResolution



Exit Sub
psSetResolutionErr:
Err.Raise Err.number, Err.Source, "ps.SetResolution (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Public Sub ScreenLock(ByVal Status As Boolean)
On Error GoTo psScreenLockErr 'EHCG.UID.psScreenLock



Exit Sub
psScreenLockErr:
Err.Raise Err.number, Err.Source, "ps.ScreenLock (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Public Sub Reboot()
On Error GoTo psRebootErr 'EHCG.UID.psReboot



Exit Sub
psRebootErr:
Err.Raise Err.number, Err.Source, "ps.Reboot (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Public Sub LogOff()
On Error GoTo psLogOffErr 'EHCG.UID.psLogOff



Exit Sub
psLogOffErr:
Err.Raise Err.number, Err.Source, "ps.LogOff (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Public Sub KillNeuron()
On Error GoTo psKillNeuronErr 'EHCG.UID.psKillNeuron



Exit Sub
psKillNeuronErr:
Err.Raise Err.number, Err.Source, "ps.KillNeuron (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Public Sub SetUpdateRate(uRate As String)
On Error GoTo psSetUpdateRateErr 'EHCG.UID.psSetUpdateRate

SendBroadcast "UPDATERATE|" & uRate

Exit Sub
psSetUpdateRateErr:
Err.Raise Err.number, Err.Source, "ps.SetUpdateRate (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Public Function Add(ByVal uMachine As Machine) As Machine
On Error GoTo pfAddErr 'EHCG.UID.pfAdd

Dim lObjRS As Recordset, lStrSQL As String

    With uMachine
        If False Then
        Err.Raise &H5002, "Machines Collection", "Couldn't insert Item: Essential info missing."
        Exit Function
        End If

    Set lObjRS = Data.Database.Execute("SELECT * FROM [Machine] WHERE [MACAddress] = '" & .Macaddress & "'")

        If Not lObjRS.EOF Then
        Err.Raise &H5003, "Machines Collection", "Couldn't insert Item: trying to replicate Unique Identifier field [MACAddress]."
        Exit Function
        End If

    Dim uTmpAmbient As String
        If TypeName(.Ambient) = "Nothing" Then
        uTmpAmbient = "null"
        Else
        uTmpAmbient = .Ambient.ID
        End If

    lStrSQL = "INSERT INTO [Machine] ([AmbientID], [Ipaddress], [Macaddress], [Netname], [Sign]) VALUES (" & _
    uTmpAmbient & ", " & _
    "'" & .Ipaddress & "', " & _
    "'" & .Macaddress & "', " & _
    "'" & .Netname & "', " & _
    "'" & .Sign & "')"

    Data.Database.Execute lStrSQL
    Set lObjRS = Data.Database.Execute("SELECT * FROM [Machine] WHERE [MACAddress] = '" & .Macaddress & "'")
    .ID = lObjRS("ID")

    mCol.Add uMachine, uMachine.Macaddress

    Set Add = uMachine
    Set uMachine = Nothing

    End With

Exit Function
pfAddErr:
Err.Raise Err.number, Err.Source, "pf.Add (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Function
Public Property Get Item(vntIndexKey As Variant) As Machine
On Error GoTo ppgItemErr 'EHCG.UID.ppgItem

Set Item = mCol(vntIndexKey)

Exit Property
ppgItemErr:
Resume Next
Err.Raise Err.number, Err.Source, "ppg.Item (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Property
Public Property Get Count() As Long
On Error GoTo ppgCountErr 'EHCG.UID.ppgCount

Count = mCol.Count

Exit Property
ppgCountErr:
Err.Raise Err.number, Err.Source, "ppg.Count (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Property
Public Sub Remove(vntIndexKey As Variant)
On Error GoTo psRemoveErr 'EHCG.UID.psRemove

Dim lObjRS As Recordset, lStrSQL As String, lMachine As Machine
Set lMachine = mCol(vntIndexKey)
Data.Machine_Statuses.Remove Data.Machine_Statuses.SeekMachine(lMachine).ID
Data.Database.Execute "DELETE FROM [Machine] WHERE [MACAddress] = '" & lMachine.Macaddress & "'"
mCol.Remove vntIndexKey

Exit Sub
psRemoveErr:

    If Err.number = 91 Then Resume Next
    
Err.Raise Err.number, Err.Source, "ps.Remove (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Public Property Get NewEnum() As IUnknown
On Error GoTo ppgNewEnumErr 'EHCG.UID.ppgNewEnum

Set NewEnum = mCol.[_NewEnum]

Exit Property
ppgNewEnumErr:
Err.Raise Err.number, Err.Source, "ppg.NewEnum (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Property
Private Sub Class_Initialize()
On Error GoTo psClass_InitializeErr 'EHCG.UID.psClass_Initialize

Set mCol = New Collection
Call LoadItems

Exit Sub
psClass_InitializeErr:
Err.Raise Err.number, Err.Source, "ps.Class_Initialize (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Private Sub Class_Terminate()
On Error GoTo psClass_TerminateErr 'EHCG.UID.psClass_Terminate

Set mCol = Nothing

Exit Sub
psClass_TerminateErr:
Err.Raise Err.number, Err.Source, "ps.Class_Terminate (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Private Sub LoadItems()
On Error GoTo psLoadItemsErr 'EHCG.UID.psLoadItems

Dim lObjRS As Recordset, lClsMachine As Machine, lObjRS1 As Recordset
Set lObjRS = Data.Database.Execute("SELECT * FROM [Machine]")

    Do While Not lObjRS.EOF
    Set lClsMachine = New Machine

        With lClsMachine
        .OnParse = True
        .ID = ValidNum(lObjRS("ID"))
        If Not IsNull(lObjRS("AmbientID")) Then Set .Ambient = Data.Ambients.SeekID(lObjRS("AmbientID"))
        .Ipaddress = ValidStr(lObjRS("Ipaddress"))
        .Macaddress = ValidStr(lObjRS("Macaddress"))
        .Netname = ValidStr(lObjRS("Netname"))
        .Sign = ValidStr(lObjRS("Sign"))
        Set lObjRS1 = Data.Database.Execute("SELECT [machine_status_defID] FROM [machine_status] WHERE [machineID]=" & .ID)

            If lObjRS1.EOF Then
            .Status = MSDisconnected

            Else
            .Status = lObjRS1(0)

            End If

        Set lObjRS1 = Nothing
        .OnParse = False
        End With

    mCol.Add lClsMachine, ValidStr(lObjRS("MACAddress"))
    lObjRS.MoveNext
    Loop

Exit Sub
psLoadItemsErr:
Err.Raise Err.number, Err.Source, "ps.LoadItems (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Public Function SeekID(uParm As Long) As Machine
On Error GoTo pfSeekIDErr 'EHCG.UID.pfSeekID

Dim uItem As Machine

    For Each uItem In mCol

        If uItem.ID = uParm Then
        Set SeekID = uItem
        Exit Function
        End If

    Next uItem

Exit Function
pfSeekIDErr:
Err.Raise Err.number, Err.Source, "pf.SeekID (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Function
Public Function SeekAmbient(uParm As Ambient) As Machine
On Error GoTo pfSeekAmbientErr 'EHCG.UID.pfSeekAmbient

Dim uItem As Machine

    For Each uItem In mCol

        If uItem.Ambient = uParm Then
        Set SeekAmbient = uItem
        Exit Function
        End If

    Next uItem

Exit Function
pfSeekAmbientErr:
Err.Raise Err.number, Err.Source, "pf.SeekAmbient (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Function
Public Function SeekIpaddress(uParm As String) As Machine
On Error GoTo pfSeekIpaddressErr 'EHCG.UID.pfSeekIpaddress

Dim uItem As Machine

    For Each uItem In mCol

        If uItem.Ipaddress = uParm Then
        Set SeekIpaddress = uItem
        Exit Function
        End If

    Next uItem

Exit Function
pfSeekIpaddressErr:
Err.Raise Err.number, Err.Source, "pf.SeekIpaddress (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Function
Public Function SeekMacaddress(uParm As String) As Machine
On Error GoTo pfSeekMacaddressErr 'EHCG.UID.pfSeekMacaddress

Dim uItem As Machine

    For Each uItem In mCol

        If uItem.Macaddress = uParm Then
        Set SeekMacaddress = uItem
        Exit Function
        End If

    Next uItem

Exit Function
pfSeekMacaddressErr:
Err.Raise Err.number, Err.Source, "pf.SeekMacaddress (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Function
Public Function SeekNetname(uParm As String) As Machine
On Error GoTo pfSeekNetnameErr 'EHCG.UID.pfSeekNetname

Dim uItem As Machine

    For Each uItem In mCol

        If uItem.Netname = uParm Then
        Set SeekNetname = uItem
        Exit Function
        End If

    Next uItem

Exit Function
pfSeekNetnameErr:
Err.Raise Err.number, Err.Source, "pf.SeekNetname (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Function
Public Function SeekSign(uParm As String) As Machine
On Error GoTo pfSeekSignErr 'EHCG.UID.pfSeekSign

Dim uItem As Machine

    For Each uItem In mCol

        If uItem.Sign = uParm Then
        Set SeekSign = uItem
        Exit Function
        End If

    Next uItem

Exit Function
pfSeekSignErr:
Err.Raise Err.number, Err.Source, "pf.SeekSign (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Function
