VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Shops"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"UserDefinedCollection"
Attribute VB_Ext_KEY = "Member0" ,"LANHouse"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'================================================================================================
'Shops Collection
'================================================================================================

Option Explicit

'local variable to hold collection
Private mCol As Collection
Public Function Add(ByVal uShop As Shop) As Shop
Dim lObjRS As Recordset, lStrSQL As String

    With uShop
        If False Then
        Err.Raise &H5002, "Shops Collection", "Couldn't insert Item: Essential info missing."
        Exit Function
        End If

    Set lObjRS = Data.Database.Execute("SELECT * FROM [Shop] WHERE [ID]=" & .ID)

        If Not lObjRS.EOF Then
        Err.Raise &H5003, "Shops Collection", "Couldn't insert Item: trying to replicate Unique Identifier field [ID]."
        Exit Function
        End If

Dim uTmpFranchise As String, _
uTmpName As String, _
uTmpDescr As String, _
uTmpFulladress As String, _
uTmpTokenvalue As String, _
uTmpTokenduration As String

    If TypeName(.Franchise) = "Nothing" Then uTmpFranchise = "null" Else uTmpFranchise = .Franchise.ID
uTmpName = IIf(.Name = "", "null", "'" & .Name & "'")
uTmpDescr = IIf(.Descr = "", "null", "'" & .Descr & "'")
uTmpFulladress = IIf(.Fulladress = "", "null", "'" & .Fulladress & "'")
uTmpTokenvalue = IIf(.Tokenvalue = 0, "null", .Tokenvalue)
uTmpTokenduration = IIf(.Tokenduration = 0, "null", .Tokenduration)

    lStrSQL = "INSERT INTO [Shop] ([FranchiseID], [Name], [Descr], [Fulladress], [Tokenvalue], [Tokenduration]) VALUES (" & _
    uTmpFranchise & ", " & _
    uTmpName & ", " & _
    uTmpDescr & ", " & _
    uTmpFulladress & ", " & _
    uTmpTokenvalue & ", " & _
    uTmpTokenduration & ")"

    Data.Database.Execute lStrSQL
    Set lObjRS = Data.Database.Execute("SELECT TOP 1 ID FROM [Shop] ORDER BY ID DESC")
    .ID = lObjRS("ID")

    mCol.Add uShop, "N" & uShop.ID

    Set Add = uShop
    Set uShop = Nothing

    End With

End Function
Public Property Get Item(vntIndexKey As Variant) As Shop
Set Item = mCol(vntIndexKey)
End Property
Public Property Get Count() As Long
Count = mCol.Count
End Property
Public Sub Remove(vntIndexKey As Variant)
Dim lObjRS As Recordset, lStrSQL As String, lShop As Shop
Set lShop = mCol(vntIndexKey)
Data.Database.Execute "DELETE FROM [Shop] WHERE [ID]=" & lShop.ID
mCol.Remove vntIndexKey
End Sub
Public Property Get NewEnum() As IUnknown
Set NewEnum = mCol.[_NewEnum]
End Property
Private Sub Class_Initialize()
Set mCol = New Collection
Call LoadItems
End Sub
Private Sub Class_Terminate()
Set mCol = Nothing
End Sub
Private Sub LoadItems()
Dim lObjRS As Recordset, lClsShop As Shop
Set lObjRS = Data.Database.Execute("SELECT * FROM [Shop]")

    Do While Not lObjRS.EOF
    Set lClsShop = New Shop

        With lClsShop
        .OnParse = True
        .ID = ValidNum(lObjRS("ID"))
        If Not IsNull(lObjRS("FranchiseID")) Then Set .Franchise = Data.Franchises.SeekID(lObjRS("FranchiseID"))
        .Name = ValidStr(lObjRS("Name"))
        .Descr = ValidStr(lObjRS("Descr"))
        .Fulladress = ValidStr(lObjRS("Fulladress"))
        .Tokenvalue = ValidNum(lObjRS("Tokenvalue"))
        .Tokenduration = ValidNum(lObjRS("Tokenduration"))
        .OnParse = False
        End With

    mCol.Add lClsShop, ValidStr("N" & lObjRS("ID"))
    lObjRS.MoveNext
    Loop

End Sub
Public Function SeekID(uParm As Long) As Shop
Dim uItem As Shop

    For Each uItem In mCol

        If uItem.ID = uParm Then
        Set SeekID = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekFranchise(uParm As Franchise) As Shop
Dim uItem As Shop

    For Each uItem In mCol

        If uItem.Franchise = uParm Then
        Set SeekFranchise = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekName(uParm As String) As Shop
Dim uItem As Shop

    For Each uItem In mCol

        If uItem.Name = uParm Then
        Set SeekName = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekDescr(uParm As String) As Shop
Dim uItem As Shop

    For Each uItem In mCol

        If uItem.Descr = uParm Then
        Set SeekDescr = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekFulladress(uParm As String) As Shop
Dim uItem As Shop

    For Each uItem In mCol

        If uItem.Fulladress = uParm Then
        Set SeekFulladress = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekTokenvalue(uParm As Currency) As Shop
Dim uItem As Shop

    For Each uItem In mCol

        If uItem.Tokenvalue = uParm Then
        Set SeekTokenvalue = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekTokenduration(uParm As Long) As Shop
Dim uItem As Shop

    For Each uItem In mCol

        If uItem.Tokenduration = uParm Then
        Set SeekTokenduration = uItem
        Exit Function
        End If

    Next uItem

End Function


