Attribute VB_Name = "ModMain"
Option Explicit
    
    Enum uSetLocks
    StartUp = 0
    Logon = 1
    Interface = 2
    End Enum
    
    Enum uSetDebug
    Client = 0
    server = 1
    Both = 2
    End Enum

    Type uSettings
    PingBeaconUse As Boolean
    PingBeaconLast As Long
    PingBeaconPeriod As Long
    ICAEventLast As Long
    ICAEventPeriod As Long
    ICAEventPeriodClient As Long
    LockEvent As uSetLocks
    DebugModeUse As Boolean
    DebugMode As uSetDebug
    AutoUpdateNeuron As Boolean
    RemoteLogon As Boolean
    TimerOverWarning As Boolean
    TimeOverAutoKickUse As Boolean
    TimeOverAutoKickPeriod As Long
    End Type
    
    Type uAppLocalTypeDataBag
    Database As New ADODB.Connection
    MainInterfaceLoaded As Boolean
    MachineListLoaded As Boolean
    UserListLoaded As Boolean
    UserOnDrag As Long
    InstanceIdentifier As String
    DefaultAmbient As Long
    Ambients As New Ambients
    Applications As New Applications
    Discounts As New Discounts
    Discount_Scopes As New Discount_Scopes
    Franchises As New Franchises
    Machines As New Machines
    Machine_Statuses As New Machine_Statuses
    Shops As New Shops
    Shop_queues As New Shop_queues
    Users As New Users
    User_Clans As New User_Clans
    User_Classes As New User_Classes
    Language As New LangForms
    OnDrag As Boolean
    Settings As uSettings
    Development As Boolean
    Log As Boolean
    StatusMessageTime As Long
    StatusMessageTimeLeft As Long
    StatusMessageDisplayed As Boolean
    LanguagePack As String
    LanguageLoaded As Boolean
    End Type

    Enum uStatusType
    uSTNormal = 0
    uSTMessage = 1
    uSTSuccess = 2
    uSTError = 3
    End Enum
    

Global gsCommBuffer As String, lStrMAC As String
Sub ApplyLanguage(pFrame As Form)
On Error GoTo sApplyLanguageErr 'EHCG.UID.sApplyLanguage

    If Not Data.LanguageLoaded Then Exit Sub

Dim uFrameDef As LangForm
Dim uLCtl As LangControl, uCtl As Control
Dim uStrName As String, uStrIndex As String
Dim lBolSkip As Boolean
Dim lIntMarker As Long, lStrItem As String, lStrText As String

Set uFrameDef = Data.Language(pFrame.Name)
pFrame.Caption = uFrameDef.frmCaption

    For Each uCtl In pFrame.Controls
    uStrIndex = ""
    uStrName = uCtl.Name
    uStrIndex = uCtl.Index
    uStrName = uStrName & IIf(uStrIndex <> "", "(" & uStrIndex & ")", "")
    
    lBolSkip = False
    Set uLCtl = uFrameDef.LangControls.Item(uStrName)
    
        If Not lBolSkip Then
            If uLCtl.ctlCaption <> "" Then uCtl.Caption = uLCtl.ctlCaption
            If uLCtl.ctlTag <> "" Then uCtl.Tag = uLCtl.ctlTag
            If uLCtl.ctlText <> "" Then uCtl.Text = uLCtl.ctlText
            
            If uLCtl.ctlContents <> "" Then
            
                If TypeOf uCtl Is ListBox Then
                lIntMarker = 0
                
                    Do
                    lStrItem = ParseDataBlock(uLCtl.ctlContents, lIntMarker, "|")
                    lStrText = ParseDataBlock(uLCtl.ctlContents, lIntMarker + 1, "|")
                    
                        If lStrItem & lStrText = "" Then Exit Do
                    
                    uCtl.ItemData(lIntMarker / 2) = lStrItem
                    uCtl.List(lIntMarker / 2) = lStrText
                    
                    lIntMarker = lIntMarker + 2
                    Loop
                
                ElseIf TypeOf uCtl Is ListView Then
                lIntMarker = 0
                
                    Do
                    lStrItem = ParseDataBlock(uLCtl.ctlContents, lIntMarker, "|")
                    lStrText = ParseDataBlock(uLCtl.ctlContents, lIntMarker + 1, "|")
                    
                        If lStrItem & lStrText = "" Then Exit Do
                    
                    uCtl.ColumnHeaders(1 + lIntMarker / 2).Key = lStrItem
                    uCtl.ColumnHeaders(1 + lIntMarker / 2).Text = lStrText
                    
                    lIntMarker = lIntMarker + 2
                    Loop
                
                End If
            
            End If
            
        End If


    Next uCtl

Exit Sub
sApplyLanguageErr:

    If Err.number = 343 Then Resume Next
    If Err.number = 5 Then
    lBolSkip = True
    Resume Next
    End If
    If Err.number = 91 Then Exit Sub

Err.Raise Err.number, Err.Source, "s.ApplyLanguage (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Sub ShowCaption(ByVal uParm As String)
MDIMain.mcfMain.Caption = uParm
End Sub
Sub ConnectDatabase()
On Error GoTo sConnectDatabaseErr 'EHCG.UID.sConnectDatabase

Data.Database.Open "DRIVER={Microsoft Access Driver (*.mdb)};DBQ=" & App.Path & "\main.mdb"

Exit Sub
sConnectDatabaseErr:
Err.Raise Err.number, Err.Source, "s.ConnectDatabase:" & vbCrLf & "Error: " & Err.number & vbCrLf & "Description: " & Err.Description & vbCrLf, Err.HelpFile, Err.HelpContext

End Sub
Sub DisconnectDatabase()
On Error GoTo sDisconnectDatabaseErr 'EHCG.UID.sDisconnectDatabase

Set Data.Database = Nothing

Exit Sub
sDisconnectDatabaseErr:
Err.Raise Err.number, Err.Source, "s.DisconnectDatabase:" & vbCrLf & "Error: " & Err.number & vbCrLf & "Description: " & Err.Description & vbCrLf, Err.HelpFile, Err.HelpContext

End Sub
Sub ProccessBuffer()
On Error GoTo sProccessBufferErr 'EHCG.UID.sProccessBuffer

Dim lsParseableCommand As String

Dim lsClientMAC As String, lsClientIP As String, lsClientName As String, lsClientCommand As String

    Do
    If InStr(gsCommBuffer, vbCrLf) = 0 Then Exit Do

    gsCommBuffer = StripLine(gsCommBuffer, vbCrLf, lsParseableCommand)

    lsClientMAC = ParseDataBlock(lsParseableCommand, 0, "|")
    lsClientIP = ParseDataBlock(lsParseableCommand, 1, "|")
    lsClientName = ParseDataBlock(lsParseableCommand, 2, "|")
    lsClientCommand = Right$(lsParseableCommand, Len(lsParseableCommand) - (Len(lsClientIP & lsClientName & lsClientMAC) + 3))

    Call ExecuteClientCommand(lsClientMAC, lsClientIP, lsClientName, lsClientCommand)

    Loop

Exit Sub
sProccessBufferErr:
Err.Raise Err.number, Err.Source, "s.ProccessBuffer:" & vbCrLf & "Error: " & Err.number & vbCrLf & "Description: " & Err.Description & vbCrLf, Err.HelpFile, Err.HelpContext

End Sub
Function SendBroadcast(ByVal psInfo As String) As Boolean
On Error GoTo fSendBroadcastErr 'EHCG.UID.fSendBroadcast

SendBroadcast = Send("255.255.255.255", psInfo) 'Setando o IP para broadcast local.

Exit Function
fSendBroadcastErr:
Err.Raise Err.number, Err.Source, "f.SendBroadcast:" & vbCrLf & "Error: " & Err.number & vbCrLf & "Description: " & Err.Description & vbCrLf, Err.HelpFile, Err.HelpContext

End Function
Function Send(ByVal psIP As String, ByVal psInfoAll As String) As Boolean
On Error Resume Next 'EHCG.UID.fSend
Dim uHeader As String, psInfo As String

    Do
    psInfoAll = StripLine(psInfoAll, vbCrLf, psInfo)
    
        If psInfoAll = "" And psInfo = "" Then Exit Do
    
    
        With frmComm.wskPort
        uHeader = lStrMAC & "|" & .LocalIP & "|" & .LocalHostName & "|"
        .RemotePort = 81 'Ajustando a porta remota para a Listening port dos clientes Neuron
        .RemoteHost = psIP 'Identifica especificamente um IP.
        .SendData uHeader & psInfo & vbCrLf
        
        frmComm.Sent
        
            If Data.MainInterfaceLoaded Then MDIMain.mcfMain.Caption = Format$(Now, "YYYY.MM.DD.HH.NN.SS") & " SENT to " & psIP & ": " & psInfo
        
        AddToCommLog "Server [" & IIf(.RemoteHost = "255.255.255.255", "Broadcast", "to " & .RemoteHost) & "]: " & psInfo
         
        Debug.Print "SEND: " & .RemoteHost & ", " & uHeader & psInfo
        If Data.Log Then SysLog "SEND: " & .RemoteHost & ", " & uHeader & psInfo
        End With
    
    Loop

Exit Function
fSendErr:
Err.Raise Err.number, Err.Source, "f.Send:" & vbCrLf & "Error: " & Err.number & vbCrLf & "Description: " & Err.Description & vbCrLf, Err.HelpFile, Err.HelpContext

End Function
Function SendMagicPacket(ByVal uMac As String) As Boolean
On Error GoTo fSendErr 'EHCG.UID.fSend

Dim uMACParse As String

uMACParse = Chr$(Val("&H" & ParseDataBlock(uMac, 0, "-"))) & _
Chr$(Val("&H" & ParseDataBlock(uMac, 1, "-"))) & _
Chr$(Val("&H" & ParseDataBlock(uMac, 2, "-"))) & _
Chr$(Val("&H" & ParseDataBlock(uMac, 3, "-"))) & _
Chr$(Val("&H" & ParseDataBlock(uMac, 4, "-"))) & _
Chr$(Val("&H" & ParseDataBlock(uMac, 5, "-")))

    With frmComm.wskPort
    .RemotePort = 81 'Ajustando a porta remota para a Listening port dos clientes Neuron
    .RemoteHost = "255.255.255.255"
    .SendData String$(6, Chr$(255)) & uMACParse & uMACParse & uMACParse & uMACParse & uMACParse & uMACParse & uMACParse & uMACParse & uMACParse & uMACParse & uMACParse & uMACParse & uMACParse & uMACParse & uMACParse & uMACParse
    End With
    
Exit Function
fSendErr:
Err.Raise Err.number, Err.Source, "f.Send:" & vbCrLf & "Error: " & Err.number & vbCrLf & "Description: " & Err.Description & vbCrLf, Err.HelpFile, Err.HelpContext

End Function
Function ExecuteClientCommand(ByVal lsClientMAC As String, ByVal lsClientIP As String, ByVal lsClientName As String, ByVal lsClientCommand As String) As Boolean
On Error GoTo fExecuteClientCommandErr 'EHCG.UID.fExecuteClientCommand

Dim uSQL As String, uRS As Recordset, uTmpStr As String, uTmpValue As String

Call CheckMachineReg(lsClientMAC, lsClientIP, lsClientName)

Debug.Print lsClientIP & "|" & lsClientCommand

AddToCommLog "[" & lsClientName & "]: " & lsClientCommand

    Select Case ParseDataBlock(lsClientCommand, 0, "|")
    Case "SERVERINFO"
    Send lsClientIP, "SERVERINFO|" & frmComm.wskPort.LocalHostName
    
    Dim uM As Machine, uMS As Machine_Status
    Set uM = Data.Machines.Item(lsClientMAC)

            If TypeName(Data.Machine_Statuses.SeekMachine(Data.Machines.Item(lsClientMAC)).User) = "Nothing" Then
            
                If Data.Settings.LockEvent <> Interface Then Send lsClientIP, "LOCK"
            
            Else
            Send lsClientIP, "USERINFO|" & Data.Machine_Statuses.SeekMachine(Data.Machines.Item(lsClientMAC)).User.Alias
            
            End If

    Send lsClientIP, "SETRESOLUTION|1280|1024|32"
    Send lsClientIP, "SCHEDULE|" & Data.Settings.ICAEventPeriodClient & "|PING?"
    Send lsClientIP, "SAY|Conectado ao servidor " & frmComm.wskPort.LocalHostName & "."

    Case "PONG!"
    uTmpStr = Data.Machines.Item(lsClientMAC).Status
    uTmpValue = Val(IIf(ParseDataBlock(lsClientCommand, 1, "|") <> "", ParseDataBlock(lsClientCommand, 1, "|"), 4)) - 1
    Data.Machines.Item(lsClientMAC).Status = uTmpValue
    
        If uTmpStr <> uTmpValue Then If Data.MachineListLoaded Then frmMachines.UpdateItem lsClientMAC

    Case "OFF"

        If Data.MachineListLoaded Then
        Data.Machines.Item(lsClientMAC).Status = MSDisconnected
        End If

    Case "QUERYID"
    uTmpStr = Data.Machines.Item(lsClientMAC).Sign
    uTmpValue = ParseDataBlock(lsClientCommand, 1, "|")
    Data.Machines.Item(lsClientMAC).Sign = uTmpValue
        
        If uTmpStr <> uTmpValue Then If Data.MachineListLoaded Then frmMachines.UpdateItem lsClientMAC
        
    End Select

Exit Function
fExecuteClientCommandErr:
Err.Raise Err.number, Err.Source, "f.ExecuteClientCommand:" & vbCrLf & "Error: " & Err.number & vbCrLf & "Description: " & Err.Description & vbCrLf, Err.HelpFile, Err.HelpContext

End Function
Sub CheckMachineReg(ByVal lsClientMAC As String, ByVal lsClientIP As String, ByVal lsClientName As String)
On Error GoTo sPopulateMachineDBErr 'EHCG.UID.sPopulateMachineDB
Dim uMachine As Machine, lbolUpdate As Boolean, nMachine As New Machine, nMachine_status As New Machine_Status
    
    If lsClientMAC = "" Then Exit Sub

Set uMachine = Data.Machines.Item(lsClientMAC)

    If TypeName(uMachine) = "Nothing" Then
    nMachine.OnParse = True
    nMachine.Macaddress = lsClientMAC
    nMachine.Ipaddress = lsClientIP
    nMachine.Netname = lsClientName
    nMachine.OnParse = False
    
    Data.Machines.Add nMachine
      
    lbolUpdate = True
    
    Else
    
    
        If uMachine.Ipaddress <> lsClientIP Or uMachine.Netname <> lsClientName Then
        uMachine.Ipaddress = lsClientIP
        uMachine.Netname = lsClientName
        lbolUpdate = True
        End If
    
    End If

    If TypeName(Data.Machine_Statuses.SeekMachine(Data.Machines.Item(lsClientMAC))) = "Nothing" Then
        
        With nMachine_status
        .OnParse = True
        Set .Machine = Data.Machines.Item(lsClientMAC)
        .lastchange = Now
        .OnParse = False
        End With
        
    Data.Machine_Statuses.Add nMachine_status
    
    End If


    If lbolUpdate Then If Data.MachineListLoaded Then frmMachines.UpdateItem lsClientMAC

Exit Sub
sPopulateMachineDBErr:
Err.Raise Err.number, Err.Source, "s.PopulateMachineDB:" & vbCrLf & "Error: " & Err.number & vbCrLf & "Description: " & Err.Description & vbCrLf, Err.HelpFile, Err.HelpContext

End Sub
Function GetIP(ByVal lsClientMAC As String) As String
On Error GoTo fGetIPErr 'EHCG.UID.fGetIP

Dim lSQL As String, lRS As Recordset

    If lsClientMAC = "" Then Exit Function

lSQL = "SELECT [IPAddress] FROM [machine] WHERE [MACAddress] = '" & lsClientMAC & "'"
Set lRS = Data.Database.Execute(lSQL)

    If Not lRS.EOF Then
    GetIP = lRS(0)
    End If

Exit Function
fGetIPErr:
Err.Raise Err.number, Err.Source, "f.GetIP:" & vbCrLf & "Error: " & Err.number & vbCrLf & "Description: " & Err.Description & vbCrLf, Err.HelpFile, Err.HelpContext

End Function
Function GetMachineID(ByVal lsClientMAC As String) As String
On Error GoTo fGetMachineIDErr 'EHCG.UID.fGetMachineID

Dim lSQL As String, lRS As Recordset

    If lsClientMAC = "" Then Exit Function

lSQL = "SELECT [ID] FROM [machine] WHERE [MACAddress] = '" & lsClientMAC & "'"
Set lRS = Data.Database.Execute(lSQL)

    If Not lRS.EOF Then
    GetMachineID = lRS(0)
    End If

Exit Function
fGetMachineIDErr:
Err.Raise Err.number, Err.Source, "f.GetMachineID:" & vbCrLf & "Error: " & Err.number & vbCrLf & "Description: " & Err.Description & vbCrLf, Err.HelpFile, Err.HelpContext

End Function
Sub DoAction(ByVal parm As String)
On Error GoTo sDoActionErr 'EHCG.UID.sDoAction

SendBroadcast parm

Exit Sub
sDoActionErr:
Err.Raise Err.number, Err.Source, "s.DoAction:" & vbCrLf & "Error: " & Err.number & vbCrLf & "Description: " & Err.Description & vbCrLf, Err.HelpFile, Err.HelpContext

End Sub
Function GetMDIForm() As MDIForm
Set GetMDIForm = MDIMain
End Function
Function MachineStatusText(ByVal uValue As Long) As String

    Select Case uValue
    Case 0: MachineStatusText = "N/D"
    Case 1: MachineStatusText = "FileSync"
    Case 2: MachineStatusText = "Erro"
    Case 3: MachineStatusText = "Aberta"
    Case 4: MachineStatusText = "Fechada"
    End Select

End Function
Sub CopyFileToAllMachines(ByVal uFile As String, uDestiny As String)
Dim u As ListItem, ConnString As String

    For Each u In frmMachines.lstItems.ListItems
            
        If u.SmallIcon <> 1 Then
        ConnString = IIf(ConnString <> "", "N", "D") & ":" & GetIP(u.Key) & ":11000" & IIf(ConnString <> "", "|", "") & ConnString
        End If
            
    Next u

    
    If ConnString <> "" Then
    MDIMain.ccpServer.TransferFile uFile, uDestiny, ConnString, 8192
    End If

End Sub
Sub RegMachineEvent(ByVal MachineMAC As String)
Dim uRS As Recordset, uMS As Machine_Status, uMSU As User, uMSM As Machine, MachineID As Long, UserID As Long, StatusID As u_MachineStatus

    If MachineMAC = "" Then Exit Sub

Set uMSM = Data.Machines.Item(MachineMAC): MachineID = uMSM.ID: If TypeName(uMSM) <> "Nothing" Then StatusID = uMSM.Status
Set uMS = Data.Machine_Statuses.SeekMachine(uMSM)
    
    If TypeName(Data.Machine_Statuses.SeekMachine(uMSM)) <> "Nothing" Then
    Set uMS = Data.Machine_Statuses.SeekMachine(uMSM)
    
        If TypeName(uMS.User) <> "Nothing" Then
        Set uMSU = uMS.User
        UserID = uMSU.ID
        End If
    
    End If

    If MachineID = 0 Then Exit Sub

Set uRS = Data.Database.Execute("SELECT [ID], [machineID], [userID], [machine_log_typeID], [EventInit], [EventEnd] FROM [machine_log] WHERE [machineID]=" & uMSM.ID & " AND [EventEnd] is null")

    If Not uRS.EOF Then 'No  o primeiro registro desta mquina, ou no foram corretamente fechados.
    
        Do While Not uRS.EOF
        
            If DateAdd("s", 5, uRS("EventInit")) > Now() Then  'o evento foi a apenas 5 segundos. exclu-lo.
            Data.Database.Execute "DELETE FROM [machine_log] WHERE ID=" & uRS("ID")
            
            Else
            Data.Database.Execute "UPDATE [machine_log] SET [EventEnd]=" & SQLDate(Now) & " WHERE ID=" & uRS("ID")
            
            End If
            
        uRS.MoveNext
        Loop
    
    End If
    
    If StatusID = MSDisconnected And UserID = 0 Then Exit Sub 'Desconectado, e sem usurio. Nada a fazer.
    
    If StatusID = MSOnUse And UserID = 0 Then 'Mquina aberta, sem usurio.
    Data.Database.Execute "INSERT INTO [machine_log] ([machineID], [machine_log_typeID], [EventInit]) VALUES (" & MachineID & ", 2, " & SQLDate(Now) & ")"
    
    ElseIf StatusID = MSOnUse And UserID <> 0 Then 'Mquina aberta, com usurio.
    Data.Database.Execute "INSERT INTO [machine_log] ([machineID], [UserID], [machine_log_typeID], [EventInit]) VALUES (" & MachineID & ", " & UserID & ", 1, " & SQLDate(Now) & ")"
    
    End If

End Sub
Sub RemoveUserFromQueue(ByVal uId As Long, ByVal pProcessed As Boolean)
Data.Database.Execute "UPDATE [Shop_queue] SET [ServiceDT]=" & SQLDate(Now) & ", [Processed]=" & IIf(pProcessed, "true", "false") & " WHERE UserID=" & uId & " AND [ServiceDT] is Null"
MDIMain.LoadQueueList
End Sub
Function ChainCopyObtainConnectionScript() As String
Dim uMac As Machine, Counter As Long, ConnString As String

    For Counter = 1 To Data.Machines.Count
    Set uMac = Data.Machines.Item(Counter)
            
        If uMac.Status <> MSDisconnected And uMac.Status <> MSReceivingFile Then
        ConnString = IIf(ConnString <> "", "N", "D") & ":" & uMac.Ipaddress & ":11000" & IIf(ConnString <> "", "|", "") & ConnString
        End If
            
    Next Counter

ChainCopyObtainConnectionScript = ConnString

End Function
Function CheckMachineStatusReg(ByVal uReg As Machine)
Dim uTempStatus As New Machine_Status

        If TypeName(Data.Machine_Statuses.SeekMachine(uReg)) = "Nothing" Then 'Ainda no existe a meno do equipamento em Machine_Statuses.
        
        uTempStatus.OnParse = True
        Set uTempStatus.Machine = uReg
        uTempStatus.lastchange = Now
        uTempStatus.OnParse = False
        
        Data.Machine_Statuses.Add uTempStatus
        Set uTempStatus = Nothing
        End If

End Function
Sub Main()
Dim uFSO As New FileSystemObject

    If Not uFSO.FolderExists(".\Language") Then
    Shell ".\Language.exe"
    End
    End If
    

Call InitializeInstanceIdentifier
Data.Development = GetSetting(App.ProductName, "Main", "Development", False)

'Hard-Coded Vars, for future Config.
Data.StatusMessageTime = 10
    
    If Not Data.Development Then
    CenterForm frmSplash
    frmSplash.Visible = True
    OnTop frmSplash, True
    End If
    
Call StartupSequence
MDIMain.Visible = True
frmComm.Visible = True
OnTop frmComm, True

    If Not Data.Development Then
    Unload frmSplash
    End If

End Sub
Sub StartupSequence()
On Error GoTo sStartupSequenceErr 'EHCG.UID.sStartupSequence
Dim uTime As Long
'Carregar lista de usuarios e equipamentos

uTime = GetTickCount

    Do
    DoEvents
    
        If frmComm.wskPort.LocalIP <> "127.0.0.1" Then Exit Do
        
        If GetTickCount + 10000 > uTime Then
        Exit Do
        End If
    
    Loop

lStrMAC = GetMACAddress

Call LoadRegistrySettings
Call ConnectDatabase
SendBroadcast "SERVERINFO|" & frmComm.wskPort.LocalHostName
SendBroadcast "SCHEDULE|" & Data.Settings.ICAEventPeriodClient & "|PING?"

Exit Sub
sStartupSequenceErr:
Err.Raise Err.number, Err.Source, "s.StartupSequence:" & vbCrLf & "Error: " & Err.number & vbCrLf & "Description: " & Err.Description & vbCrLf, Err.HelpFile, Err.HelpContext

End Sub
Sub LoadRegistrySettings()
Data.Settings.PingBeaconUse = GetSetting(App.ProductName, "Settings", "PingBeaconUse", False)
Data.Settings.AutoUpdateNeuron = GetSetting(App.ProductName, "Settings", "AutoUpdateNeuron", True)
Data.Settings.DebugModeUse = GetSetting(App.ProductName, "Settings", "DebugModeUse", False)
Data.Settings.RemoteLogon = GetSetting(App.ProductName, "Settings", "RemoteLogon", False)
Data.Settings.TimerOverWarning = GetSetting(App.ProductName, "Settings", "TimerOverWarning", True)
Data.Settings.TimeOverAutoKickUse = GetSetting(App.ProductName, "Settings", "TimeOverAutoKickUse", True)
Data.Settings.PingBeaconPeriod = GetSetting(App.ProductName, "Settings", "PingBeaconPeriod", 10000)
Data.Settings.ICAEventPeriod = GetSetting(App.ProductName, "Settings", "ICAEventPeriod", 15000)
Data.Settings.ICAEventPeriodClient = GetSetting(App.ProductName, "Settings", "ICAEventPeriodClient", 5000)
Data.Settings.LockEvent = GetSetting(App.ProductName, "Settings", "LockEvent", 1)
Data.Settings.DebugMode = GetSetting(App.ProductName, "Settings", "DebugMode", 0)
Data.Settings.TimeOverAutoKickPeriod = GetSetting(App.ProductName, "Settings", "TimeOverAutoKickPeriod", 300000)
Data.LanguagePack = GetSetting(App.ProductName, "Language", "Package", "US-EN")

Call LoadLanguagePack

End Sub
Sub KickUser(uItem As String)
Dim uMS As Machine_Status
Set uMS = Data.Machine_Statuses.SeekMachine(Data.Machines.Item(uItem))

    If TypeName(uMS) = "Nothing" Then Exit Sub
    If TypeName(uMS.User) = "Nothing" Then Exit Sub
    
Set uMS.User = Nothing
uMS.user_endTime = "00:00"
uMS.user_initTime = "00:00"

    If Data.MachineListLoaded Then frmMachines.UpdateItem uItem

Send Data.Machines.Item(uItem).Ipaddress, "KILLPROCESS|HL.EXE"
Send Data.Machines.Item(uItem).Ipaddress, "KILLPROCESS|UNREAL"
Send Data.Machines.Item(uItem).Ipaddress, "KILLPROCESS|WAR"
Send Data.Machines.Item(uItem).Ipaddress, "PING?"

End Sub
Sub AddToCommLog(ByVal uText As String)
Dim uLine As String, uOrigin As String

uOrigin = uText

    Do
    uOrigin = StripLine(uOrigin, vbCrLf, uLine)
    
        If uLine = "" And uOrigin = "" Then Exit Do
    
    frmComm.lstIn.AddItem " " & UCase(uLine)
    frmComm.lstIn.Selected(frmComm.lstIn.ListCount - 1) = True
    frmComm.lstIn.Selected(frmComm.lstIn.ListCount - 1) = False
    
        If frmComm.lstIn.ListCount > 100 Then
        frmComm.lstIn.RemoveItem 0
        End If
    
    Loop

End Sub
Sub Status(ByVal uText As String, Optional uType As uStatusType)

    With MDIMain
    
        Select Case uType
        Case uStatusType.uSTNormal
        Set .imgStatusIcon.Picture = .imgStLib(0).Picture
        .lblStatus(0) = ""
        .lblStatus(1) = uText
        
        Case uStatusType.uSTMessage
        Set .imgStatusIcon.Picture = .imgStLib(1).Picture
        .lblStatus(0).ForeColor = &HFFA0A0
        .lblStatus(0) = "Mensagem:"
        .lblStatus(1) = uText
        
        Case uStatusType.uSTSuccess
        Set .imgStatusIcon.Picture = .imgStLib(2).Picture
        .lblStatus(0).ForeColor = &HA0FFA0
        .lblStatus(0) = "Sucesso!"
        .lblStatus(1) = uText
        
        Case uStatusType.uSTError
        Set .imgStatusIcon.Picture = .imgStLib(3).Picture
        .lblStatus(0) = "Erro!"
        .lblStatus(0).ForeColor = &HA0A0FF
        .lblStatus(1) = uText
    
        End Select
        
    End With

Data.StatusMessageTimeLeft = Data.StatusMessageTime
Data.StatusMessageDisplayed = True

End Sub
Sub ScanFormCaptions(uForm As Form)
On Error GoTo sScanFormCaptionsErr 'EHCG.UID.sScanFormCaptions

Dim uFSO As New FileSystemObject, lControl As Control, uFile As TextStream

    If Not uFSO.FolderExists(".\Language") Then uFSO.CreateFolder ".\Language"
    If Not uFSO.FolderExists(".\Language\" & Data.LanguagePack) Then uFSO.CreateFolder ".\Language\" & Data.LanguagePack

Set uFile = uFSO.CreateTextFile(".\Language\" & Data.LanguagePack & "\" & uForm.Name & ".txt", True, True)

Dim lStrName As String, lStrIndex As String, lStrCaption As String, lStrTag As String, lStrText As String, lStrContents As String, lIntCounter As Integer

uFile.WriteLine "' " & App.ProductName & " " & App.Major & "." & App.Minor & ".R" & App.Revision & " External language resource file."

uFile.WriteLine "[Form]"
uFile.WriteLine vbTab & "Caption: " & uForm.Caption

    For Each lControl In uForm.Controls
    lStrName = "": lStrIndex = "": lStrCaption = "": lStrTag = "": lStrText = "": lStrContents = ""
    
        With lControl
        lStrName = .Name: lStrIndex = .Index: lStrCaption = .Caption: lStrTag = .Tag: lStrText = .Text
        
            If TypeOf lControl Is ListBox Then
            
                For lIntCounter = 0 To .ListCount - 1
                    If lStrContents <> "" Then lStrContents = lStrContents & "|"
                lStrContents = lStrContents & .ItemData(lIntCounter) & "|" & .List(lIntCounter)
                Next lIntCounter
                
            ElseIf TypeOf lControl Is ListView Then
            
                For lIntCounter = 1 To .ColumnHeaders.Count
                    If lStrContents <> "" Then lStrContents = lStrContents & "|"
                lStrContents = lStrContents & .ColumnHeaders(lIntCounter).Key & "|" & .ColumnHeaders(lIntCounter).Text
                Next lIntCounter
            
            End If
            
            If Trim(lStrCaption & lStrTag & lStrText & lStrContents) <> "" Then

            uFile.Write lStrName & IIf(lStrIndex <> "", "(" & lStrIndex & ")", "") & vbCrLf
            
                If lStrCaption <> "" Then uFile.WriteLine vbTab & "Caption: " & lStrCaption
                If lStrTag <> "" Then uFile.WriteLine vbTab & "Tag: " & lStrTag
                If lStrText <> "" Then uFile.WriteLine vbTab & "Text: " & lStrText
                If lStrContents <> "" Then uFile.WriteLine vbTab & "Contents: " & lStrContents
                
            End If
        
        End With

    Next lControl

Exit Sub

sScanFormCaptionsErr:

    If Err.number = 343 Then Resume Next
    If Err.number = 438 Then Resume Next
    
Err.Raise Err.number, Err.Source, "s.ScanFormCaptions (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Sub ScanAllForms()
ScanFormCaptions frmComm
ScanFormCaptions frmConfig
ScanFormCaptions frmMachines
ScanFormCaptions frmMoneyQuery
ScanFormCaptions frmSplash
ScanFormCaptions frmUsers
ScanFormCaptions MDIMain
End Sub
Sub LoadLanguagePack()
Dim uFSO As New FileSystemObject, lClsForm As New LangForm, lclsControl As New LangControl, lObjFile As File, lobjfolder As Folder, lObjStream As TextStream
Dim lStrtemp As String, lStrControl As String
Dim lStrPiece As String
Dim lClsLCtls As New LangControls
Dim lClsFormDef As New LangControl
Dim lFieldContent As String

Set Data.Language = Nothing

    If Not uFSO.FolderExists(".\Language\" & Data.LanguagePack) Then Exit Sub
    
Set lobjfolder = uFSO.GetFolder(".\Language\" & Data.LanguagePack)
    
    For Each lObjFile In lobjfolder.Files
    
        If UCase(Right$(lObjFile.Name, 4)) = ".TXT" Then 'arquivo de definio de Linguagem.
        Set lObjStream = lObjFile.OpenAsTextStream(ForReading, TristateTrue)
        
            Do
            lStrtemp = lObjStream.ReadLine
            
                If Left$(lStrtemp, 1) = "'" Or lStrtemp = "" Then
                'Apenas ignorar a linha.
                
                ElseIf Left$(lStrtemp, 1) = vbTab Then 'Uma propriedade qualquer.
                lStrtemp = Right$(lStrtemp, Len(lStrtemp) - 1)
                lStrPiece = ParseDataBlock(lStrtemp, 0, ":")
                lFieldContent = Right$(lStrtemp, Len(lStrtemp) - Len(lStrPiece & ": "))
                
                    lFieldContent = Replace$(lFieldContent, "%MAJOR%", Format$(App.Major, "00"))
                    lFieldContent = Replace$(lFieldContent, "%MINOR%", Format$(App.Minor, "00"))
                    lFieldContent = Replace$(lFieldContent, "%REVISION%", Format$(App.Revision, "00"))
                
                    Select Case lStrPiece
                    Case "Caption"
                    lclsControl.ctlCaption = lFieldContent
                    Case "Name"
                    lclsControl.ctlName = lFieldContent
                    Case "Text"
                    lclsControl.ctlText = lFieldContent
                    Case "Tag"
                    lclsControl.ctlTag = lFieldContent
                    Case "Contents"
                    lclsControl.ctlContents = lFieldContent
                    End Select
                
                Else 'O nome de um controle.
                
                    If lclsControl.ctlName <> "" Then
                    
                        If lclsControl.ctlName = "[Form]" Then 'Definies do prprio formulrio.
                        Set lClsFormDef = lclsControl
                        lClsFormDef.ctlName = Left$(lObjFile.Name, Len(lObjFile.Name) - 4)
                        
                        Else
                        
                            With lclsControl
                            lClsLCtls.Add .ctlCaption, .ctlTag, .ctlText, .ctlName, .ctlContents, .ctlIndex, .ctlName & IIf(.ctlIndex <> "", "(" & .ctlIndex & ")", "")
                            Set lclsControl = Nothing
                            End With
                        
                        End If
                    
                    End If
                
                lStrControl = lStrtemp
                Set lclsControl = Nothing
                lclsControl.ctlName = lStrtemp
                
                    If InStr(lStrControl, "(") <> 0 Then
                    lclsControl.ctlIndex = Val(Right$(lStrControl, Len(lStrControl) - InStr(lStrControl, "(")))
                    lclsControl.ctlName = Left$(lStrControl, InStr(lStrControl, "(") - 1)
                    End If
                
                End If
                
            If lObjStream.AtEndOfStream Then Exit Do
            
            Loop
        
            If lclsControl.ctlName <> "" Then
            
                If lclsControl.ctlName = "[Form]" Then 'Definies do prprio formulrio.
                Set lClsFormDef = lclsControl
                lClsFormDef.ctlName = Left$(lObjFile.Name, Len(lObjFile.Name) - 4)
                
                Else
                
                    With lclsControl
                    lClsLCtls.Add .ctlCaption, .ctlTag, .ctlText, .ctlName, .ctlContents, .ctlIndex, .ctlName & IIf(.ctlIndex <> "", "(" & .ctlIndex & ")", "")
                    Set lclsControl = Nothing
                    End With
                
                End If
            
            End If
        
        End If
        
    Data.Language.Add lClsLCtls, lClsFormDef.ctlName, lClsFormDef.ctlCaption, lClsFormDef.ctlName
    Set lClsLCtls = Nothing
    Set lClsFormDef = Nothing
        
    lObjStream.Close
    Next lObjFile

Data.LanguageLoaded = True

End Sub
